
$TeamDeployableMax[TacMechPack] = 10;      // How many mechs per map is each team allowed?
$TacMech::Health = 10;
//enableTacMechUsage();

function TacMechMountWeapons(%obj)
{
   %obj.setInventory(AutoCannon, 1);
   %obj.setInventory(AutoCannonAmmo, 1000);
   %obj.setInventory(Reaver, 1);
   %obj.setInventory(ReaverAmmo, 1000);
   %obj.setInventory(Starburst, 1);
   %obj.setInventory(StarburstAmmo, 1000);
   %obj.setInventory(EnergyRifle, 1);
   %obj.setInventory(EnergyRifleAmmo, 1000);
//   %obj.setInventory(Mortar, 1);
//   %obj.setInventory(MortarAmmo, 1000);
   %obj.setInventory(Disc, 1);
   %obj.setInventory(DiscAmmo, 1000);
   %obj.setInventory(Chaingun, 1);
   %obj.setInventory(ChaingunAmmo, 1000);
   %obj.setInventory(Chaingun, 1);
   %obj.setInventory(ChaingunAmmo, 1000);
   %obj.setInventory(RAXX, 1);
   %obj.setInventory(RAXXAmmo, 1500);

   %obj.setInventory(StarHammerPack, 1);

   %obj.use("Disc");
}

datablock TSShapeConstructor(TR2HeavyMaleDts)
{
   baseShape = "TR2heavy_male.dts";
   sequence0 = "TR2heavy_male_root.dsq root";
   sequence1 = "TR2heavy_male_forward.dsq run";
   sequence2 = "TR2heavy_male_back.dsq back";
   sequence3 = "TR2heavy_male_side.dsq side";
   sequence4 = "heavy_male_lookde.dsq look";
   sequence5 = "heavy_male_head.dsq head";
   sequence6 = "TR2heavy_male_fall.dsq fall";
   sequence7 = "TR2heavy_male_jet.dsq jet";
   sequence8 = "TR2heavy_male_land.dsq land";
   sequence9 = "TR2heavy_male_jump.dsq jump";
   sequence10 = "heavy_male_recoilde.dsq light_recoil";
   sequence11 = "heavy_male_idlepda.dsq pda";
   sequence12 = "heavy_male_headside.dsq headside";
   sequence13 = "heavy_male_lookms.dsq lookms";
   sequence14 = "TR2heavy_male_diehead.dsq death1";
   sequence15 = "TR2heavy_male_diechest.dsq death2";
   sequence16 = "TR2heavy_male_dieback.dsq death3";
   sequence17 = "TR2heavy_male_diesidelf.dsq death4";
   sequence18 = "TR2heavy_male_diesidert.dsq death5";
   sequence19 = "TR2heavy_male_dieforward.dsq death6";      // heavy_male_dieleglf
   sequence20 = "TR2heavy_male_diechest.dsq death7";        // heavy_male_dielegrt
   sequence21 = "TR2heavy_male_dieslump.dsq death8";
   sequence22 = "TR2heavy_male_dieforward.dsq death9";      // heavy_male_dieknees
   sequence23 = "TR2heavy_male_dieforward.dsq death10";
   sequence24 = "TR2heavy_male_diespin.dsq death11";
   sequence25 = "TR2heavy_male_celsalute.dsq cel1";
   sequence26 = "TR2heavy_male_celwave.dsq cel2";
   sequence27 = "TR2heavy_male_tauntbest.dsq cel3";
   sequence28 = "TR2heavy_male_tauntimp.dsq cel4";
   sequence29 = "TR2heavy_male_celdance.dsq cel5";
   sequence30 = "TR2heavy_male_celflex.dsq cel6";
   sequence31 = "TR2heavy_male_celtaunt.dsq cel7";
   sequence32 = "TR2heavy_male_celjump.dsq cel8";
   sequence33 = "TR2heavy_male_ski.dsq ski";
   sequence34 = "TR2heavy_male_standjump.dsq standjump";
   sequence35 = "heavy_male_looknw.dsq looknw";
};

datablock ShockwaveData(TacMechShockwave)
{
   width = 36.0;
   numSegments = 32;
   numVertSegments = 6;
   velocity = 90;
   acceleration = -30;
   lifetimeMS = 3000;
   height = 4.0;
   verticalCurve = 0.5;
   is2D = false;

   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.9 0.8 0.1 0.5";
   colors[1] = "0.9 0.8 0.1 0.8";
   colors[2] = "1.0 1.0 1.0 0.0";

   mapToTerrain = false;
   orientToNormal = true;
   renderBottom = true;
};

datablock SimDataBlock(MechDamageProfile)
{
   damageScale[$DamageType::Blaster] = 0.5;
   damageScale[$DamageType::Bullet] = 0.3;
   damageScale[$DamageType::ELF] = 1.5;
   damageScale[$DamageType::ShockLance] = 1.0;
   damageScale[$DamageType::Laser] = 2.5;
   damageScale[$DamageType::ShrikeBlaster] = 0.75;
   damageScale[$DamageType::BellyTurret] = 1.0;
   damageScale[$DamageType::AATurret] = 0.7;
   damageScale[$DamageType::IndoorDepTurret] = 0.2;
   damageScale[$DamageType::OutdoorDepTurret] = 2.14;
   damageScale[$DamageType::SentryTurret] = 0.5;
   damageScale[$DamageType::Disc] = 1.6;
   damageScale[$DamageType::Grenade] = 0.2;
   damageScale[$DamageType::Mine] = 0.1;
   damageScale[$DamageType::Missile] = 1.2345;
   damageScale[$DamageType::Mortar] = 1.3;
   damageScale[$DamageType::Plasma] = 0.25;
   damageScale[$DamageType::BomberBombs] = 3.0;
   damageScale[$DamageType::TankChaingun] = 1.25;
   damageScale[$DamageType::TankMortar] = 1.8;
   damageScale[$DamageType::MissileTurret] = 2.0;
   damageScale[$DamageType::MortarTurret] = 1.6;
   damageScale[$DamageType::PlasmaTurret] = 1.0;
   damageScale[$DamageType::SatchelCharge] = 0.5;
   damageScale[$DamageType::Default] = 1.0;
   damageScale[$DamageType::Impact] = 0.2;
   damageScale[$DamageType::Ground] = 0.2;
   damageScale[$DamageType::Explosion] = 1.0;
   damageScale[$DamageType::Lightning]	= 9.0;

   damageScale[$DamageType::BTMine] 		= 0.3;
   shieldDamageScale[$DamageType::BTMine] = 0.3;
   damageScale[$DamageType::MB] 			= 2.0;
   shieldDamageScale[$DamageType::MB] 		= 2.0;
   damageScale[$DamageType::PBW] 			= 2.0;
   shieldDamageScale[$DamageType::PBW] 		= 4.0;
   damageScale[$DamageType::Phaser] 		= 1.0;
   shieldDamageScale[$DamageType::Phaser] 	= 1.0;
   damageScale[$DamageType::Sniper] 		= 0.1;
   shieldDamageScale[$DamageType::Sniper] 	= 0.1;
   damageScale[$DamageType::ElectroMissile] 		= 0.1;
   shieldDamageScale[$DamageType::ElectroMissile] 	= 0.1;
   damageScale[$DamageType::PWT] 			= 3.0;
   shieldDamageScale[$DamageType::PWT] 		= 3.0;
   damageScale[$DamageType::Disruptor] 		= 1.0;
   shieldDamageScale[$DamageType::Disruptor] 	= 1.0;
   damageScale[$DamageType::EnergyBlast] 		= 1.0;
   shieldDamageScale[$DamageType::EnergyBlast] 	= 1.0;
   damageScale[$DamageType::Nuke] 		= 2.0;
   shieldDamageScale[$DamageType::Nuke] 	= 2.0;
   damageScale[$DamageType::Gauss] 		= 0.9;
   shieldDamageScale[$DamageType::Gauss] 	= 1.0;
   damageScale[$DamageType::Annihalator] 	= 0.25;
   shieldDamageScale[$DamageType::Annihalator]= 0.125;
   damageScale[$DamageType::EMP]    		= 0.0;
   shieldDamageScale[$DamageType::EMP] 	     = 0.0;
   damageScale[$DamageType::Burn] 		     = 0.0;
   shieldDamageScale[$DamageType::Burn] 	= 0.0;
   damageScale[$DamageType::Poison] 		= 0.0;
   shieldDamageScale[$DamageType::Poison] 	= 0.0;
   damageScale[$DamageType::MitziTransparent] 		     = 10.0;
   shieldDamageScale[$DamageType::MitziTransparent] 	     = 10.0;
   damageScale[$DamageType::PoisonLoop] 		= 0.5;
   shieldDamageScale[$DamageType::PoisonLoop] 	= 0.0;
   damageScale[$DamageType::BlueBlaster] 		= 1.0;
   shieldDamageScale[$DamageType::BlueBlaster] 	= 1.0;
   damageScale[$DamageType::BurnLoop] 		= 0.5;
   shieldDamageScale[$DamageType::BurnLoop] 	= 0.0;
   damageScale[$DamageType::Flak] 		= 0.125;
   shieldDamageScale[$DamageType::Flak] 	= 0.125;
   damageScale[$DamageType::Protron] 		= 1.0;
   shieldDamageScale[$DamageType::Protron] 	= 1.0;
   damageScale[$DamageType::Ecstacy] 		= 0.1;
   shieldDamageScale[$DamageType::Ecstacy] 	= 0.1;
   damageScale[$DamageType::AssaultR] 		= 0.5;
   shieldDamageScale[$DamageType::AssaultR] 	= 0.5;
   damageScale[$DamageType::Shotgun] 		= 0.1;
   shieldDamageScale[$DamageType::Shotgun] 	= 0.1;
};

datablock StaticShapeData(StaticTacMech) : MechDamageProfile
{
   shapeFile = "TR2heavy_male.dts";   // TR2HeavyMale
   maxDamage = $TacMech::Health;
   destroyedLevel = $TacMech::Health;
   disabledLevel = $TacMech::Health;

   isTacticalMech = true;
   deployedObject = true;
   emap = true;
   targetNameTag = 'Mech/Gundam';
   explosion = AnExplosion;
   heatSignature = 0;
};

datablock PlayerData(TacticalMechMaleHumanArmor) : MechDamageProfile
{
   emap = true;

   isTacticalMech = true;

   className = Armor;
   shapeFile = "TR2heavy_male.dts";
   cameraMaxDist = 12;
   computeCRC = true;

   debrisShapeName = "debris_player.dts";
   debris = playerDebris;

   canObserve = true;
   cmdCategory = "Clients";
   cmdIcon = CMDPlayerIcon;
   cmdMiniIconName = "commander/MiniIcons/com_player_grey";

   hudImageNameFriendly[0] = "gui/hud_playertriangle.png";
   hudImageNameEnemy[0] = "gui/hud_playertriangle_enemy.png";
   hudRenderModulated[0] = true;

   hudImageNameFriendly[1] = "commander/MiniIcons/com_flag_grey";
   hudImageNameEnemy[1] = "commander/MiniIcons/com_flag_grey";
   hudRenderModulated[1] = true;
   hudRenderAlways[1] = true;
   hudRenderCenter[1] = true;
   hudRenderDistance[1] = true;

   hudImageNameFriendly[2] = "commander/MiniIcons/com_flag_grey";
   hudImageNameEnemy[2] = "commander/MiniIcons/com_flag_grey";
   hudRenderModulated[2] = true;
   hudRenderAlways[2] = true;
   hudRenderCenter[2] = true;
   hudRenderDistance[2] = true;

   aiAvoidThis = true;

   minLookAngle = -1.4;
   maxLookAngle = 1.4;
   maxFreelookAngle = 3.0;

   mass = 1911*Meltdown.MassMod;
   drag = 0.5;
   maxdrag = 0.6;
   density = 10*Meltdown.DensityMod;
   maxDamage = $TacMech::Health;
   maxEnergy =  500;
   repairRate = 0.0011;
   energyPerDamagePoint = 200.0; // shield energy required to block one point of damage

   rechargeRate = 1.024;
   jetForce = (21.4 * 182) * 11.1;
   underwaterJetForce = (21.4 * 182) * 13;
   underwaterVertJetFactor = 1.5;
   jetEnergyDrain =  1.359;
   underwaterJetEnergyDrain =  1.25;
   minJetEnergy = 50;
   maxJetHorizontalPercentage = 0.8;

   runForce = (35 * 210) * 8;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 16*Meltdown.RunSpeedMod;
   maxBackwardSpeed = 16*Meltdown.RunSpeedMod;
   maxSideSpeed = 16*Meltdown.RunSpeedMod;

   maxUnderwaterForwardSpeed = 8*Meltdown.WaterRunSpeedMod;
   maxUnderwaterBackwardSpeed = 8*Meltdown.WaterRunSpeedMod;
   maxUnderwaterSideSpeed = 8*Meltdown.WaterRunSpeedMod;

   recoverDelay = 12;
   recoverRunForceScale = 1.2;

   jumpForce = (9.25 * 215) * 10;
   jumpEnergyDrain = 0;
   minJumpEnergy = 65535;
   jumpDelay = 0;

   // heat inc'ers and dec'ers
   heatDecayPerSec      = 1.0 / 6.0; // takes 3 seconds to clear heat sig.
   heatIncreasePerSec   = 3; // takes 3.0 seconds of constant jet to get full heat sig.

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 75;
   jumpSurfaceAngle = 75;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 1000;
   horizResistSpeed = 20;
   horizResistFactor = 0.3;
   maxJetForwardSpeed = 16*Meltdown.JetSpeedMod;

   upMaxSpeed = 60;
   upResistSpeed = 35;
   upResistFactor = 0.15;

   minImpactSpeed = 60;
   speedDamageScale = 0.006;

   jetSound = ScoutFlyerThrustSound;
   wetJetSound = AssaultVehicleThrustSound;
   jetEmitter = TurboJetEmitter; //ShrikeEngineEmitter;

   boundingBox = "6.2 6.2 9.0";
   pickupRadius = 1.5; //0.75;

   // damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;

   //Foot Prints
   decalData   = HeavyMaleFootprint;
   decalOffset = 0.4;

   footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 15;
   footPuffRadius = 0.25;

   dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.4;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;
   hardSplashSoundVelocity = 20.0;
   exitSplashSoundVelocity = 5.0;

   footstepSplashHeight = 0.35;
   //Footstep Sounds
   LFootSoftSound       = LFootHeavySoftSound;
   RFootSoftSound       = RFootHeavySoftSound;
   LFootHardSound       = LFootHeavyHardSound;
   RFootHardSound       = RFootHeavyHardSound;
   LFootMetalSound      = LFootHeavyMetalSound;
   RFootMetalSound      = RFootHeavyMetalSound;
   LFootSnowSound       = LFootHeavySnowSound;
   RFootSnowSound       = RFootHeavySnowSound;
   LFootShallowSound    = LFootHeavyShallowSplashSound;
   RFootShallowSound    = RFootHeavyShallowSplashSound;
   LFootWadingSound     = LFootHeavyWadingSound;
   RFootWadingSound     = RFootHeavyWadingSound;
   LFootUnderwaterSound = LFootHeavyUnderwaterSound;
   RFootUnderwaterSound = RFootHeavyUnderwaterSound;
   LFootBubblesSound    = LFootHeavyBubblesSound;
   RFootBubblesSound    = RFootHeavyBubblesSound;
   movingBubblesSound   = ArmorMoveBubblesSound;
   waterBreathSound     = WaterBreathMaleSound;

   impactSoftSound      = ImpactHeavySoftSound;
   impactHardSound      = ImpactHeavyHardSound;
   impactMetalSound     = ImpactHeavyMetalSound;
   impactSnowSound      = ImpactHeavySnowSound;

   skiSoftSound         = SkiAllSoftSound;
   skiHardSound         = SkiAllHardSound;
   skiMetalSound        = SkiAllMetalSound;
   skiSnowSound         = SkiAllSnowSound;

   impactWaterEasy      = ImpactHeavyWaterEasySound;
   impactWaterMedium    = ImpactHeavyWaterMediumSound;
   impactWaterHard      = ImpactHeavyWaterHardSound;

   groundImpactMinSpeed    = 20.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;

   exitingWater         = ExitingWaterHeavySound;

   maxWeapons = 10;           // Max number of different weapons the mech can have
   maxGrenades = 0;
   maxMines = 0;

   // Inventory restrictions
   max[RepairKit]          = 0;
   max[Beacon]             = 0;

   max[Mine]               = 0;
   max[LargeMine]          = 0;
   max[CloakMine]          = 0;
   max[EMPMine]            = 0;
   max[IncendiaryMine]     = 0;

   max[Grenade]            = 0;
   max[CameraGrenade]      = 0;
   max[FlashGrenade]       = 0;
   max[ConcussionGrenade]  = 0;
   max[FlareGrenade]       = 0;
   max[MortarGrenade]      = 0;
   max[EMPGrenade]         = 0;
   max[FireGrenade]        = 0;
   max[PoisonGrenade]      = 0;

   max[BoosterGrenade]     = 0;
   max[BlastechMine]       = 0;

   max[TargetingLaser]     = 1;
   max[Reassembler]        = 0;
   max[EDisassembler]      = 0;

   max[Blaster]            = 0;
   max[SniperRifle]        = 0;
   max[ELFGun]             = 0;
   max[ShockLance]         = 0;
   max[FissionRifle]       = 0;
   max[PBW]                = 0;
   max[AssaultR]           = 0;
   max[MagMissileLauncher] = 0;

   max[Plasma]             = 0;
   max[PlasmaAmmo]         = 0;
   max[Disc]               = 1;
   max[DiscAmmo]           = 250;
   max[GrenadeLauncher]    = 0;
   max[GrenadeLauncherAmmo]= 0;
   max[Mortar]             = 0;
   max[MortarAmmo]         = 0;
   max[MissileLauncher]    = 0;
   max[MissileLauncherAmmo]= 0;
   max[Chaingun]           = 1;
   max[ChaingunAmmo]       = 1000;
   max[EnergyRifle]        = 1;
   max[EnergyRifleAmmo]    = 100;
   max[Protron]            = 0;
   max[ProtronAmmo]        = 0;
   max[MBCannon]           = 0;
   max[MBCannonCapacitor]  = 0;
   max[RFL]                = 0;
   max[RFLCapacitor]       = 0;
   max[PCR]                = 0;
   max[PCRAmmo]            = 0;
   max[TetherLauncher]     = 0;
   max[TetherLauncherAmmo] = 0;
   max[Sniper3006]         = 0;
   max[Sniper3006Ammo]     = 0;
   max[Shotgun]            = 0;
   max[ShotgunAmmo]        = 0;
   max[AutoCannon]         = 1;
   max[AutoCannonAmmo]     = 750;
   max[PWT]                = 1;
   max[PWTAmmo]            = 50;
   max[Multifusor]         = 1;
   max[Reaver]             = 1;
   max[ReaverAmmo]         = 250;
   max[Starburst]          = 1;
   max[StarburstAmmo]      = 50;
   max[EcstacyCannon]      = 0;
   max[EcstacyCapacitor]   = 0;
   max[MechRocketGun]      = 0;
   max[MechRocketGunAmmo]  = 0;
   max[PAC]                = 0;
   max[PACCapacitor]       = 0;
   max[MechMinigun]        = 0;
   max[MechMinigunAmmo]    = 0;

   max[MechAAA]            = 0;
   max[FlakMortar]         = 0;
   max[FlakMortarAmmo]     = 0;
   max[MSCannon]           = 0;
   max[MSCannonCapacitor]  = 0;

   max[CloakingPack]       = 0;
   max[SensorJammerPack]   = 0;
   max[EnergyPack]         = 0;
   max[ShieldPack]         = 0;
   max[AmmoPack]           = 0;
   max[SynomiumPack]       = 0;
   max[SatchelCharge]      = 0;
   max[HeatShieldPack]     = 0;
   max[GravitronPack]      = 0;
   max[HoverPack]          = 0;
   max[JetPack]            = 0;
   max[StarHammerPack]     = 1;
   max[PlasmaCannonPack]   = 1;
   max[BlasterCannonPack]  = 1;
   max[SlipstreamPack]     = 0;
   max[DetPack]            = 0;
   max[JetfirePack]        = 0;
   max[MegaDiscPack]       = 0;
   max[InventoryPack]      = 0;
   max[MagIonPack]         = 0;
   max[MagIonHeatPack]     = 0;
   max[AngelPack]          = 0;

   max[RepairPack]         = 0;
   max[RepairGun]          = 0;
   max[RAXX]               = 1;
   max[RAXXAmmo]           = 1500;
   max[LaserCannonPack]    = 0;
   max[LaserCannonGun]     = 0;

   max[VehiclePadPack]     = 0;
   max[TurretBasePack]     = 0;
   max[TelePack]           = 0;
   max[WildcatPack]        = 0;
   max[JammerBeaconPack]   = 0;
   max[ShieldGeneratorPack] = 0;
   max[RepulsorBeaconPack]   = 0;
   max[TeamchatBeaconPack]   = 0;
   max[SmallShieldBeaconPack] = 0;
   max[DeployableInvHumanPack] = 0;
   max[InventoryDeployable]     = 0;
   max[MotionSensorDeployable]  = 0;
   max[PulseSensorDeployable]   = 0;
   max[TurretOutdoorDeployable] = 0;
   max[TurretIndoorDeployable]  = 0;
   max[DefenderDesignator]      = 0;
   max[DeployableGeneratorPack] = 0;

   max[MortarBarrelPack]   = 0;
   max[MissileBarrelPack]  = 0;
   max[AABarrelPack]       = 0;
   max[PlasmaBarrelPack]   = 0;
   max[ELFBarrelPack]      = 0;
   max[PhaserBarrelPack]   = 0;
   max[MitziBarrelPack]    = 0;
   max[ChainBarrelPack]    = 0;
   max[DiscBarrelPack]     = 0;

   max[SensorJamMod]       = 0;
   max[ReactorMod]         = 0;
   max[AutoRepairMod]      = 0;
   max[LavaShieldMod]      = 0;
   max[RepulsorMod]        = 0;
   max[SelfDestructMod]    = 0;
   max[CloakMod]           = 0;
   max[BoosterMod]         = 0;
   max[DampenerMod]        = 0;
   max[FlareMod]           = 0;
   max[VehicleRocketMod]   = 0;
   max[VehicleStandardMod] = 0;
   max[VehicleChaingunMod] = 0;
   max[VehicleBomberMod]   = 0;
   max[VehicleDiscMod]     = 0;
   max[VehicleMitziMod]    = 0;
   max[VehiclePhaserMod]   = 0;

   observeParameters = "1.0 12.0 12.0";

   shieldEffectScale = "0.7 0.7 1.0";
};

datablock PlayerData(TacticalMechFemaleHumanArmor) : TacticalMechMaleHumanArmor
{
   shieldEffectScale = "0.7 0.7 1.0";
};

datablock PlayerData(TacticalMechMaleBiodermArmor) : TacticalMechMaleHumanArmor
{
   shieldEffectScale = "0.7 0.7 1.0";
};
