if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// Meltdown2 Variables

// Game

function DefaultGame::clearDeployableMaxes(%game)
{
   for(%i = 0; %i <= %game.numTeams; %i++)
   {
      $TeamDeployedCount[%i, TurretIndoorDeployable] = 0;
      $TeamDeployedCount[%i, TurretOutdoorDeployable] = 0;
      $TeamDeployedCount[%i, PulseSensorDeployable] = 0;
      $TeamDeployedCount[%i, MotionSensorDeployable] = 0;
      $TeamDeployedCount[%i, InventoryDeployable] = 0;
      $TeamDeployedCount[%i, DeployedCamera] = 0;
      $TeamDeployedCount[%i, MineDeployed] = 0;
      $TeamDeployedCount[%i, TargetBeacon] = 0;
      $TeamDeployedCount[%i, MarkerBeacon] = 0;
      $TeamDeployedCount[%i, VehiclePadPack] = 0;
      $TeamDeployedCount[%i, TurretBasePack] = 0;
      $TeamDeployedCount[%i, TelePack] = 0;
     // $TeamDeployedCount[%i, WildcatPack] = 0;  -Nite- Drones ?
      $TeamDeployedCount[%i, DeployableInvHumanPack] = 0;
      $TeamDeployedCount[%i, ShieldGeneratorPack] = 0;
      $TeamDeployedCount[%i, DefenderDesignator] = 0;
//      $TeamDeployedCount[%i, DetPack] = 0;  -Nite- nuke
      $TeamDeployedCount[%i, TapperPack] = 0;
      $TeamDeployedCount[%i, HoverBasePack] = 0;
      $TeamDeployedCount[%i, BorgCubePack] = 0;
      $TeamDeployedCount[%i, DefenseBasePack] = 0;
      $TeamDeployedCount[%i, ShieldBeaconPack] = 0;
      $TeamDeployedCount[%i, TeamchatBeaconPack] = 0;
      $TeamDeployedCount[%i, RepulsorBeaconPack] = 0;
      $TeamDeployedCount[%i, JammerBeaconPack] = 0;
      $TeamDeployedCount[%i, DeployableGeneratorPack] = 0;
      $TeamDeployedCount[%i, DefEnhancePack] = 0;
      $TeamDeployedCount[%i, TacMechPack] = 0;
      $TeamDeployedCount[%i, BlastWallPack] = 0;
      $TeamDeployedCount[%i, BlastDoorPack] = 0;
      $TeamDeployedCount[%i, DeployableSentryPack] = 0;
      $TeamDeployedCount[%i, LaserSentryPack] = 0;
      $TeamDeployedCount[%i, MantaSatPack] = 0;
      $TeamDeployedCount[%i, RMSSPack] = 0; // Death~Bot
   }
}

$BackpackHudData[18, itemDataName] = "HeatShieldPack";
$BackpackHudData[18, bitmapName] = "gui/hud_new_packshield";
$BackpackHudData[19, itemDataName] = "GravitronPack";
$BackpackHudData[19, bitmapName] = "gui/hud_new_packsatchel";
$BackpackHudData[20, itemDataName] = "SensorJamMod";
$BackpackHudData[20, bitmapName] = "gui/hud_new_packsensjam";
$BackpackHudData[21, itemDataName] = "MagIonHeatPack";
$BackpackHudData[21, bitmapName] = "gui/hud_new_packenergy";
$BackpackHudData[22, itemDataName] = "HoverPack";
$BackpackHudData[22, bitmapName] = "gui/hud_new_packcloak";
$BackpackHudData[23, itemDataName] = "MagIonPack";
$BackpackHudData[23, bitmapName] = "gui/hud_new_packsatchel";
$BackpackHudData[24, itemDataName] = "RAXXPack";
$BackpackHudData[24, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[25, itemDataName] = "VehiclePadPack";
$BackpackHudData[25, bitmapName] = "gui/hud_new_packrepair";
$BackpackHudData[26, itemDataName] = "TurretBasePack";
$BackpackHudData[26, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[27, itemDataName] = "LavaShieldMod";
$BackpackHudData[27, bitmapName] = "gui/hud_new_packshield";
$BackpackHudData[28, itemDataName] = "DefEnhancePack";
$BackpackHudData[28, bitmapName] = "gui/hud_new_packinventory";
$BackpackHudData[29, itemDataName] = "PlasmaCannonPack";
$BackpackHudData[29, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[30, itemDataName] = "MASCPack";
$BackpackHudData[30, bitmapName] = "gui/hud_new_packenergy";
//$BackpackHudData[31, itemDataName] = "VehicleBomberMod"; -Nite- no bomb mod
//$BackpackHudData[31, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[31, itemDataName] = "VehicleMitziMod";
$BackpackHudData[31, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[32, itemDataName] = "VehiclePhaserMod";
$BackpackHudData[32, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[33, itemDataName] = "MitziBarrelPack";
$BackpackHudData[33, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[34, itemDataName] = "PhaserBarrelPack";
$BackpackHudData[34, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[35, itemDataName] = "TelePack";
$BackpackHudData[35, bitmapName] = "gui/hud_new_packrepair";
$BackpackHudData[36, itemDataName] = "PulseCannonPack";
$BackpackHudData[36, bitmapName] = "gui/hud_new_packenergy";
$BackpackHudData[37, itemDataName] = "RepulsorBeaconPack";
$BackpackHudData[37, bitmapName] = "gui/hud_new_packshield";
//$BackpackHudData[39, itemDataName] = "WildcatPack";    -Nite- drones
//$BackpackHudData[39, bitmapName] = "gui/hud_new_packinventory";
$BackpackHudData[38, itemDataName] = "ReactorMod";
$BackpackHudData[38, bitmapName] = "gui/hud_new_packenergy";
$BackpackHudData[39, itemDataName] = "DeployableInvHumanPack";
$BackpackHudData[39, bitmapName] = "gui/hud_new_packenergy";
$BackpackHudData[40, itemDataName] = "JetfirePack";
$BackpackHudData[40, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[41, itemDataName] = "MegaDiscPack";
$BackpackHudData[41, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[42, itemDataName] = "ShieldGeneratorPack";
$BackpackHudData[42, bitmapName] = "gui/hud_new_packenergy";
$BackpackHudData[43, itemDataName] = "BlasterCannonPack";
$BackpackHudData[43, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[44, itemDataName] = "SynomiumPack";
$BackpackHudData[44, bitmapName] = "gui/hud_new_packenergy";
$BackpackHudData[45, itemDataName] = "StarHammerPack";
$BackpackHudData[45, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[46, itemDataName] = "SlipstreamPack";
$BackpackHudData[46, bitmapName] = "gui/hud_new_packcloak";
$BackpackHudData[47, itemDataName] = "DetPack";
$BackpackHudData[47, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[48, itemDataName] = "DeployableGeneratorPack";
$BackpackHudData[48, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[49, itemDataName] = "SelfDestructMod";
$BackpackHudData[49, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[50, itemDataName] = "DampenerMod";
$BackpackHudData[50, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[51, itemDataName] = "DiscBarrelPack";
$BackpackHudData[51, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[52, itemDataName] = "InventoryPack";
$BackpackHudData[52, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[53, itemDataName] = "ShieldBeaconPack";
$BackpackHudData[53, bitmapName] = "gui/hud_new_packshield";
$BackpackHudData[54, itemDataName] = "LaserCannonPack";
$BackpackHudData[54, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[55, itemDataName] = "TurbogravPack";
$BackpackHudData[55, bitmapName] = "gui/hud_new_packenergy";
$BackpackHudData[56, itemDataName] = "BorgCubePack";
$BackpackHudData[56, bitmapName] = "gui/hud_new_packrepair";
$BackpackHudData[57, itemDataName] = "JammerBeaconPack";
$BackpackHudData[57, bitmapName] = "gui/hud_new_packsensjam";
$BackpackHudData[58, itemDataName] = "DefenseBasePack";
$BackpackHudData[58, bitmapName] = "gui/hud_new_packrepair";
$BackpackHudData[59, itemDataName] = "HoverBasePack";
$BackpackHudData[59, bitmapName] = "gui/hud_new_packrepair";
$BackpackHudData[60, itemDataName] = "EnergyBarrelPack";
$BackpackHudData[60, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[61, itemDataName] = "VehicleEnergyMod";
$BackpackHudData[61, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[62, itemDataName] = "TeamchatBeaconPack";
$BackpackHudData[62, bitmapName] = "gui/hud_new_packsensjam";
$BackpackHudData[63, itemDataName] = "FlareMod";
$BackpackHudData[63, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[66, itemDataName] = "TacMechPack";
$BackpackHudData[66, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[64, itemDataName] = "BlastWallPack";
$BackpackHudData[64, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[65, itemDataName] = "BlastDoorPack";
$BackpackHudData[65, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[66, itemDataName] = "DeployableSentryPack";
$BackpackHudData[66, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[67, itemDataName] = "LaserSentryPack";
$BackpackHudData[67, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[68, itemDataName] = "MantaSatPack";
$BackpackHudData[68, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[69, itemDataName] = "IonTagPack";
$BackpackHudData[69, bitmapName] = "gui/hud_new_packturret";

$BackpackHudData[70, itemDataName] = "RMSSPack";         //Death~Bot
$BackpackHudData[70, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[71, itemDataName] = "MANTACapacitorPack";         //MrKeen
$BackpackHudData[71, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[72, itemDataName] = "TapperPack";         //MrKeen
$BackpackHudData[72, bitmapName] = "gui/hud_new_packsensjam";
$BackpackHudData[73, itemDataName] = "MANTANukePack";         //MrKeen
$BackpackHudData[73, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[74, itemDataName] = "VectorPortPack";         //MrKeen
$BackpackHudData[74, bitmapName] = "gui/hud_new_packturret";
$BackpackHudData[75, itemDataName] = "RMSScatterpackAmmoPack";         //MrKeen
$BackpackHudData[75, bitmapName] = "gui/hud_new_packturret";

$BackpackHudCount = 76;  //-Nite- with taking out all this stuff we free'd up some room.

$InventoryHudData[8, bitmapName]   = "gui/hud_handgren";
$InventoryHudData[8, itemDataName] = MortarGrenade;
$InventoryHudData[8, ammoDataName] = MortarGrenade;
$InventoryHudData[8, slot]         = 0;
$InventoryHudData[9, bitmapName]   = "gui/hud_handgren";
$InventoryHudData[9, itemDataName] = EMPGrenade;
$InventoryHudData[9, ammoDataName] = EMPGrenade;
$InventoryHudData[9, slot]         = 0;
$InventoryHudData[10, bitmapName]   = "gui/hud_handgren";
$InventoryHudData[10, itemDataName] = FireGrenade;
$InventoryHudData[10, ammoDataName] = FireGrenade;
$InventoryHudData[10, slot]         = 0;
$InventoryHudData[11, bitmapName]   = "gui/hud_handgren";
$InventoryHudData[11, itemDataName] = PoisonGrenade;
$InventoryHudData[11, ammoDataName] = PoisonGrenade;
$InventoryHudData[11, slot]         = 0;
$InventoryHudData[12, bitmapName]   = "gui/hud_handgren";
$InventoryHudData[12, itemDataName] = WhiteoutGrenade;
$InventoryHudData[12, ammoDataName] = WhiteoutGrenade;
$InventoryHudData[12, slot]         = 0;
$InventoryHudData[13, bitmapName]   = "gui/hud_mine";
$InventoryHudData[13, itemDataName] = LargeMine;
$InventoryHudData[13, ammoDataName] = LargeMine;
$InventoryHudData[13, slot]         = 1;
$InventoryHudData[14, bitmapName]   = "gui/hud_mine";
$InventoryHudData[14, itemDataName] = CloakMine;
$InventoryHudData[14, ammoDataName] = CloakMine;
$InventoryHudData[14, slot]         = 1;
$InventoryHudData[15, bitmapName]   = "gui/hud_mine";
$InventoryHudData[15, itemDataName] = EMPMine;
$InventoryHudData[15, ammoDataName] = EMPMine;
$InventoryHudData[15, slot]         = 1;
$InventoryHudData[16, bitmapName]   = "gui/hud_mine";
$InventoryHudData[16, itemDataName] = IncendiaryMine;
$InventoryHudData[16, ammoDataName] = IncendiaryMine;
$InventoryHudData[16, slot]         = 1;

$InventoryHudCount = 17;

$ControlObjectReticle[PhaserBarrelLarge, bitmap] = "ret_blaster";
$ControlObjectReticle[PhaserBarrelLarge, frame] = true;
$ControlObjectReticle[MitziBarrelLarge, bitmap] = "ret_elf";
$ControlObjectReticle[MitziBarrelLarge, frame] = true;
$ControlObjectReticle[DiscBarrelLarge, bitmap] = "ret_disc";
$ControlObjectReticle[DiscBarrelLarge, frame] = true;
$ControlObjectReticle[ChaingunBarrelLarge, bitmap] = "ret_chaingun";
$ControlObjectReticle[ChaingunBarrelLarge, frame] = true;
$ControlObjectReticle[EnergyBarrelLarge, bitmap] = "ret_mortor";
$ControlObjectReticle[EnergyBarrelLarge, frame] = true;

// Inventory Cycle List

function ShapeBase::hasAmmo( %this, %weapon )
{
   if(%this.disableSwitch)
     return false;

   switch$ ( %weapon )
   {
      case Blaster:
         return (true);  //self charge
      case Plasma:
         return( %this.getInventory( PlasmaAmmo ) > 0 );
      case Chaingun:
         return( %this.getInventory( ChaingunAmmo ) > 0 );
      case Disc:
         return( %this.getInventory( DiscAmmo ) > 0 );
      case GrenadeLauncher:
         return( %this.getInventory( GrenadeLauncherAmmo ) > 0 );
      case SniperRifle:
         return true;
//         return( %this.getInventory( EnergyPack ) );
      case ELFGun:
         return( true );
      case Mortar:
         return( %this.getInventory( MortarAmmo ) > 0 );
      case MissileLauncher:
         return( %this.getInventory( MissileLauncherAmmo ) > 0 );
      case ShockLance:
         return( true );
      // This is our kinda hacky way to keep from cycling to the targeting laser:
      case TargetingLaser:
         return( false );
      case EnergyRifle:
         return( %this.getInventory( EnergyRifleAmmo ) > 0 );
      case MBCannon:
         return(true);   // self-charge weapon.
      case RFL:
         return(true);   // self-charge weapon.
      case FissionRifle:
         return(true);
      case Protron:
         return(true);
//         return( %this.getInventory( ProtronAmmo ) > 0 );
      case PBW:
         return(true);
      case TetherLauncher:
         return( %this.getInventory( TetherLauncherAmmo ) > 0 );
      case PCR:
         return( %this.getInventory( PCRAmmo ) > 0 );
      case RAXX:
         return( %this.getInventory( RAXXAmmo ) > 0 );
//      case Sniper3006:
//         return( %this.getInventory( Sniper3006Ammo ) > 0 );
      case Shotgun:
         return( %this.getInventory( ShotgunAmmo ) > 0 );
      case PWT:
         return( %this.getInventory( PWTAmmo ) > 0 );
//      case AssaultR:
//         return(true);
      case MagMissileLauncher:
         return(true);
      case GatPBW:  //evil death~bot
         return(true);
      case Multifusor:
         return(%this.getInventory(DiscAmmo) > 0);
      case Starburst:
         return(%this.getInventory(StarburstAmmo) > 0);
      case AutoCannon:
         return(%this.getInventory(AutoCannonAmmo) > 0);
      case Reassembler:
         return true;
      case EcstacyCannon:
         return true;
      case GuidedMissileLauncher:
         return(%this.getInventory(GuidedMissileAmmo) > 0);
      case MechMinigun:
         return(%this.getInventory(MechMinigunAmmo) > 0);
      case MechRocketGun:
         return(%this.getInventory(MechRocketGunAmmo) > 0);
      case Reaver:
         return(%this.getInventory(ReaverAmmo) > 0);
//         return true;
      case PAC:
         return true;
      case PlasmaCannon:
         return true;
      case Ripper:
         return true; // MrKeen
      default:
         warn( "\"" @ %weapon @ "\" has not been added to the cycle list!" );
         return( false );
   }
}

function ShapeBase::clearInventory(%this)
{
   %this.setInventory(RepairKit,0);

   %this.setInventory(Mine,0);
   %this.setInventory(LargeMine,0);
   %this.setInventory(CloakMine,0);
   %this.setInventory(EMPMine,0);
   %this.setInventory(IncendiaryMine,0);
   %this.setInventory(Grenade,0);
   %this.setInventory(FlashGrenade,0);
   %this.setInventory(ConcussionGrenade,0);
   %this.setInventory(FlareGrenade,0);
   %this.setInventory(MortarGrenade, 0);
   %this.setInventory(EMPGrenade, 0);
   %this.setInventory(PoisonGrenade, 0);
   %this.setInventory(FireGrenade, 0);

   %this.setInventory(Blaster,0);
   //%this.setInventory(BlasterAmmo,0);
   %this.setInventory(Plasma,0);
   %this.setInventory(Disc,0);
   %this.setInventory(Chaingun, 0);
   %this.setInventory(Mortar, 0);
   %this.setInventory(GrenadeLauncher, 0);
   %this.setInventory(MissileLauncher, 0);
   %this.setInventory(SniperRifle, 0);
   %this.setInventory(TargetingLaser, 0);
   %this.setInventory(ELFGun, 0);
   %this.setInventory(ShockLance, 0);

   %this.setInventory(EnergyRifle, 0);
   %this.setInventory(EnergyRifleAmmo, 0);
   %this.setInventory(SonicPistol, 0);
   %this.setInventory(Protron, 0);
   %this.setInventory(ProtronAmmo, 0);
   %this.setInventory(MBCannon, 0);
   %this.setInventory(MBCannonCapacitor, 0);
   %this.setInventory(RFL, 0);
   %this.setInventory(RFLCapacitor, 0);
   %this.setInventory(PCR, 0);
   %this.setInventory(PCRAmmo, 0);
   %this.setInventory(TetherLauncher, 0);
   %this.setInventory(TetherLauncherAmmo, 0);
   %this.setInventory(PBW, 0);
   %this.setInventory(RAXX, 0);
   %this.setInventory(RAXXAmmo, 0);
   %this.setInventory(Sniper3006Ammo, 0);
   %this.setInventory(Shotgun, 0);
   %this.setInventory(ShotgunAmmo, 0);
   %this.setInventory(PWT, 0);
   %this.setInventory(PWTAmmo, 0);
   %this.setInventory(Ripper, 0);
   %this.setInventory(RipperAmmo, 0);
   %this.setInventory(MagMissileLauncher, 0);
   %this.setInventory(Starburst, 0);
   %this.setInventory(Multifusor, 0);
   %this.setInventory(EcstacyCannon, 0);
   %this.setInventory(MechMinigun, 0);
   %this.setInventory(MechMinigunAmmo, 0);
   %this.setInventory(MechRocketGun, 0);
   %this.setInventory(MechAAA, 0);
   %this.setInventory(MechRocketGunAmmo, 0);
   %this.setInventory(PlasmaCannon, 0);
   %this.setInventory(FissionRifle, 0);
   %this.setInventory(PAC, 0);
   %this.setInventory(PACCapacitor, 0);
   %this.setInventory(Reaver, 0);
   %this.setInventory(ReaverAmmo, 0);
   %this.setInventory(AutoCannon, 0);
   %this.setInventory(AutoCannonAmmo, 0);

   %this.setInventory(PlasmaAmmo,0);
   %this.setInventory(ChaingunAmmo, 0);
   %this.setInventory(DiscAmmo, 0);
   %this.setInventory(GrenadeLauncherAmmo, 0);
   %this.setInventory(MissileLauncherAmmo, 0);
   %this.setInventory(MortarAmmo, 0);
   %this.setInventory(Beacon, 0);
   %this.setInventory(Disruptor, 0);

   // take away any pack the player has
   %curPack = %this.getMountedImage($BackpackSlot);
   if(%curPack > 0)
      %this.setInventory(%curPack.item, 0);
}

// Inv Hud Data
$InvArmor[3] = "Magnetic Ion";
$NameToInv["Magnetic Ion"]  = "MagIon";
$InvArmor[4] = "Field Engineer";
$NameToInv["Field Engineer"]  = "Engineer";
$InvArmor[5] = "Battle Angel";
$NameToInv["Battle Angel"]  = "BattleAngel";
$InvArmor[6] = "Blastech";
$NameToInv["Blastech"] = "Blastech";

///////////////////////////////////////////////////////////////////////////////

$InvWeapon[0] = "Blaster"; //Pulse Rifle";         //Death~Bot
$NameToInv["Blaster"] = "Blaster";

$InvWeapon[5] = "Sniper/3006 Rifle";
$NameToInv["Sniper/3006 Rifle"] = "SniperRifle";

$InvWeapon[10] = "Energy Rifle";
$NameToInv["Energy Rifle"] = "EnergyRifle";
$InvWeapon[11] = "Rapid Fire Laser";
$NameToInv["Rapid Fire Laser"] = "RFL";
$InvWeapon[12] = "Protron";  //moved death~bot
$NameToInv["Protron"] = "Protron";
$InvWeapon[13] = "Phaser Rifle";
$NameToInv["Phaser Rifle"] = "PCR";
$InvWeapon[14] = "Ripper";
//$NameToInv["Ripper"] = "Ripper";
$InvWeapon[15] = "Mitzi Blast Cannon";
$NameToInv["Mitzi Blast Cannon"] = "MBCannon";
$InvWeapon[16] = "Tether Missile Launcher";
$NameToInv["Tether Missile Launcher"] = "TetherLauncher";
$InvWeapon[17] = "PBW";
$NameToInv["PBW"] = "PBW";
$InvWeapon[18] = "Pocket Rocket";
$NameToInv["Pocket Rocket"] = "PWT";
$InvWeapon[19] = "Reaver Flak Cannon";
$NameToInv["Reaver Flak Cannon"] = "Reaver";
$InvWeapon[20] = "Shotgun";
//$NameToInv["Shotgun"] = "Shotgun";
$InvWeapon[21] = "Mini Missile Launcher";
$NameToInv["Mini Missile Launcher"] = "MagMissileLauncher";
$InvWeapon[22] = "AutoCannon";
$NameToInv["AutoCannon"] = "AutoCannon";
$InvWeapon[23] = "Multifusor";
$NameToInv["Multifusor"] = "Multifusor";
$InvWeapon[24] = "Starburst Cannon";
$NameToInv["Starburst Cannon"] = "Starburst";
$InvWeapon[25] = "Ecstacy Charge Cannon";
$NameToInv["Ecstacy Charge Cannon"] = "EcstacyCannon";
$InvWeapon[26] = "PAC";
$NameToInv["PAC"] = "PAC";
$InvWeapon[27] = "Mech Minigun";
$NameToInv["Mech Minigun"] = "MechMinigun";
$InvWeapon[28] = "Mech Rocket Launcher";
$NameToInv["Mech Rocket Launcher"] = "MechRocketGun";
$InvWeapon[29] = "Plasma Cannon";
$NameToInv["Plasma Cannon"] = "PlasmaCannon";
$InvWeapon[30] = "RAXX Flamer";
$NameToInv["RAXX Flamer"] = "RAXX";
$InvWeapon[31] = "Fission Rifle";
$NameToInv["Fission Rifle"] = "FissionRifle";

$InvPack[12] = "ELF Turret Barrelx";
$InvPack[13] = "Mortar Turret Barrelx";
$InvPack[14] = "Plasma Turret Barrelx";
$InvPack[15] = "AA Turret Barrelx";
$InvPack[16] = "Missile Turret Barrelx";

$InvPack[17] = "Lava Shield / Heat Sink";
$NameToInv["Lava Shield / Heat Sink"] = "HeatShieldPack";
$InvPack[18] = "Gravitron Field Emitter";
$NameToInv["Gravitron Field Emitter"] = "GravitronPack";
$InvPack[19] = "Forcefield Array";
$NameToInv["Forcefield Array"] = "ShieldGeneratorPack";
$InvPack[20] = "Magnetic Ion Reactor";
$NameToInv["Magnetic Ion Reactor"] = "MagIonPack";
$InvPack[21] = "Synomium Device";
$NameToInv["Synomium Device"] = "SynomiumPack";
$InvPack[22] = "Inventory Pack";
$NameToInv["Inventory Pack"] = "InventoryPack";
$InvPack[23] = "Teamchat Tapper Pack";
$NameToInv["Teamchat Tapper Pack"] = "TapperPack";
$InvPack[24] = "Shield Beacon";
$NameToInv["Shield Beacon"] = "ShieldBeaconPack";
$InvPack[25] = "Slipstream-IX";
$NameToInv["Slipstream-IX"] = "SlipstreamPack";
$InvPack[26] = "Weapon Repulsor";
$NameToInv["Weapon Repulsor"] = "RepulsorBeaconPack";
$InvPack[27] = "MASC";
$NameToInv["MASC"] = "MASCPack";
$InvPack[28] = "Jammer Beacon";
$NameToInv["Jammer Beacon"] = "JammerBeaconPack";
$InvPack[29] = "Jetfire Transformer";
$NameToInv["Jetfire Transformer"] = "JetfirePack";
$InvPack[30] = "Bean-With-Bacon MegaDisc";
$NameToInv["Bean-With-Bacon MegaDisc"] = "MegaDiscPack";
$InvPack[31] = "Equipment Generator";
$NameToInv["Equipment Generator"] = "DeployableGeneratorPack";
$InvPack[32] = "Vehicle Base";
$NameToInv["Vehicle Base"] = "VehiclePadPack";
$InvPack[33] = "Base Turret";
$NameToInv["Base Turret"] = "TurretBasePack";
$InvPack[34] = "Reactor/HeatShield";
$NameToInv["Reactor/HeatShield"] = "MagIonHeatPack";
$InvPack[35] = "Hover Base";
$NameToInv["Hover Base"] = "HoverBasePack";
$InvPack[36] = "Bombardment Base";
$NameToInv["Bombardment Base"] = "BorgCubePack";
$InvPack[37] = "Defense Base";
$NameToInv["Defense Base"] = "DefenseBasePack";
$InvPack[38] = "Defender Designator";
//$NameToInv["Defender Designator"] = "DefenderDesignator";
$InvPack[39] = "Large Inv Station";
$NameToInv["Large Inv Station"] = "DeployableInvHumanPack";
$InvPack[40] = "Teleporter Pad";
$NameToInv["Teleporter Pad"] = "TelePack";
//$InvPack[41] = "Remote Drone";
//$NameToInv["Remote Drone"] = "WildcatPack";    -Nite-
$InvPack[41] = "Laser Cannon";
$NameToInv["Laser Cannon"] = "LaserCannonPack";
//$InvPack[43] = "Nuke Pack";
$InvPack[42] = "Star Hammer";
$NameToInv["Star Hammer"] = "StarHammerPack";
$InvPack[43] = "Mitzi Singularity Cannon";
$NameToInv["Mitzi Singularity Cannon"] = "BlasterCannonPack";
$InvPack[44] = "Pulse Cannon";
$NameToInv["Pulse Cannon"] = "PulseCannonPack";

//$InvPack[47] = "Jet Pack";
$InvPack[45] = "Angels Wings";
//$NameToInv["Angels Wings"] = "AngelPack";
$InvPack[46] = "Defense+ Device";
$NameToInv["Defense+ Device"] = "DefEnhancePack";
$InvPack[47] = "Blast Wall";
$NameToInv["Blast Wall"] = "BlastWallPack";
$InvPack[48] = "Blast Door";
$NameToInv["Blast Door"] = "BlastDoorPack";
$InvPack[49] = "Sentry Turret";
$NameToInv["Sentry Turret"] = "DeployableSentryPack";
//$InvPack[54] = "Laser Sentry";
//$NameToInv["Laser Sentry"] = "LaserSentryPack";
$InvPack[50] = "MANTA Ion/RMS Targeter"; // (ST)
$NameToInv["MANTA Ion/RMS Targeter"] = "IonTAGPack"; // (ST)
$InvPack[51] = "MANTA Satellite";
$NameToInv["MANTA Satellite"] = "MantaSatPack";

$InvPack[52] = "RMS Silo";       //Death~Bot
$NameToInv["RMS Silo"] = "RMSSpack"; //Death~Bot
$InvPack[53] = "MANTA Ion Battery";       //MrKeen
$NameToInv["MANTA Ion Battery"] = "MANTACapacitorPack"; //MrKeen

$InvPack[54] = "Mech/Gundam";
$NameToInv["Mech/Gundam"] = "TacMechPack";

$InvPack[55] = "MANTA Ion Nuke";       //MrKeen
if($Feature[MANTANukePack])
   $NameToInv["MANTA Ion Nuke"] = "MANTANukePack"; //MrKeen

$InvPack[56] = "VectorPort";       //MrKeen
$NameToInv["VectorPort"] = "VectorPortPack"; //MrKeen
$InvPack[57] = "RMS ScatterPack Missiles";       //MrKeen
$NameToInv["RMS ScatterPack Missiles"] = "RMSScatterpackAmmoPack"; //MrKeen


//-Nite- removed jetpack   Also reordered above
//if($AllowItem[Jetpack])
//   $NameToInv["Jet Pack"] = "JetPack";

$InvGrenade[0] = "Std Frag";
$NameToInv["Std Frag"] = "Grenade";
$InvGrenade[1] = "Mortar";
$NameToInv["Mortar"] = "MortarGrenade";
$InvGrenade[2] = "Poison Gas";
$NameToInv["Poison Gas"] = "PoisonGrenade";
$InvGrenade[3] = "ElectroMag";
$NameToInv["ElectroMag"] = "EMPGrenade";
$InvGrenade[4] = "Whiteout";
$NameToInv["Whiteout"] = "FlashGrenade";
$InvGrenade[5] = "Concussion";
$NameToInv["Concussion"] = "ConcussionGrenade";
$InvGrenade[6] = "Incendiary";
$NameToInv["Incendiary"] = "FireGrenade";
$InvGrenade[7] = "Camera";
$NameToInv["Camera"] = "CameraGrenade";
$InvGrenade[8] = "Flare";
$NameToInv["Flare"] = "FlareGrenade";
$InvGrenade[9] = "";
$NameToInv["Booster"] = "BoosterGrenade";

$InvMine[0] = "Mine";
$NameToInv["Mine"] = "Mine";
$InvMine[1] = "Large Mine";
$NameToInv["Large Mine"] = "LargeMine";
$InvMine[2] = "Cloak Mine";
$NameToInv["Cloak Mine"] = "CloakMine";
$InvMine[3] = "EMP Mine";
$NameToInv["EMP Mine"] = "EMPMine";
$InvMine[4] = "Incendiary Mine";
$NameToInv["Incendiary Mine"] = "IncendiaryMine";
$InvMine[5] = "Anti-Blastech Mine";
$NameToInv["Anti-Blastech Mine"] = "BlastechMine";

function buyFavorites(%client)
{
   %client.player.battleangel = false;
   // don't forget -- for many functions, anything done here also needs to be done
   // below in buyDeployableFavorites !!!
   %client.player.clearInventory();
   %client.setWeaponsHudClearAll();
   %cmt = $CurrentMissionType;

   %curArmor = %client.player.getDatablock();
   %curDmgPct = getDamagePercent(%curArmor.maxDamage, %client.player.getDamageLevel());

   // armor
   %client.armor = $NameToInv[%client.favorites[0]];
   %client.player.setArmor( %client.armor );

   %newArmor = %client.player.getDataBlock();

   if(%newArmor.isBattleAngel)
   {
      %client.player.battleangel = true;
      ejectFlag(%client.player);
   }

   %client.player.setDamageLevel(%curDmgPct * %newArmor.maxDamage);
   %client.player.setRechargeRate(%newArmor.rechargeRate);

   if(!%client.player.charging)
   {
        %client.player.charging = true; //case MB
        ChargeMBC(%client.player, %client.player.getDatablock());
   }

   if(!%client.player.chargingProt)
   {
        %client.player.chargingProt = true; //case Protron/blaster
        ChargeProtron(%client.player, %client.player.getDatablock());
   }

   if(!%client.player.chargingRFL)
   {
        %client.player.chargingRFL = true; //case RFL
        ChargeRFL(%client.player);
   }

   if(%client.player.getDatablock().isBlastech)
      BlastechRecharge(%client.player);

//   if(%client.player.getDatablock().isCPX)
//          CPXArmorInit(%client.player);

   schedule(0, 0, useEnergy, %client.player, -%newArmor.maxEnergy); // why I had to do this? T2 is w3rd... 8(

   // weapons
   for(%i = 0; %i < getFieldCount( %client.weaponIndex ); %i++)
   {
      %inv = $NameToInv[%client.favorites[getField( %client.weaponIndex, %i )]];

      if( %inv !$= "" )
      {
         %weaponCount++;
         %client.player.setInventory( %inv, 1 );
      }
      // z0dd - ZOD, 9/13/02. Streamlining.
      if ( %inv.image.ammo !$= "" )
         %client.player.setInventory( %inv.image.ammo, 2500 );

      if(%inv $= "MBCannon") // hack - would give 2000 ammo to MB :o lol
         %client.player.setInventory( MBCannonCapacitor, 50 );

      if(%inv $= "Protron") // hack -
         %client.player.setInventory( ProtronAmmo, 100 );
   }
   %client.player.weaponCount = %weaponCount;

   // pack
   %pCh = $NameToInv[%client.favorites[%client.packIndex]];
   if ( %pCh $= "" )
      %client.clearBackpackIcon();
   else
      %client.player.setInventory( %pCh, 1 );

   // if this pack is a deployable that has a team limit, warn the purchaser
	// if it's a deployable turret, the limit depends on the number of players (deployables.cs)
	if(%pCh $= "TurretIndoorDeployable" || %pCh $= "TurretOutdoorDeployable")
		%maxDep = countTurretsAllowed(%pCh);
	else
	   %maxDep = $TeamDeployableMax[%pCh];

   if(%maxDep !$= "")
   {
      %depSoFar = $TeamDeployedCount[%client.player.team, %pCh];
      %packName = %client.favorites[%client.packIndex];

      if(Game.numTeams > 1)
         %msTxt = "Your team has "@%depSoFar@" of "@%maxDep SPC %packName@"s deployed.";
      else
         %msTxt = "You have deployed "@%depSoFar@" of "@%maxDep SPC %packName@"s.";

      messageClient(%client, 'MsgTeamDepObjCount', %msTxt);
   }

   // grenades
   for ( %i = 0; %i < getFieldCount( %client.grenadeIndex ); %i++ )
      %client.player.setInventory( $NameToInv[%client.favorites[getField( %client.grenadeIndex,%i )]], 30 );

   // if player is buying cameras, show how many are already deployed
   if(%client.favorites[%client.grenadeIndex] $= "Deployable Camera")
   {
      %maxDep = $TeamDeployableMax[DeployedCamera];
      %depSoFar = $TeamDeployedCount[%client.player.team, DeployedCamera];
      if(Game.numTeams > 1)
         %msTxt = "Your team has "@%depSoFar@" of "@%maxDep@" Deployable Cameras placed.";
      else
         %msTxt = "You have placed "@%depSoFar@" of "@%maxDep@" Deployable Cameras.";
      messageClient(%client, 'MsgTeamDepObjCount', %msTxt);
   }

   // mines
   // -----------------------------------------------------------------------------------------------------
   // z0dd - ZOD, 5/8/02. Old code did not check to see if mines are banned, fixed.
   //for ( %i = 0; %i < getFieldCount( %client.mineIndex ); %i++ )
   //   %client.player.setInventory( $NameToInv[%client.favorites[getField( %client.mineIndex,%i )]], 30 );

   for ( %i = 0; %i < getFieldCount( %client.mineIndex ); %i++ )
   {
      if ( !($InvBanList[%cmt, $NameToInv[%client.favorites[getField( %client.mineIndex, %i )]]]) )
        %client.player.setInventory( $NameToInv[%client.favorites[getField( %client.mineIndex,%i )]], 30 );
   }
   // End z0dd - ZOD
   // -----------------------------------------------------------------------------------------------------

   // miscellaneous stuff -- Repair Kit, Beacons, Targeting Laser
   if ( !($InvBanList[%cmt, RepairKit]) )
      %client.player.setInventory( RepairKit, 10 );
   if ( !($InvBanList[%cmt, Beacon]) )
      %client.player.setInventory( Beacon, 1000 );
   if ( !($InvBanList[%cmt, TargetingLaser]) )
      %client.player.setInventory( TargetingLaser, 1 );

   // ammo pack pass -- hack! hack!
   if( %pCh $= "AmmoPack" )
      invAmmoPackPass(%client);
}

function buyDeployableFavorites(%client)
{
   %player = %client.player;
	%prevPack = %player.getMountedImage($BackpackSlot);
   %player.clearInventory();
   %client.setWeaponsHudClearAll();
   %cmt = $CurrentMissionType;

   if(!%client.player.charging)
   {
        %client.player.charging = true; //case MB
        ChargeMBC(%client.player, %client.player.getDatablock());
   }

   if(!%client.player.chargingProt)
   {
        %client.player.chargingProt = true; //case Protron
        ChargeProtron(%client.player, %client.player.getDatablock());
   }

   if(!%client.player.chargingRFL)
   {
        %client.player.chargingRFL = true; //case RFL
        ChargeRFL(%client.player);
   }
   schedule(0, 0, useEnergy, %client.player, -%client.player.getDatablock().maxEnergy);

  // players cannot buy armor from deployable inventory stations
   %weapCount = 0;
   for ( %i = 0; %i < getFieldCount( %client.weaponIndex ); %i++ )
   {
      %inv = $NameToInv[%client.favorites[getField( %client.weaponIndex, %i )]];
      if ( !($InvBanList[DeployInv, %inv]) )
      {
         %player.setInventory( %inv, 1 );
         // increment weapon count if current armor can hold this weapon
         if(%player.getDatablock().max[%inv] > 0)
            %weapCount++;

         // z0dd - ZOD, 9/13/02. Streamlining
         if ( %inv.image.ammo !$= "" )
            %player.setInventory( %inv.image.ammo, 2500 );

         if(%inv $= "MBCannon") // hack - would give 2000 ammo to MB :o lol
            %client.player.setInventory( MBCannonCapacitor, 50 );

         if(%inv $= "Protron")
            %client.player.setInventory( ProtronAmmo, 100 );

         if(%weapCount >= %player.getDatablock().maxWeapons)
            break;
      }
   }
   %player.weaponCount = %weapCount;

   // give player the grenades and mines they chose, beacons, and a repair kit
   for ( %i = 0; %i < getFieldCount( %client.grenadeIndex ); %i++)
   {
      %GInv = $NameToInv[%client.favorites[getField( %client.grenadeIndex, %i )]];
      if ( !($InvBanList[DeployInv, %GInv]) )
         %player.setInventory( %GInv, 30 );
   }

   // if player is buying cameras, show how many are already deployed
   if(%client.favorites[%client.grenadeIndex] $= "Deployable Camera")
   {
      %maxDep = $TeamDeployableMax[DeployedCamera];
      %depSoFar = $TeamDeployedCount[%client.player.team, DeployedCamera];
      if(Game.numTeams > 1)
         %msTxt = "Your team has "@%depSoFar@" of "@%maxDep@" Deployable Cameras placed.";
      else
         %msTxt = "You have placed "@%depSoFar@" of "@%maxDep@" Deployable Cameras.";
      messageClient(%client, 'MsgTeamDepObjCount', %msTxt);
   }

   for ( %i = 0; %i < getFieldCount( %client.mineIndex ); %i++ )
   {
      %MInv = $NameToInv[%client.favorites[getField( %client.mineIndex, %i )]];
      if ( !($InvBanList[DeployInv, %MInv]) )
         %player.setInventory( %MInv, 30 );
   }
   if ( !($InvBanList[DeployInv, Beacon]) && !($InvBanList[%cmt, Beacon]) )
      %player.setInventory( Beacon, 1000 );
   if ( !($InvBanList[DeployInv, RepairKit]) && !($InvBanList[%cmt, RepairKit]) )
      %player.setInventory( RepairKit, 10 );
   if ( !($InvBanList[DeployInv, TargetingLaser]) && !($InvBanList[%cmt, TargetingLaser]) )
      %player.setInventory( TargetingLaser, 1 );

   // players cannot buy deployable station packs from a deployable inventory station
   %packChoice = $NameToInv[%client.favorites[%client.packIndex]];
   if ( !($InvBanList[DeployInv, %packChoice]) )
      %player.setInventory( %packChoice, 1 );

   // if this pack is a deployable that has a team limit, warn the purchaser
	// if it's a deployable turret, the limit depends on the number of players (deployables.cs)
	if(%packChoice $= "TurretIndoorDeployable" || %packChoice $= "TurretOutdoorDeployable")
		%maxDep = countTurretsAllowed(%packChoice);
	else
	   %maxDep = $TeamDeployableMax[%packChoice];
   if((%maxDep !$= "") && (%packChoice !$= "InventoryDeployable"))
   {
      %depSoFar = $TeamDeployedCount[%client.player.team, %packChoice];
      %packName = %client.favorites[%client.packIndex];

      if(Game.numTeams > 1)
         %msTxt = "Your team has "@%depSoFar@" of "@%maxDep SPC %packName@"s deployed.";
      else
         %msTxt = "You have deployed "@%depSoFar@" of "@%maxDep SPC %packName@"s.";

      messageClient(%client, 'MsgTeamDepObjCount', %msTxt);
   }

	if(%prevPack > 0)
	{
		// if player had a "forbidden" pack (such as a deployable inventory station)
		// BEFORE visiting a deployed inventory station AND still has that pack chosen
		// as a favorite, give it back
		if((%packChoice $= %prevPack.item) && ($InvBanList[DeployInv, %packChoice]))
	      %player.setInventory( %prevPack.item, 1 );
	}

   if(%packChoice $= "AmmoPack")
      invAmmoPackPass(%client);
}

for(%idx = 0; %idx < 32; %idx++)
   $WeaponsHudData[%idx, visible] = "true";

//$WeaponsHudData[0, reticle] = "gui/ret_blaster";
//$WeaponsHudData[0, itemDataName] = "Blaster";
//$WeaponsHudData[0, ammoDataName] = "ProtronAmmo"; //Death~bot

$WeaponsHudData[1, reticle] = "gui/ret_plasma";
$WeaponsHudData[2, reticle] = "gui/ret_chaingun";
$WeaponsHudData[3, reticle] = "gui/ret_disc";
$WeaponsHudData[4, reticle] = "gui/ret_grenade";

$WeaponsHudData[5, ammoDataName] = "Sniper3006Ammo";
$WeaponsHudData[5, reticle] = "gui/ret_chaingun";

$WeaponsHudData[6, reticle] = "gui/ret_elf";
$WeaponsHudData[7, reticle] = "gui/ret_mortor";
$WeaponsHudData[8, reticle] = "gui/ret_missile";

$WeaponsHudData[9, bitmapName]   = "gui/hud_targetlaser"; // hud_targetlaser
$WeaponsHudData[9, itemDataName] = "FissionRifle"; // TargetingLaser
$WeaponsHudData[9, reticle] = "gui/ret_blaster";

$WeaponsHudData[10, reticle] = "gui/hud_ret_shocklance";

$WeaponsHudData[11, bitmapName]   = "gui/hud_chaingun";
$WeaponsHudData[11, itemDataName] = "EnergyRifle";
$WeaponsHudData[11, ammoDataName] = "EnergyRifleAmmo";
$WeaponsHudData[11, reticle] = "gui/ret_plasma";

$WeaponsHudData[12, bitmapName]   = "gui/hud_blaster";
$WeaponsHudData[12, itemDataName] = "RFL";
$WeaponsHudData[12, ammoDataName] = "RFLCapacitor";
$WeaponsHudData[12, reticle] = "gui/hud_ret_shocklance";

$WeaponsHudData[13, bitmapName]   = "gui/hud_chaingun";
$WeaponsHudData[13, itemDataName] = "Protron";
$WeaponsHudData[13, ammoDataName] = "ProtronAmmo";
$WeaponsHudData[13, reticle] = "gui/ret_blaster";

$WeaponsHudData[14, bitmapName]   = "gui/hud_elfgun";
$WeaponsHudData[14, itemDataName] = "MBCannon";
$WeaponsHudData[14, ammoDataName] = "MBCannonCapacitor";
$WeaponsHudData[14, reticle] = "gui/ret_mortor";

$WeaponsHudData[15, bitmapName]   = "gui/hud_chaingun";
$WeaponsHudData[15, itemDataName] = "PCR";
$WeaponsHudData[15, ammoDataName] = "PCRAmmo";
$WeaponsHudData[15, reticle] = "gui/ret_elf";

$WeaponsHudData[16, bitmapName]   = "gui/hud_missiles";
$WeaponsHudData[16, itemDataName] = "Reaver";
$WeaponsHudData[16, ammoDataName] = "ReaverAmmo";
$WeaponsHudData[16, reticle] = "gui/ret_plasma";

$WeaponsHudData[17, bitmapName]   = "gui/hud_sniper";
$WeaponsHudData[17, itemDataName] = "PBW";
$WeaponsHudData[17, reticle] = "gui/ret_grenade";

$WeaponsHudData[18, bitmapName]   = "gui/hud_missiles";
$WeaponsHudData[18, itemDataName] = "TetherLauncher";
$WeaponsHudData[18, ammoDataName] = "TetherLauncherAmmo";
$WeaponsHudData[18, reticle] = "gui/ret_missile";

$WeaponsHudData[19, bitmapName]   = "gui/hud_plasma";
$WeaponsHudData[19, itemDataName] = "PlasmaCannon";
$WeaponsHudData[19, reticle] = "gui/ret_blaster"; //hud_ret_sniper";

$WeaponsHudData[20, bitmapName]   = "gui/hud_missiles";
$WeaponsHudData[20, itemDataName] = "PWT";
$WeaponsHudData[20, ammoDataName] = "PWTAmmo";
$WeaponsHudData[20, reticle] = "gui/ret_mortor";

$WeaponsHudData[21, bitmapName]   = "gui/hud_plasma";
$WeaponsHudData[21, itemDataName] = "Shotgun";
$WeaponsHudData[21, ammoDataName] = "ShotgunAmmo";
$WeaponsHudData[21, reticle] = "gui/ret_grenade";

$WeaponsHudData[22, bitmapName]   = "gui/hud_missiles";
$WeaponsHudData[22, itemDataName] = "MagMissileLauncher";
$WeaponsHudData[22, reticle] = "gui/ret_missile";

$WeaponsHudData[23, bitmapName]   = "gui/hud_disc";
$WeaponsHudData[23, itemDataName] = "Multifusor";
$WeaponsHudData[23, ammoDataName] = "DiscAmmo";
$WeaponsHudData[23, reticle] = "gui/ret_disc";

$WeaponsHudData[24, bitmapName]   = "gui/hud_plasma";
$WeaponsHudData[24, itemDataName] = "AutoCannon";
$WeaponsHudData[24, ammoDataName] = "AutoCannonAmmo";
$WeaponsHudData[24, reticle] = "gui/ret_blaster";

$WeaponsHudData[25, bitmapName]   = "gui/hud_mortor";
$WeaponsHudData[25, itemDataName] = "Starburst";
$WeaponsHudData[25, ammoDataName] = "StarburstAmmo";
$WeaponsHudData[25, reticle] = "gui/ret_mortor";

$WeaponsHudData[26, bitmapName]   = "gui/hud_chaingun";
$WeaponsHudData[26, itemDataName] = "RAXX";
$WeaponsHudData[26, ammoDataName] = "RAXXAmmo";
$WeaponsHudData[26, reticle] = "gui/ret_missile";

$WeaponsHudData[27, bitmapName]   = "gui/hud_shocklance";
$WeaponsHudData[27, itemDataName] = "EcstacyCannon";
$WeaponsHudData[27, ammoDataName] = "EcstacyCapacitor";
$WeaponsHudData[27, reticle] = "gui/ret_grenade";

$WeaponsHudData[28, bitmapName]   = "gui/hud_chaingun";
$WeaponsHudData[28, itemDataName] = "MechMinigun";
$WeaponsHudData[28, ammoDataName] = "MechMinigunAmmo";
$WeaponsHudData[28, reticle] = "gui/ret_chaingun";

$WeaponsHudData[29, bitmapName]   = "gui/hud_missiles";
$WeaponsHudData[29, itemDataName] = "MechRocketGun";
$WeaponsHudData[29, ammoDataName] = "MechRocketGunAmmo";
$WeaponsHudData[29, reticle] = "gui/ret_missile";

$WeaponsHudData[30, bitmapName]   = "gui/hud_disc";
$WeaponsHudData[30, itemDataName] = "Ripper";
$WeaponsHudData[30, ammoDataName] = "RipperAmmo";
$WeaponsHudData[30, reticle] = "gui/ret_disc";

$WeaponsHudData[31, bitmapName]   = "gui/hud_shocklance";
$WeaponsHudData[31, itemDataName] = "PAC";
$WeaponsHudData[31, ammoDataName] = "PACCapacitor";
$WeaponsHudData[31, reticle] = "gui/ret_elf";

$WeaponsHudData[32, bitmapName]   = "gui/hud_sniper";//death~bot
$WeaponsHudData[32, itemDataName] = "GatPBW";
$WeaponsHudData[32, reticle] = "gui/ret_elf";

$WeaponsHudCount = 33; //WAS 32 until keen wanted that crappin blaster back BAH!

$AmmoIncrement[EnergyRifleAmmo]  = 25;
$AmmoIncrement[PCRAmmo]   = 60;
$AmmoIncrement[TetherLauncherAmmo]   = 4;
$AmmoIncrement[ShotgunAmmo]   = 400;
$AmmoIncrement[Sniper3006Ammo]   = 15;
$AmmoIncrement[PWTAmmo]   = 4;
$AmmoIncrement[MechMinigunAmmo]   = 150;
$AmmoIncrement[MechRocketGunAmmo]   = 10;
$AmmoIncrement[StarburstAmmo]   = 5;
$AmmoIncrement[AutoCannonAmmo]   = 100;
$AmmoIncrement[RAXXAmmo] = 75;
//$AmmoIncrement[BlasterAmmo] = 75;

$ammoType[0] = "PlasmaAmmo";
$ammoType[1] = "DiscAmmo";
$ammoType[2] = "GrenadeLauncherAmmo";
$ammoType[3] = "MortarAmmo";
$ammoType[4] = "MissileLauncherAmmo";
$ammoType[5] = "ChaingunAmmo";

$ammoType[6] = "EnergyRifleAmmo";
$ammoType[7] = "StarburstAmmo";
$ammoType[8] = "PCRAmmo";
$ammoType[9] = "MechRocketGunAmmo";
$ammoType[10] = "TetherLauncherAmmo";
$ammoType[11] = "PWTAmmo";
$ammoType[12] = "Sniper3006Ammo";
$ammoType[13] = "ShotgunAmmo";
$ammoType[14] = "MechMinigunAmmo";
$ammoType[15] = "AutoCannonAmmo";
$ammoType[16] = "RAXXAmmo";
$ammoType[17] = "ReaverAmmo";
//$ammoType[18] = "BlasterAmmo";
//$ammoType[19] = "ReaverAmmo";
$ammoType[18] = "ProtronAmmo";

/// vehicles

function VehicleHud::updateHud( %obj, %client, %tag)
{
   %station = %client.player.station;
   %obj.vstag = %tag;
   %menu = %client.vsmenu;
// Not sure if we need to clear the huds... They'll always have the same num rows...
   //if ( %station.lastCount !$= "" )
   //   VehicleHud::clearHud( %client, %tag, %station.lastCount );

   if(!%station.overrideMasterList)
   {
      %station.vehicle[scoutVehicle] = true;
      %station.vehicle[scoutFlyer] = true;
      %station.vehicle[AssaultVehicle] = true;
      %station.vehicle[AssaultFlyer] = true; //removal per Keen
      %station.vehicle[bomberFlyer] = true;
      %station.vehicle[LOSDownFlyer] = true; //removal per Keen
      %station.vehicle[hapcFlyer] = true;
      %station.vehicle[mobileBaseVehicle] = true;
      %station.vehicle[alternateMobileBase] = true;
      %station.vehicle[HoverBike] = true;
      %station.vehicle[SuicideFlyer] = true; //removal per Keen
      %station.vehicle[PyroXL] = true; //removal per Keen
      %station.vehicle[Wolfhound] = true;
      %station.vehicle[Skyranger] = true;
      %station.vehicle[ATV] = true;
      %station.vehicle[ATV2] = true;
      %station.vehicle[tPOC] = true;
      %station.vehicle[Truck] = true;
      %station.vehicle[WarpFlyer] = true; //removal per Keen
      %station.vehicle[Stingray] = true;
      %station.vehicle[TurboCat] = true;
      %station.vehicle[Explorer] = true;
   }

   %station.vehicle[Advanced] = true;

   %team = %client.getSensorGroup();
   %count = 0;

   if(%menu == 1)
   {
      if (%station.vehicle[scoutVehicle])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Wildcat", "", ScoutVehicle, $VehicleMax[ScoutVehicle] - $VehicleTotalCount[%team, ScoutVehicle] );
         %count++;
      }
      if (%station.vehicle[TurboCat])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "TurboCat", "", TurboCat, $VehicleMax[TurboCat] - $VehicleTotalCount[%team, TurboCat] );
         %count++;
      }
      if(%station.vehicle[ATV])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "All Terrain Vehicle", "", ATV, $VehicleMax[ATV] - $VehicleTotalCount[%team, ATV]);
         %count++;
      }
      if (%station.vehicle[Advanced])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Back", "", Back, 1 );
         %count++;
      }
   }
   else if(%menu == 2)
   {
      if (%station.vehicle[HoverBike])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Hover Bike", "", HoverBike, $VehicleMax[HoverBike] - $VehicleTotalCount[%team, HoverBike] );
         %count++;
      }
      if (%station.vehicle[scoutFlyer])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Shrike", "", ScoutFlyer, $VehicleMax[ScoutFlyer] - $VehicleTotalCount[%team, ScoutFlyer] );
         %count++;
      }
      if (%station.vehicle[tPOC])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Marantz Turbograv", "", tPOC, $VehicleMax[tPOC] - $VehicleTotalCount[%team, tPOC] );
         %count++;
      }
      if (%station.vehicle[Skyranger])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "SilverShark Patroller", "", Skyranger, $VehicleMax[Skyranger] - $VehicleTotalCount[%team, Skyranger] );
         %count++;
      }
      if (%station.vehicle[WarpFlyer] && $AllowItem[Camanis])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Camanis* Hypergrav", "", WarpFlyer, $VehicleMax[WarpFlyer] - $VehicleTotalCount[%team, WarpFlyer] );
         %count++;
      }
      if (%station.vehicle[Advanced])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Back", "", Back, 1 );
         %count++;
      }
   }
   else if(%menu == 3)
   {
      if (%station.vehicle[AssaultVehicle])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Beowulf", "", AssaultVehicle, $VehicleMax[AssaultVehicle] - $VehicleTotalCount[%team, AssaultVehicle] );
         %count++;
      }
      if (%station.vehicle[AssaultFlyer])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Flying Beowulf", "", AssaultFlyer, $VehicleMax[AssaultFlyer] - $VehicleTotalCount[%team, AssaultFlyer] );
         %count++;
      }
      if (%station.vehicle[bomberFlyer])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Thundersword", "", BomberFlyer, $VehicleMax[BomberFlyer] - $VehicleTotalCount[%team, BomberFlyer] );
         %count++;
      }
      if(%station.vehicle[SuicideFlyer] && $AllowItem[SMPB] && !$SMPBBuilding[%client.team])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Flying Suicide MPB", "", SuicideFlyer,  $VehicleMax[SuicideFlyer] - $VehicleTotalCount[%team, SuicideFlyer] ); //$VehicleMax[SuicideFlyer] - $VehicleTotalCount[%team, SuicideFlyer] );
         %count++;
      }
      if (%station.vehicle[Advanced])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Back", "", Back, 1 );
         %count++;
      }
   }
   else if(%menu == 4)
   {
      if (%station.vehicle[mobileBaseVehicle])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Mobile Point Base", "", MobileBaseVehicle, $VehicleMax[MobileBaseVehicle] - $VehicleTotalCount[%team, MobileBaseVehicle] );
         %count++;
      }
      if(%station.vehicle[AlternateMobileBase]) // 4 water maps -- hack for now.
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Floating Mobile Point Base", "", AlternateMobileBase, $VehicleMax[AlternateMobileBase] - $VehicleTotalCount[%team, AlternateMobileBase] );
         %count++;
      }
      if (%station.vehicle[Advanced])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Back", "", Back, 1 );
         %count++;
      }
   }
   else if(%menu == 5)
   {
      if (%station.vehicle[PyroXL])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "PyroXL LPC", "", PyroXL, $VehicleMax[PyroXL] - $VehicleTotalCount[%team, PyroXL] );
         %count++;
      }
      if (%station.vehicle[LOSDownFlyer])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "LOSDown Teleporter Transport", "", LOSDownFlyer, $VehicleMax[LOSDownFlyer] - $VehicleTotalCount[%team, LOSDownFlyer] );
         %count++;
      }
      if (%station.vehicle[hapcFlyer])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Havoc", "", HAPCFlyer, $VehicleMax[HAPCFlyer] - $VehicleTotalCount[%team, HAPCFlyer] );
         %count++;
      }
      if (%station.vehicle[Wolfhound])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Wolfhound Armed Transport", "", Wolfhound, $VehicleMax[Wolfhound] - $VehicleTotalCount[%team, Wolfhound] );
         %count++;
      }
      if (%station.vehicle[Explorer])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Explorer Stealth Transporter", "", Explorer, $VehicleMax[Explorer] - $VehicleTotalCount[%team, Explorer] );
         %count++;
      }
      if(%station.vehicle[ATV2])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "PQZ StarShine Warp Transport", "", ATV2, $VehicleMax[ATV2] - $VehicleTotalCount[%team, ATV2]);
         %count++;
      }
      if (%station.vehicle[Advanced])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Back", "", Back, 1 );
         %count++;
      }
   }
   else
   {
      if (%station.vehicle[Advanced])
      {
        messageClient( %client, 'SetLineHud', "", %tag, %count, "Terragravs", "", Terragravs, 1 );
         %count++;
      }
      if (%station.vehicle[Advanced])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Turbogravs", "", Turbogravs, 1 );
         %count++;
      }
      if (%station.vehicle[Advanced])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Heavy", "", Heavy, 1 );
         %count++;
      }
      if (%station.vehicle[Advanced])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Ground", "", Ground, 1 );
         %count++;
      }
      if (%station.vehicle[Advanced])
      {
         messageClient( %client, 'SetLineHud', "", %tag, %count, "Transports", "", Transports, 1 );
         %count++;
      }
   }
   %station.lastCount = %count;
}

$VehicleMax[ScoutVehicle]        = 10;
$VehicleMax[AssaultVehicle]      = 4;
$VehicleMax[AssaultFlyer]        = 2; //removed per Keen
$VehicleMax[MobileBaseVehicle]   = 1;
$VehicleMax[tPOC]                = 3;
$VehicleMax[AlternateMobileBase] = 1;
$VehicleMax[ScoutFlyer]          = 6;
$VehicleMax[BomberFlyer]         = 2;
$VehicleMax[HAPCFlyer]           = 3;
$VehicleMax[HoverBike]           = 5;
$VehicleMax[SuicideFlyer]        = 1;
$VehicleMax[PyroXL]              = 3; //removed per Keen
$VehicleMax[Wolfhound]           = 2;
$VehicleMax[Skyranger]           = 3;
$VehicleMax[ATV2]                = 2;
$VehicleMax[ATV]                 = 4;
$VehicleMax[Advanced]            = 1;
$VehicleMax[WarpFlyer]           = 3; //removed per Keen
$VehicleMax[Stingray]            = 8;
$VehicleMax[Explorer]            = 3;
$VehicleMax[TurboCat]            = 5;
$VehicleMax[LOSDownFlyer]        = 2; //removed per Keen

function clearVehicleCount(%team)
{
   $VehicleTotalCount[%team, ScoutVehicle]      = 0;
   $VehicleTotalCount[%team, AssaultVehicle]    = 0;
   $VehicleTotalCount[%team, AssaultFlyer]      = 0;
   $VehicleTotalCount[%team, MobileBaseVehicle] = 0;
   $VehicleTotalCount[%team, ScoutFlyer]        = 0;
   $VehicleTotalCount[%team, BomberFlyer]       = 0;
   $VehicleTotalCount[%team, HAPCFlyer]         = 0;
   $VehicleTotalCount[%team, HoverBike]         = 0;
   $VehicleTotalCount[%team, ATV]               = 0;
   $VehicleTotalCount[%team, SuicideFlyer]      = 0;
   $VehicleTotalCount[%team, PyroXL]            = 0;
   $VehicleTotalCount[%team, Wolfhound]         = 0;
   $VehicleTotalCount[%team, Skyranger]         = 0;
   $VehicleTotalCount[%team, ATV2]              = 0;
   $VehicleTotalCount[%team, tPOC]              = 0;
   $VehicleTotalCount[%team, Advanced]          = 0;
   $VehicleTotalCount[%team, Truck]             = 0;
   $VehicleTotalCount[%team, WarpFlyer]         = 0;
   $VehicleTotalCount[%team, Stingray]          = 0;
   $VehicleTotalCount[%team, TurboCat]          = 0;
   $VehicleTotalCount[%team, Explorer]          = 0;
   $VehicleTotalCount[%team, LOSDownFlyer]      = 0;
}

// Beacon Modes

//MrKeen - $DenyMode[armor, weapon, %mode] = true;

$WeaponModeCount[Blaster] = 2;
$WeaponModeName[Blaster] = "Blaster";
$WeaponModeSound[Blaster] = "SniperRifleDryFireSound";
$WeaponMode[Blaster, 0] = "Energy Bolt";
$WeaponMode[Blaster, 1] = "Blue Blaster";
$WeaponMode[Blaster, 2] = "AA Bolt";
$WeaponModeDescription[Blaster, 0] = "Standard Blaster Bolt.";
$WeaponModeDescription[Blaster, 1] = "Blue Blaster Bolt.";
$WeaponModeDescription[Blaster, 2] = "This mode is useful for tagging Magnetic Ions.";

$WeaponModeCount[Chaingun] = 2;
$WeaponMode[Chaingun, 0] = "Standard";
$WeaponMode[Chaingun, 1] = "Vulcan";
$WeaponMode[Chaingun, 2] = "Gauss";
$WeaponModeName[Chaingun] = "Chaingun";
$WeaponModeSound[Chaingun] = "SniperRifleDryFireSound";
$WeaponModeDescription[Chaingun, 0] = "Standard Chaingun bullets.";
$WeaponModeDescription[Chaingun, 1] = "Fires 2x the bullets and gives a little knockback.";
$WeaponModeDescription[Chaingun, 2] = "Fires explosive-tipped bullets.";
$DenyMode[MagIon, Chaingun, 2] = true;
$DenyMode[Light, Chaingun, 2] = true;

$WeaponModeCount[Shotgun] = 1;
$WeaponMode[Shotgun, 0] = "Standard";
$WeaponMode[Shotgun, 1] = "Firewall";
$WeaponModeName[Shotgun] = "Shotgun";
$WeaponModeSound[Shotgun] = "SniperRifleDryFireSound";
$WeaponModeDescription[Shotgun, 0] = "Standard 12-shot blast.";
$WeaponModeDescription[Shotgun, 1] = "Explosive 24-shot blast.";
$DenyMode[MagIon, Shotgun, 1] = true;
$DenyMode[Blastech, Shotgun, 1] = true;

$WeaponModeCount[Shocklance] = 2;
$WeaponMode[Shocklance, 0] = "Standard";
$WeaponMode[Shocklance, 1] = "Incendiary";
$WeaponMode[Shocklance, 2] = "Extended";  //-Nite new mod for fun see what happens
$WeaponModeName[Shocklance] = "Shocklance";
$WeaponModeSound[Shocklance] = "ShockLanceDryFireSound";
$WeaponModeDescription[Shocklance, 0] = "Standard electro-lance.";
$WeaponModeDescription[Shocklance, 1] = "Sets your target on fire!";
$WeaponModeDescription[ShockLance, 2] = "2x range at the cost of 2x energy usage.";

$WeaponModeCount[EnergyRifle] = 1;
$WeaponMode[EnergyRifle, 0] = "Standard";
$WeaponMode[EnergyRifle, 1] = "Spreadfire";
$WeaponModeName[EnergyRifle] = "Energy Rifle";
$WeaponModeSound[EnergyRifle] = "ShockLanceDryFireSound";
$WeaponModeDescription[EnergyRifle, 0] = "Standard Energy blast.";
$WeaponModeDescription[EnergyRifle, 1] = "Fires 3 direct-hit energy blasts.";

$WeaponModeCount[Protron] = 2;
$WeaponMode[Protron, 0] = "Standard";
$WeaponMode[Protron, 1] = "Pulse";
$WeaponMode[Protron, 2] = "Blue Blaster";
$WeaponModeName[Protron] = "Protron";
$WeaponModeSound[Protron] = "SniperRifleDryFireSound";
$WeaponModeDescription[Protron, 0] = "Useful multi-purpose Protron bolt.";
$WeaponModeDescription[Protron, 1] = "More damage blast radius Pulse bolt. Good for taking out structures.";
$WeaponModeDescription[Protron, 2] = "Blue Blaster bolt; bounces off of walls and damages BAs.";

$WeaponModeCount[Mortar] = 2; // mode 3 disabled ATM - not working properly
$WeaponMode[Mortar, 0] = "Standard";
$WeaponMode[Mortar, 1] = "Impact";
$WeaponMode[Mortar, 2] = "EMP";
$WeaponMode[Mortar, 3] = "Fireworks";
$WeaponModeName[Mortar] = "Mortar";
$WeaponModeSound[Mortar] = "MortarReloadSound";
$WeaponModeDescription[Mortar, 0] = "Standard big green boomie.";
$WeaponModeDescription[Mortar, 1] = "Impact explosive charge. Not as powerful as normal mortar.";
$WeaponModeDescription[Mortar, 2] = "Industrial-strength EMP bomb! Knock out all electronics within 40m!";
$WeaponModeDescription[Mortar, 3] = "100 compressed reaver blasts exploding in a 20m skyline!";
$DenyMode[Heavy, Mortar, 2] = true;
$DenyMode[Heavy, Mortar, 3] = true;

$WeaponModeCount[GrenadeLauncher] = 2; 
$WeaponMode[GrenadeLauncher, 0] = "Standard";
$WeaponMode[GrenadeLauncher, 1] = "EMP";
$WeaponMode[GrenadeLauncher, 2] = "RPG";
$WeaponModeName[GrenadeLauncher] = "Grenade Launcher";
$WeaponModeSound[GrenadeLauncher] = "GrenadeReloadSound";
$WeaponModeDescription[GrenadeLauncher, 0] = "Standard explosive grenade.";
$WeaponModeDescription[GrenadeLauncher, 1] = "Normal strength EMP bomb. 15m effect radius.";
$WeaponModeDescription[GrenadeLauncher, 2] = "Rocket Propelled Grenade. Death at 360 KPH.";
$DenyMode[MagIon, GrenadeLauncher, 2] = true;
//$DenyMode[Light, GrenadeLauncher, 3] = true;

$WeaponModeCount[Disc] = 2;
$WeaponMode[Disc, 0] = "Standard";
$WeaponMode[Disc, 1] = "Turbo Disc";
$WeaponMode[Disc, 2] = "Power Disc";
$WeaponModeName[Disc] = "Spinfusor";
$WeaponModeSound[Disc] = "DiscReloadSound";
$WeaponModeDescription[Disc, 0] = "Standard destructive Tribal weapon.";
$WeaponModeDescription[Disc, 1] = "Trades power for speed. Useful against lights.";
$WeaponModeDescription[Disc, 2] = "Trades speed for power. More useful against slow moving targets.";
$DenyMode[MagIon, Disc, 2] = true;
$DenyMode[Blastech, Disc, 2] = true;

$WeaponModeCount[Plasma] = 2;
$WeaponMode[Plasma, 0] = "Standard";
$WeaponMode[Plasma, 1] = "Turbo Bolt";
$WeaponMode[Plasma, 2] = "Power Bolt";
$WeaponModeName[Plasma] = "Plasma";
$WeaponModeSound[Plasma] = "PlasmaReloadSound";
$WeaponModeDescription[Plasma, 0] = "Standard incendiary sphere launcher.";
$WeaponModeDescription[Plasma, 1] = "Trades power for speed. Useful against lights.";
$WeaponModeDescription[Plasma, 2] = "Trades speed for power. More useful against slow moving targets.";
$DenyMode[Light, Plasma, 2] = true;
$DenyMode[MagIon, Plasma, 2] = true;
$DenyMode[Blastech, Plasma, 2] = true;
$DenyMode[Medium, Plasma, 2] = true;
$DenyMode[Heavy, Plasma, 2] = true;
$DenyMode[Engineer, Plasma, 2] = true;

$WeaponModeCount[MBCannon] = 5;
$WeaponMode[MBCannon, 0] = "Standard (10)";
$WeaponMode[MBCannon, 1] = "Power Output 0.5x (5)";
$WeaponMode[MBCannon, 2] = "Power Output 2x (20)";
$WeaponMode[MBCannon, 3] = "Booster (25)";
$WeaponMode[MBCannon, 4] = "Annihalator (100)";
$WeaponMode[MBCannon, 5] = "Modulated Shield Transparency Blast (150)";
$WeaponModeName[MBCannon] = "Mitzi Blast Cannon";
$WeaponModeSound[MBCannon] = "MortarDryFireSound";
$WeaponModeDescription[MBCannon, 0] = "Standard Mitzi blast. Mitzi will damage anything.";
$WeaponModeDescription[MBCannon, 1] = "Trades power for speed. Useful against lights.";
$WeaponModeDescription[MBCannon, 2] = "Trades speed for power. More useful against slow moving targets.";
$WeaponModeDescription[MBCannon, 3] = "Boosts your target away from you.";
$WeaponModeDescription[MBCannon, 4] = "Slow-moving destructive ball of love. Here comes the SUN!";
$WeaponModeDescription[MBCannon, 5] = "This is a powerful blast that ignores shields.";
$DenyMode[MagIon, MBCannon, 2] = true;
$DenyMode[Blastech, MBCannon, 2] = true;

//$WeaponModeCount[Reaver] = 1;
//$WeaponMode[Reaver, 0] = "Explosive Flak";
//$WeaponMode[Reaver, 1] = "Incendiary Flak";
//$WeaponModeName[Reaver] = "Reaver";
//$WeaponModeSound[Reaver] = "SniperRifleDryFireSound";
//$WeaponModeDescription[Reaver, 0] = "Fires rockets that explode when near a heated enemy.";
//$WeaponModeDescription[Reaver, 1] = "Fires gasoline cartidges that explode near an enemy.";

$WeaponModeCount[ElfGun] = 3;
$WeaponMode[ElfGun, 0] = "Standard";
$WeaponMode[ElfGun, 1] = "Tractor Beam";
$WeaponMode[ElfGun, 2] = "Super Tractor";
//$WeaponMode[ElfGun, 3] = "Stasis Beam";
$WeaponMode[ElfGun, 3] = "Pull Beam"; //-Nite-
$WeaponModeName[ElfGun] = "Electron Flux";
$WeaponModeSound[ElfGun] = "ShocklanceDryFireSound";
$WeaponModeDescription[ElfGun, 0] = "Standard Energy draining beam.";
$WeaponModeDescription[ElfGun, 1] = "Allows you to hold onto players and vehicles.";
$WeaponModeDescription[ElfGun, 2] = "Pulls you toward your target.";
//$WeaponModeDescription[ElfGun, 3] = "Freezes your target in place. They cannot move, but they can turn and fire...";
$WeaponModeDescription[ElfGun, 3] = "Pulls objects towards you.";

$WeaponModeCount[MissileLauncher] = 4;
$WeaponMode[MissileLauncher, 0] = "Standard";
$WeaponMode[MissileLauncher, 1] = "EMP";
$WeaponMode[MissileLauncher, 2] = "Concussion";
$WeaponMode[MissileLauncher, 3] = "Incendiary";
$WeaponMode[MissileLauncher, 4] = "Speed";
$WeaponModeName[MissileLauncher] = "Missile Launcher";
$WeaponModeSound[MissileLauncher] = "MissileReloadSound";
$WeaponModeDescription[MissileLauncher, 0] = "Standard heatseeking missile.";
$WeaponModeDescription[MissileLauncher, 1] = "Use it against vehicles to stop them from jetting.";
$WeaponModeDescription[MissileLauncher, 2] = "Collides with the target knocking them way off course.";
$WeaponModeDescription[MissileLauncher, 3] = "Sets the vehicle on fire.";
$WeaponModeDescription[MissileLauncher, 4] = "Trades power for speed. Can usually destroy a Hover Bike.";
$DenyMode[Medium, MissileLauncher, 1] = true;
$DenyMode[Medium, MissileLauncher, 2] = true;
$DenyMode[Engineer, MissileLauncher, 2] = true;
$DenyMode[Medium, MissileLauncher, 3] = true;

//$DenyMode[Heavy, MissileLauncher, 1] = true;
//$DenyMode[Engineer, MissileLauncher, 1] = true;
//$DenyMode[Heavy, MissileLauncher, 3] = true;
//$DenyMode[Engineer, MissileLauncher, 3] = true;

if($OptionalModes[MissileLauncher])
{
   $WeaponModeCount[MissileLauncher] = 6;
   $WeaponMode[MissileLauncher, 5] = "Electro-Optical";
   $WeaponMode[MissileLauncher, 6] = "Mega";
   $WeaponModeDescription[MissileLauncher, 5] = "Normal power missile that comes with an onboard camera.";
   $WeaponModeDescription[MissileLauncher, 6] = "High-power warhead, but slow moving.";
}

$WeaponModeCount[SniperRifle] = 4;
$WeaponMode[SniperRifle, 0] = "Standard Laser";
$WeaponMode[SniperRifle, 1] = "Half-Burst Laser";
$WeaponMode[SniperRifle, 2] = "Standard 30.06";
$WeaponMode[SniperRifle, 3] = "Poison Dart";
$WeaponMode[SniperRifle, 4] = "Mass Driver";
$WeaponModeName[SniperRifle] = "Laser/30.06";
$WeaponModeSound[SniperRifle] = "SniperRifleDryFireSound";
$WeaponModeDescription[SniperRifle, 0] = "150 Megajoule laser. This aint your everyday laser pointer.";
$WeaponModeDescription[SniperRifle, 1] = "75 Megajoule laser. Half the power, half the energy!";
$WeaponModeDescription[SniperRifle, 2] = "Standard sniper shot. Headshots do more damage, while body shots don't do much.";
$WeaponModeDescription[SniperRifle, 3] = "Needs a headshot. This poisons your target.";
$WeaponModeDescription[SniperRifle, 4] = "Fires an explosive tipped bolt.";

$WeaponModeCount[Starburst] = 4;
$WeaponMode[Starburst, 0] = "Blaster";
$WeaponMode[Starburst, 1] = "Plasma Bolt";
$WeaponMode[Starburst, 2] = "Disc";
$WeaponMode[Starburst, 3] = "Grenade";
$WeaponMode[Starburst, 4] = "Ground Spray";
$WeaponModeName[Starburst] = "Starburst Cannon";
$WeaponModeSound[Starburst] = "SniperRifleDryFireSound";
$WeaponModeDescription[Starburst, 0] = "Fires a sphere of blaster bolts.";
$WeaponModeDescription[Starburst, 1] = "Extremely deadly having the ability to set objects on fire.";
$WeaponModeDescription[Starburst, 2] = "Fires several discs in a random direction.";
$WeaponModeDescription[Starburst, 3] = "Launches a cluster of grenades in a MIRV pattern.";
$WeaponModeDescription[Starburst, 4] = "Fires all projectiles in a downward spread, however not as powerful.";
$DenyMode[Medium, Starburst, 3] = true;

$WeaponModeCount[LaserCannonGun] = 2;
$WeaponMode[LaserCannonGun, 0] = "Charge";
$WeaponMode[LaserCannonGun, 1] = "Bolt";
$WeaponMode[LaserCannonGun, 2] = "Beam";
$WeaponModeName[LaserCannonGun] = "Laser Charge Cannon";
$WeaponModeSound[LaserCannonGun] = "SniperRifleDryFireSound";
$WeaponModeDescription[LaserCannonGun, 0] = "Use this mode to get power for the gun.";
$WeaponModeDescription[LaserCannonGun, 1] = "Fires a low-power laser bolt.";
$WeaponModeDescription[LaserCannonGun, 2] = "Fires a continuous laser beam that can literally cut objects.";

$WeaponModeCount[PBW] = 1;
$WeaponMode[PBW, 0] = "Particle Beam";
$WeaponMode[PBW, 1] = "Maser Beam";
$WeaponModeName[PBW] = "PBW";
$WeaponModeSound[PBW] = "DiscReloadSound";
$WeaponModeDescription[PBW, 0] = "Blow your enemies to tiny bits and pieces by accelerating particles!";
$WeaponModeDescription[PBW, 1] = "Maser (\"Microwave Laser\"). Basically an instant hit plasma beam.";

$WeaponModeCount[GatPBW] = 0;    //hehehhehehehe
$WeaponMode[GatPBW, 0] = "Particle Beam";
$WeaponMode[GatPBW, 1] = "??? Beam";
$WeaponModeName[GatPBW] = "Turbo-Electric Cat Zapper X-2000";
$WeaponModeSound[GatPBW] = "DiscReloadSound";
$WeaponModeDescription[GatPBW, 0] = "Blow your kittens to tiny bits and pieces by accelerating particles!";
$WeaponModeDescription[GatPBW, 1] = "Blow your kittens to tiny bits and pieces.";

// --- Added for the RMS Silo per Death~Bot (ST)
$WeaponModeCount[IonTAGGun] = 1;
$WeaponMode[IonTAGGun, 0] = "Ion Cannon";
$WeaponMode[IonTAGGun, 1] = "RMS Silo";
$WeaponModeName[IonTAGGun] = "MANTA Tagger";
$WeaponModeSound[IonTAGGun] = "";
$WeaponModeDescription[IonTAGGun, 0] = "Condensed orb of positively charged death from the eye in the sky!!";
$WeaponModeDescription[IonTAGGun, 1] = "Devastating rainstorm of missiles fired from a remote silo.";

$WeaponModeCount[BarrelSwapper] = 9;
$WeaponMode[BarrelSwapper, 0] = "AA";
$WeaponMode[BarrelSwapper, 1] = "ELF";
$WeaponMode[BarrelSwapper, 2] = "Missile";
$WeaponMode[BarrelSwapper, 3] = "Mortar";
$WeaponMode[BarrelSwapper, 4] = "Plasma";
$WeaponMode[BarrelSwapper, 5] = "Disc";
$WeaponMode[BarrelSwapper, 6] = "Energy";
$WeaponMode[BarrelSwapper, 7] = "Bolter"; //MrKeen - chaingun
$WeaponMode[BarrelSwapper, 8] = "Flame(RAXX)";
$WeaponMode[BarrelSwapper, 9] = "Mitzi";
$WeaponModeName[BarrelSwapper] = "Barrel Swapper";
$WeaponModeSound[BarrelSwapper] = "";
$WeaponModeDescription[BarrelSwapper, 0] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 1] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 2] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 3] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 4] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 5] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 6] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 7] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 8] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 9] = "Can be mounted on any turret base or on the Wolfhound.";

$WeaponModeCount[VehicleAugmenter] = 11;   //-Nite- removed Bombs  reordered.
$WeaponMode[VehicleAugmenter, 0] = "V] Sensor Jammer";
$WeaponMode[VehicleAugmenter, 1] = "V] Inertial Dampener";
$WeaponMode[VehicleAugmenter, 2] = "V] Lava Shield";
$WeaponMode[VehicleAugmenter, 3] = "V] Dual Fusion Reactor";
$WeaponMode[VehicleAugmenter, 4] = "PV] Booster Rocket";
$WeaponMode[VehicleAugmenter, 5] = "PV] Stasis Device";
$WeaponMode[VehicleAugmenter, 6] = "PV] Self Destruct Bomb";
$WeaponMode[VehicleAugmenter, 7] = "PV] Flare Launcher";
$WeaponMode[VehicleAugmenter, 8] = "S/M] Energy"; // MrKeen
//$WeaponMode[VehicleAugmenter, 9] = "S] Bomb"; -Nite-
$WeaponMode[VehicleAugmenter, 9] = "S/M] Chaingun";
$WeaponMode[VehicleAugmenter, 10] = "S] Metaphasic Shield Transpacency";
$WeaponMode[VehicleAugmenter, 11] = "S/M] MetaLaser";
//$WeaponMode[VehicleAugmenter, 12] = "";
$WeaponModeName[VehicleAugmenter] = "Vehicle Augmenter";
$WeaponModeSound[VehicleAugmenter] = "";
$WeaponModeDescription[VehicleAugmenter, 0] = "Block out all turret sensors. Heat locks can still be attained.";
$WeaponModeDescription[VehicleAugmenter, 1] = "Negates any concussive forces applied on the vehicle.";
$WeaponModeDescription[VehicleAugmenter, 2] = "Lets you travel through lava as if it were water.";
$WeaponModeDescription[VehicleAugmenter, 3] = "Adds a 2nd fusion reactor for increased energy recharge.";
$WeaponModeDescription[VehicleAugmenter, 4] = "Press the pack key to use a solid rocket. Limited supply.";
$WeaponModeDescription[VehicleAugmenter, 5] = "Allows you to stay suspended as long as you have energy.";
$WeaponModeDescription[VehicleAugmenter, 6] = "Causes your vehicle to explode. Damage depends on the vehicle.";
$WeaponModeDescription[VehicleAugmenter, 7] = "Launchers a flare that will throw off a missile. Limited supply.";
$WeaponModeDescription[VehicleAugmenter, 8] = "Allows the Shrike or Marantz to fire Energy Cannons.";
//$WeaponModeDescription[VehicleAugmenter, 9] = "Allows the Shrike to drop Bombs.";
$WeaponModeDescription[VehicleAugmenter, 9] = "Allows the Shrike or Marantz to fire Chainguns.";
$WeaponModeDescription[VehicleAugmenter, 10] = "Allows the Shrike to fire Metaphasic Shield Transpacency blasts.";
$WeaponModeDescription[VehicleAugmenter, 11] = "Allows the Shrike or Marantz to fire MetaLasers.";
//$WeaponModeDescription[VehicleAugmenter, 12] = "";
$RestrictVehicleMode[ScoutFlyer, 0] = true;
$RestrictVehicleMode[tPOC, 0] = true;
$RestrictVehicleMode[ScoutFlyer, 6] = true;
$RestrictVehicleMode[tPOC, 6] = true;

function changeWeaponMode(%obj)
{
   if(%obj.getMountedImage(0) != 0)
   {
      %weapon = %obj.getMountedImage(0).item;
      if($WeaponModeCount[%weapon])
      {
         %armor = %obj.getArmorSize();

         %obj.play3D($WeaponModeSound[%weapon]);
         if(%obj.client.mode[%weapon] >= $WeaponModeCount[%weapon])
            %obj.client.mode[%weapon] = -1;

         %obj.client.mode[%weapon]++;

         if($DenyMode[%armor, %weapon, %obj.client.mode[%weapon]]) // MrKeen - still dynamic ;)
         {
            if(%obj.client.mode[%weapon] >= $WeaponModeCount[%weapon])
               %obj.client.mode[%weapon] = -1;

            %obj.client.mode[%weapon]++;

            bottomPrint(%obj.client, "<color:ffffff>[Mode "@%obj.client.mode[%weapon]+1@"/"@$WeaponModeCount[%weapon]+1@"] <color:42dbea>"@$WeaponModeName[%weapon]@" -> "@$WeaponMode[%weapon, %obj.client.mode[%weapon]] NL $WeaponModeDescription[%weapon, %obj.client.mode[%weapon]] NL "<color:ffff00>Last weapon mode was not avaliable for your current armor, switched to next mode.", $ChangeWepTime+2, 3);
            %weapon.onCycleMode(%obj, %obj.client.mode[%weapon]);

            return;
         }

         bottomPrint(%obj.client, "<color:ffffff>[Mode "@%obj.client.mode[%weapon]+1@"/"@$WeaponModeCount[%weapon]+1@"] <color:42dbea>"@$WeaponModeName[%weapon]@" -> "@$WeaponMode[%weapon, %obj.client.mode[%weapon]] NL $WeaponModeDescription[%weapon, %obj.client.mode[%weapon]], $ChangeWepTime, 2);
         %weapon.onCycleMode(%obj, %obj.client.mode[%weapon]);
      }
      else
         bottomPrint(%obj.client, "This weapon does not have any fire modes.", $ChangeWepTime, 1);
   }
}
//-Nite- & SouthTown This so far works pretty well
//All thats really needed is a new bottom print for when they mount the
//weapon.(which mode they dont have access too) Stuff.
// Place in functions changeWeaponmode and weaponONmount
//function findArmorMode(%obj)
//{
//   %armor = %obj.getArmorSize();    //get armor size
//   %weapon = %obj.getMountedImage(0).item;  //get weapon
//   %mode = %obj.client.mode[%weapon];      //get mode of weapon
//
//   if(%armor $= "MagIon")      // if i am ion and
//   {
//   if(%weapon $= "Disc" && %mode == 2)   //if i am using Disc
//         %obj.client.mode[%weapon] = 0; // skip mode 2
//   else if(%weapon $= "Chaingun" && %mode == 1) // just an example
//         %obj.client.mode[%weapon]++; // skip mode 1
//   else if(%weapon $= "MBCannon" && %mode == 4)
//         %obj.client.mode[%weapon] = 0;  // goto 1
//   else if(%weapon $= "MBCannon" && %mode == 5)
//         %obj.client.mode[%weapon] = 0;  //goto 1
//   }
//    bottomPrint(%obj.client, "<color:ffffff>[Mode "@%obj.client.mode[%weapon]+1@"/"@$WeaponModeCount[%weapon]+1@"] <color:42dbea>"@$WeaponModeName[%weapon]@" -> "@$WeaponMode[%weapon, %obj.client.mode[%weapon]] NL $WeaponModeDescription[%weapon, %obj.client.mode[%weapon]], $ChangeWepTime, 2);
//   else if(%armor $= "BattleAngel") // just an example
//   {
//      if(%weapon $= "whatever" && %mode == 0)
//         %client.mode[%weapon]++; // skip mode 0
//   }
//}
//}
// MrKeen - Sorry guys, but this method is directly integrated into the mode change code, and your code didn't account for mode keys (directModifyMode())

function directModifyWeaponMode(%cl, %mode)
{
   if(%cl.player.getMountedImage(0) != 0)
   {
      %obj = %cl.player;
      %weapon = %obj.getMountedImage(0).item;
      %armor = %obj.getArmorSize();

      if($WeaponModeCount[%weapon])
      {
         if($DenyMode[%armor, %weapon, %mode]) // MrKeen - still dynamic ;)
         {
            bottomPrint(%obj.client, "The mode you selected for this weapon on your current armor is not avaliable.", $ChangeWepTime, 1);
            return;
         }
         else
         {
            if(%mode <= $WeaponModeCount[%weapon])
            {
               %obj.play3D($WeaponModeSound[%weapon]);
               %obj.client.mode[%weapon] = %mode;
               bottomPrint(%obj.client, "<color:ffffff>[Mode "@%obj.client.mode[%weapon]+1@"/"@$WeaponModeCount[%weapon]+1@"] <color:42dbea>"@$WeaponModeName[%weapon]@" -> "@$WeaponMode[%weapon, %obj.client.mode[%weapon]] NL $WeaponModeDescription[%weapon, %obj.client.mode[%weapon]], $ChangeWepTime, 2);
               %weapon.onCycleMode(%obj, %obj.client.mode[%weapon]);
            }
            else
               bottomPrint(%obj.client, "This weapon only has "@$WeaponModeCount[%weapon]+1@" fire modes.", $ChangeWepTime, 1);
         }
      }
      else
         bottomPrint(%obj.client, "This weapon does not have any fire modes.", $ChangeWepTime, 1);
   }
}

function serverCmdSelectWeaponSlot(%client, %data)
{
   if(%client.modekeys)
      directModifyWeaponMode(%client, %data);
   else
      %client.getControlObject().selectWeaponSlot( %data );
}

function ItemData::onCycleMode(%weapon, %obj, %mode)
{
   // dummy to eliminate console spam
}

function Starburst::onCycleMode(%weapon, %obj, %mode)
{
   if(%mode <= 1)
   {
      %obj.mountImage(SBDecalAImage, 4);
      %obj.mountImage(SBDecalBImage, 5);
   }
   else
   {
      %obj.mountImage(SBDecalAImage, 4);
      %obj.mountImage(SBDecalB2Image, 5);
   }
}
 //-Nite-
$maxThrowStr = 2.5; // New throw str features

function serverCmdEndThrowCount(%client, %data)
{
   if(%client.player.throwStart == 0)
      return;

   // ---------------------------------------------------------------
   // z0dd - ZOD, 8/6/02. New throw str features
   %throwStrength = (getSimTime() - %client.player.throwStart) / 150;
   if(%throwStrength > $maxThrowStr)
      %throwStrength = $maxThrowStr;
   else if(%throwStrength < 0.5)
      %throwStrength = 0.5;
   // ---------------------------------------------------------------

   %throwScale = %throwStrength / 2;
   %client.player.throwStrength = %throwScale;

   %client.player.throwStart = 0;
}

