if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// ------------------------------------------------------------------
// Magnetic Ion Reactor/Heatshield Pack

datablock ShapeBaseImageData(MagHeatDecalImage)
{
   mountPoint = 1;
   shapeFile = "ammo_plasma.dts";
   offset = "0 -0.2 -0.6";
   emap = 1;
};

datablock ShapeBaseImageData(MagIonHeatPackImage)
{
   shapeFile = "pack_upgrade_energy.dts";
   item = MagIonHeatPack;
   mountPoint = 1;
   offset = "0 0.1 0.2";
   emap = 1;

	stateName[0] = "default";
	stateSequence[0] = "activate";
};

datablock ItemData(MagIonHeatPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_upgrade_energy.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "MagIonHeatPackImage";
   pickUpName = "a heatshield/reactor";
};

function magHeatShield(%obj)
{
   if(%obj.pack $= "HeatShieldPack")
   {
      %obj.setHeat(0);
      schedule(250, 0, "magHeatShield", %obj);
   }
}

function MagIonHeatPackImage::onMount(%data, %obj, %node)
{
   %obj.enPack = true;
   %obj.pack = "HeatShieldPack";
	%obj.setRechargeRate(0.4);
   %obj.mountImage(MagHeatDecalImage, 7);
   magHeatShield(%obj);
}

function MagIonHeatPackImage::onUnmount(%data, %obj, %node)
{
   %obj.enPack = false;
   %obj.unmountImage(7);
	%obj.setRechargeRate(0); //%obj.getRechargeRate() - %obj.enpackRate);     // enpack bug
   %obj.pack = "";
}

function MagIonHeatPack::onPickup(%this, %obj, %shape, %amount)
{
   // created to prevent console errors
}
