if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// ------------------------------------------------------------------
// Magnetic Ion Reactor Pack

datablock ShapeBaseImageData(MagDecalImage)
{
   mountPoint = 1;
   shapeFile = "pack_upgrade_energy.dts";
   offset = "0 0.1 -0.2";
   rotation = "0 1 0 180";
   emap = 1;
};

datablock ShapeBaseImageData(MagIonPackImage)
{
   shapeFile = "pack_upgrade_energy.dts";
   item = MagIonPack;
   mountPoint = 1;
   offset = "0 0.1 0.2";
   emap = 1;

	stateName[0] = "default";
	stateSequence[0] = "activate";
};

datablock ItemData(MagIonPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_upgrade_energy.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "MagIonPackImage";
   pickUpName = "a reactor";
};

function MagIonPackImage::onMount(%data, %obj, %node)
{
   %obj.enPack = true;
	%obj.setRechargeRate(0.575);
   %obj.mountImage(MagDecalImage, 7);
}

function MagIonPackImage::onUnmount(%data, %obj, %node)
{
   %obj.enPack = false;
   %obj.unmountImage(7);
	%obj.setRechargeRate(0); //%obj.getRechargeRate() - %obj.enpackRate);     // enpack bug
}

function MagIonPack::onPickup(%this, %obj, %shape, %amount)
{
   // created to prevent console errors
}
