if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// ------------------------------------------------------------------
// HeatShield PACK
// can be used by any armor type

datablock ShapeBaseImageData(HSDecalImage)
{
   mountPoint = 1;
   shapeFile = "ammo_plasma.dts";
   offset = "0.2 -0.2 -0.6";
//   rotation = "0 1 0 90";
   emap = 1;
};

datablock ShapeBaseImageData(HeatShieldPackImage)
{
   shapeFile = "ammo_plasma.dts";
   item = HeatShieldPack;
   mountPoint = 1;
   offset = "-0.2 -0.2 -0.6";
   emap = 1;

   stateName[0] = "default";
   stateSequence[0] = "ambient";
};

datablock ItemData(HeatShieldPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "ammo_plasma.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "HeatShieldPackImage";
	pickUpName = "a heatshield pack";
};

function heatshield(%obj)
{
     if(%obj.pack $= "HeatShieldPack")
     {
          %obj.setHeat(0);
          schedule(250, 0, "heatshield", %obj);
     }
}

function HeatShieldPackImage::onMount(%data, %obj, %node)
{
     %obj.mountImage(HSDecalImage, 7);
     %obj.pack = "HeatShieldPack";
     heatshield(%obj);
}

function HeatShieldPackImage::onUnmount(%data, %obj, %node)
{
    %obj.pack = "";
    %obj.unmountImage(7);
}

function HeatShieldPack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

