if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------------------------------------------
// Stasis Module
//--------------------------------------------------------------------------

function CloakModImage::onActivate(%data, %obj, %slot)
{
   AttemptAugmentVehicle(%data, %obj, %slot);
}

function CloakModImage::onDeactivate(%data, %obj, %slot)
{
	%obj.setImageTrigger($BackpackSlot, false);
}

function CloakMod::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

function CloakModImage::ApplyMod(%datablock, %player, %vehicle)
{
     %player.setInventory("CloakMod", 0);
     %vehicle.augmented = true;
     %vehicle.augType = "Stasis Device";
     %vehicle.augName = "Cloak";
}

function InitCloakMod(%obj)
{
   if(%obj.patr == 1)
   {
      %obj.patr = 0;
      return;
   }
   else
   {
      %obj.patr = 1;
      LoopStasisMod(%obj);
   }
}

function LoopStasisMod(%obj)
{
    if(isObject(%obj))
    {
        if(%obj.getEnergyLevel() > 10 && %obj.patr == 1)
        {
            %obj.useEnergy(4.5);
            %obj.setFrozenState(true);
            schedule(100, 0, "LoopStasisMod", %obj);
        }
        else
        {
            %obj.patr = 0;
            %obj.setFrozenState(false);
        }
    }
}

