if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------------------------------------------
// Sensor Jammer Module
//--------------------------------------------------------------------------

function SensorJamModImage::onActivate(%data, %obj, %slot)
{
   AttemptAugmentVehicle(%data, %obj, %slot);
}

function SensorJamModImage::onDeactivate(%data, %obj, %slot)
{
	%obj.setImageTrigger($BackpackSlot, false);
}

function SensorJamMod::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

datablock SensorData(VehicleJammerSensor)
{
   detects = true;
   detectsUsingLOS = false;
   detectsPassiveJammed = false;
   detectsActiveJammed = false;
   detectsCloaked = false;
   detectionPings = false;
   detectRadius = 45;
   
   jams = true;
   jamsOnlyGroup = false;
   jamsUsingLOS = false;
   jamRadius = 50;
};

function delHeatLoop(%obj)
{
   if(isObject(%obj))
   {
      %obj.setHeat(0);
      schedule(100, 0, delHeatLoop, %obj);
   }
}

function SensorJamModImage::ApplyMod(%datablock, %player, %vehicle)
{
     %player.setInventory("SensorJamMod", 0);
     %vehicle.augmented = true;
     %vehicle.augType = "Turret / Sensor Jammer";
     %vehicle.isJammed = true;
//     delHeatLoop(%vehicle);

     setTargetSensorData(%vehicle.target, VehicleJammerSensor);
}
