if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

function ScoutFlyer::onTrigger(%data, %obj, %trigger, %state)
{
     if(%trigger == 0)
     {
          if(%obj.selectedWeapon == 1)
          {
               %obj.setImageTrigger(5, false);
               %obj.setImageTrigger(6, false);

               switch(%state)
               {
                   case 0:
                   %obj.fireWeapon = false;
                   %obj.setImageTrigger(2, false);
                   %obj.setImageTrigger(3, false);
                   case 1:
                   %obj.fireWeapon = true;
                   if(%obj.nextWeaponFire == 2)
                   {
                         %obj.setImageTrigger(2, true);
                         %obj.setImageTrigger(3, false);
                   }
                   else
                   {
                         %obj.setImageTrigger(2, false);
                         %obj.setImageTrigger(3, true);
                   }
               }
          }
          else
          {
               %obj.setImageTrigger(2, false);
               %obj.setImageTrigger(3, false);

               switch(%state)
               {
                   case 0:
                   %obj.fireWeapon = false;
                   %obj.setImageTrigger(5, false);
                   %obj.setImageTrigger(6, false);
                   case 1:
                   %obj.fireWeapon = true;
                   if(%obj.nextWeaponFire == 5)
                   {
                         %obj.setImageTrigger(5, true);
                         %obj.setImageTrigger(6, false);
                   }
                   else
                   {
                         %obj.setImageTrigger(5, false);
                         %obj.setImageTrigger(6, true);
                   }
               }
          }
     }
}

function ScoutFlyer::playerDismounted(%data, %obj, %player)
{
   %obj.fireWeapon = false;
   %obj.setImageTrigger(2, false);
   %obj.setImageTrigger(3, false);
   %obj.setImageTrigger(5, false);
   %obj.setImageTrigger(6, false);

   if(%player.isCloaked())
      %player.setCloaked(false);

   setTargetSensorGroup(%obj.getTarget(), %obj.team);
}

function ScoutChaingunImage::onFire(%data,%obj,%slot)
{
   // obj = ScoutFlyer object number
   // slot = 2

   Parent::onFire(%data,%obj,%slot);
   %obj.nextWeaponFire = 6;
   schedule(%data.fireTimeout, 0, "fireNextGun", %obj);
}

function ScoutChaingunPairImage::onFire(%data,%obj,%slot)
{
   // obj = ScoutFlyer object number
   // slot = 3

   Parent::onFire(%data,%obj,%slot);
   %obj.nextWeaponFire = 5;
   schedule(%data.fireTimeout, 0, "fireNextGun", %obj);
}
