if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------
// Particle Accelerator Cannon
//--------------------------------------

datablock AudioProfile(PACFireSound)
{
   filename    = "fx/vehicles/bomber_turret_fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(PACChargeSound)
{
   filename    = "fx/weapons/ELF_fire.wav";
   description = CloseLooping3d;
   preload = true;
};

function ChargeFXBolt1::onExplode(%data, %proj, %pos, %mod)
{
      RadiusExplosion(%proj, %pos, %proj.radius, %proj.damage, %proj.kick, %proj.sourceObject, %proj.radiusDamageType);
}

function ChargeFXBolt2::onExplode(%data, %proj, %pos, %mod)
{
      RadiusExplosion(%proj, %pos, %proj.radius, %proj.damage, %proj.kick, %proj.sourceObject, %proj.radiusDamageType);
}

function ChargeFXBolt3::onExplode(%data, %proj, %pos, %mod)
{
      RadiusExplosion(%proj, %pos, %proj.radius, %proj.damage, %proj.kick, %proj.sourceObject, %proj.radiusDamageType);
}

function ChargeFXBolt4::onExplode(%data, %proj, %pos, %mod)
{
      RadiusExplosion(%proj, %pos, %proj.radius, %proj.damage, %proj.kick, %proj.sourceObject, %proj.radiusDamageType);
}

function ChargeFXBolt5::onExplode(%data, %proj, %pos, %mod)
{
      RadiusExplosion(%proj, %pos, %proj.radius, %proj.damage, %proj.kick, %proj.sourceObject, %proj.radiusDamageType);
}

function ChargeFXBolt6::onExplode(%data, %proj, %pos, %mod)
{
      RadiusExplosion(%proj, %pos, %proj.radius, %proj.damage, %proj.kick, %proj.sourceObject, %proj.radiusDamageType);
}

function ChargeFXBolt7::onExplode(%data, %proj, %pos, %mod)
{
      RadiusExplosion(%proj, %pos, %proj.radius, %proj.damage, %proj.kick, %proj.sourceObject, %proj.radiusDamageType);
}

function ChargeFXBolt8::onExplode(%data, %proj, %pos, %mod)
{
      RadiusExplosion(%proj, %pos, %proj.radius, %proj.damage, %proj.kick, %proj.sourceObject, %proj.radiusDamageType);
}

function ChargeFXBolt9::onExplode(%data, %proj, %pos, %mod)
{
      RadiusExplosion(%proj, %pos, %proj.radius, %proj.damage, %proj.kick, %proj.sourceObject, %proj.radiusDamageType);
}

function ChargeFXBolt10::onExplode(%data, %proj, %pos, %mod)
{
      RadiusExplosion(%proj, %pos, %proj.radius, %proj.damage, %proj.kick, %proj.sourceObject, %proj.radiusDamageType);
}

function ChargeFXBolt11::onExplode(%data, %proj, %pos, %mod)
{
      RadiusExplosion(%proj, %pos, %proj.radius, %proj.damage, %proj.kick, %proj.sourceObject, %proj.radiusDamageType);
}

function ChargeFXBolt12::onExplode(%data, %proj, %pos, %mod)
{
      RadiusExplosion(%proj, %pos, %proj.radius, %proj.damage, %proj.kick, %proj.sourceObject, %proj.radiusDamageType);
}

datablock LinearFlareProjectileData(ChargeFXBolt1)
{
   explosion           = "MiniPlasmaExplosion";
   splash              = DiscSplash;

   dryVelocity       = 150.0;
   wetVelocity       = 150.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 3500;
   lifetimeMS        = 3500;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = -1;

   activateDelayMS = -1;

   scale             = "1.0 1.0 1.0";
   numFlares         = 30;
   flareColor        = "0.5 0.32 0.5";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "special/shrikeBoltCross";
};

datablock LinearFlareProjectileData(ChargeFXBolt1x)
{
   explosion           = "SuperPlasmaExplosion";
   splash              = DiscSplash;

   dryVelocity       = 150.0;
   wetVelocity       = 150.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 3500;
   lifetimeMS        = 3500;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = -1;

   activateDelayMS = -1;

   scale             = "1.0 1.0 1.0";
   numFlares         = 30;
   flareColor        = "0.5 0.32 0.5";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "special/shrikeBoltCross";
};

datablock LinearFlareProjectileData(ChargeFXBolt2) : ChargeFXBolt1
{
   dryVelocity       = 145.0;
   wetVelocity       = 140.0;
   scale             = "2.0 2.0 2.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt3) : ChargeFXBolt1
{
   dryVelocity       = 140.0;
   wetVelocity       = 130.0;
   scale             = "3.0 3.0 3.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt4) : ChargeFXBolt1
{
   dryVelocity       = 135.0;
   wetVelocity       = 120.0;
   scale             = "4.0 4.0 4.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt5) : ChargeFXBolt1
{
   dryVelocity       = 130.0;
   wetVelocity       = 110.0;
   scale             = "5.0 5.0 5.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt6) : ChargeFXBolt1
{
   dryVelocity       = 125.0;
   wetVelocity       = 100.0;
   scale             = "6.0 6.0 6.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt7) : ChargeFXBolt1x
{
   dryVelocity       = 120.0;
   wetVelocity       = 90.0;
   scale             = "7.0 7.0 7.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt8) : ChargeFXBolt1x
{
   dryVelocity       = 115.0;
   wetVelocity       = 80.0;
   scale             = "8.0 8.0 8.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt9) : ChargeFXBolt1x
{
   dryVelocity       = 110.0;
   wetVelocity       = 70.0;
   scale             = "9.0 9.0 9.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt10) : ChargeFXBolt1x
{
   dryVelocity       = 105.0;
   wetVelocity       = 60.0;
   scale             = "10.0 10.0 10.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt11) : ChargeFXBolt1x
{
   dryVelocity       = 100.0;
   wetVelocity       = 50.0;
   scale             = "11.0 11.0 11.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt12) : ChargeFXBolt1x
{
   dryVelocity       = 75.0;
   wetVelocity       = 40.0;
   scale             = "12.0 12.0 12.0";
};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(PACCapacitor)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_grenade.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a particle accelerator capacitor";
   cantPickup = true;

   emap = true;
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(PAC)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_energy.dts";
   image = PACImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a particle accelerator cannon (PAC)";
};

datablock ShapeBaseImageData(PACImage)
{
   className = WeaponImage;
   shapeFile = "weapon_repair.dts";
   item = PAC;
   ammo = PACCapacitor;
//   offset = "0 0 0";
   emap = true;

   offset = "0 0.2 -0.3";
   emap = true;
   usesEnergy = true;
   minEnergy = -1;

   stateName[0]                     = "Activate";
   stateSequence[0]                 = "Activate";
	stateSound[0]                    = TargetingLaserSwitchSound;
   stateTimeoutValue[0]             = 0.5;
   stateTransitionOnTimeout[0]      = "Ready";

   stateName[1]                     = "Ready";
   stateTransitionOnTriggerDown[1]  = "Fire";

   stateName[2]                     = "Fire";
   stateFire[2]                     = true;
   stateAllowImageChange[2]         = false;
	stateSound[2]                    = PACChargeSound;
   stateScript[2]                   = "onFire";
   stateTransitionOnTriggerUp[2]    = "Deconstruction";

   stateName[3]                     = "Deconstruction";
   stateScript[3]                   = "onRelease";
   stateTimeoutValue[3]             = 0.5;
   stateTransitionOnTimeout[3]      = "Ready";
};

datablock ShapeBaseImageData(PACDecalAImage)
{
   shapeFile = "weapon_elf.dts";
   offset = "0 0 0";
   rotation = "0 1 0 180";
};

datablock ShapeBaseImageData(PACDecalBImage)
{
   shapeFile = "weapon_elf.dts";
   offset = "0 0 0";
   rotation = "0 1 0 60";
};

datablock ShapeBaseImageData(PACDecalCImage)
{
   shapeFile = "weapon_elf.dts";
   offset = "0 0 0";
   rotation = "0 1 0 -60";
};

function PACImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.mountImage(PACDecalAImage, 4);
   %obj.mountImage(PACDecalBImage, 5);
   %obj.mountImage(PACDecalCImage, 6);
   %obj.cl_CLOnHand = %obj.getMountedImage(0);
}

function PACImage::onUnmount(%this,%obj,%slot)
{
   Parent::onUnmount(%this, %obj, %slot);
   %obj.unmountImage(4);
   %obj.unmountImage(5);
   %obj.unmountImage(6);
}

function CLFire(%data, %player, %charge, %CL, %radius, %isCL, %dmg)
{
   %data.lightStart = getSimTime();

   if(!%player.getMountedImage(0) == %isCL)
        return false;

     if(%charge <= 15)
          %chgProj = "ChargeFXBolt1";
     else if(%charge <= 25)
          %chgProj = "ChargeFXBolt2";
     else if(%charge <= 45)
          %chgProj = "ChargeFXBolt3";
     else if(%charge <= 55)
          %chgProj = "ChargeFXBolt4";
     else if(%charge <= 65)
          %chgProj = "ChargeFXBolt5";
     else if(%charge <= 70)
          %chgProj = "ChargeFXBolt6";
     else if(%charge <= 85)
          %chgProj = "ChargeFXBolt7";
     else if(%charge <= 90)
          %chgProj = "ChargeFXBolt8";
     else if(%charge <= 115)
          %chgProj = "ChargeFXBolt9";
     else if(%charge <= 130)
          %chgProj = "ChargeFXBolt10";
     else if(%charge <= 145)
          %chgProj = "ChargeFXBolt11";
     else
          %chgProj = "ChargeFXBolt12";

   %p = new LinearFlareProjectile()
   {
          dataBlock        = %chgProj;
          initialDirection = %player.getMuzzleVector(%CL);
          initialPosition  = %player.getMuzzlePoint(%CL);
          sourceObject     = %player;
          sourceSlot       = %CL;
          radius           = %radius;
          damage           = %dmg;
          kick             = (%charge*15);
          scale            = %scale;
          radiusDamageType = $DamageType::PAC;
          vehicleObject    = 0;
   };

     %player.lastProjectile = %p;
     MissionCleanup.add(%p);

     %p.radius = %radius;
     %p.damage = %dmg;
     %p.kick = (%charge*15);
     %p.setScale(%scale);
     %player.setInventory(%data.ammo,0);     // start from scratch
     %player.applyKick(%charge*-27.5);

//   %q = new LinearFlareProjectile()
//   {
//          dataBlock        = %chgProj;
//          initialDirection = %player.getMuzzleVector(%CL);
//          initialPosition  = %player.getMuzzlePoint(%CL);
//          sourceObject     = %player;
//          sourceSlot       = %CL;
//          vehicleObject    = 0;
//   };
//   MissionCleanup.add(%q);


   // AI hook
   if(%player.client)
      %player.client.projectile = %p;

//   %player.getMountedImage(4).playThread(0, "spin");
   serverPlay3D(PulseCannonFire, %player.getTransform()); //PACFireSound, %player.getTransform());
}

function CLCharge(%data, %player, %CL)       // should work....
{
     if(!isObject(%player))
          return;

     %ammo = %player.getInventory(%data.ammo);
     %ammoMax = %player.getDatablock().max["PACCapacitor"];
     %CLOnHand = %player.cl_CLOnHand;

     if(%player.CL)
     {
          if(%player.getMountedImage(0) == %CLOnHand)
          {
            if(!%player.isEMP)
            {
               %q = new ShockLanceProjectile()
               {
                  dataBlock        = "BasicShocker";
                  initialDirection = %player.getMuzzleVector(0);
                  initialPosition  = %player.getMuzzlePoint(0);
                  sourceObject     = %player;
                  sourceSlot       = 0;
               };
               MissionCleanup.add(%q);

               %player.incInventory(PACCapacitor, 1);

               if(%ammo > %ammoMax)
                    %ammo = %ammoMax;   // quick non-overcharge hack
            }
            else
               %player.setInventory(PACCapacitor, 0);

               if(%player.isSyn)
                    schedule(100, 0, "CLCharge", %data, %player, %CL);
               else
                    schedule(200, 0, "CLCharge", %data, %player, %CL);
          }
     }
     else
     {
          if(%player.getMountedImage(0) == %CLOnHand)
          {
               %radius = %ammo * 0.123; //0.157
               %dmg = %ammo / 85; // MrKeen
               CLFire(%data, %player, %ammo, %CL, %radius, %CLOnHand, %dmg);
               return;
          }
     }
}

$PAC::ChargeDrain = 0.15;

function PACImage::onFire(%data,%obj,%slot) // Uses CL(tm) code
{
   if(getSightInfo(%obj, 1, $TypeMasks::ForceFieldObjectType))
      return;

     if(!%obj.CL || !%obj.CL == true)
     {
//          %obj.setRechargeRate(%obj.getRechargeRate() - $PAC::ChargeDrain); // MrKeen
          %ammo = %obj.getInventory(%data.ammo);
          %ammoMax = %obj.getDatablock().max["PACCapacitor"];

          %obj.CL = true;
          %obj.incInventory(PACCapacitor, 1);

          if(%obj.isSyn)
               schedule(50, 0, "CLCharge", %data, %obj, %slot);
          else
               schedule(100, 0, "CLCharge", %data, %obj, %slot);
     }
}

function PACImage::onRelease(%data,%obj,%slot)
{
     %obj.CL = false;
//     %obj.setRechargeRate(%obj.getRechargeRate() + $PAC::ChargeDrain);
}

