if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// MD2 External Datafile

// String Table
$ChangeWepTime = 3;

$InvBanList[DM, "ShieldGeneratorPack"] = 1;
$InvBanList[DM, "VehiclePadPack"] = 1;
$InvBanList[DM, "DefenderDesignator"] = 1;
$InvBanList[DM, "SlipstreamPack"] = 1;
$InvBanList[DM, "DetPack"] = 1;
$InvBanList[DM, "DeployableGeneratorPack"] = 1;
$InvBanList[DM, "DeployableInvHumanPack"] = 1;
$InvBanList[DM, "TurretBasePack"] = 1;
$InvBanList[DM, "ShieldBeaconPack"] = 1;
$InvBanList[DM, "TelePack"] = 1;
$InvBanList[DM, "BorgCubePack"] = 1;
$InvBanList[DM, "DefenseBasePack"] = 1;
$InvBanList[DM, "RepulsorBeaconPack"] = 1;
$InvBanList[DM, "TeamchatBeaconPack"] = 1;
$InvBanList[DM, "HoverBasePack"] = 1;
$InvBanList[DM, "LargeMine"] = 1;
$InvBanList[DM, "CloakMine"] = 1;
$InvBanList[DM, "EMPMine"] = 1;
$InvBanList[DM, "IncendiaryMine"] = 1;
$InvBanList[DM, "BlastWallPack"] = 1;
$InvBanList[DM, "BlastDoorPack"] = 1;
$InvBanList[DM, "DeployableSentryPack"] = 1;
$InvBanList[DM, "LaserSentryPack"] = 1;

$InvBanList[Hunters, "ShieldGeneratorPack"] = 1;
$InvBanList[Hunters, "VehiclePadPack"] = 1;
$InvBanList[Hunters, "DefenderDesignator"] = 1;
$InvBanList[Hunters, "SlipstreamPack"] = 1;
$InvBanList[Hunters, "DetPack"] = 1;
$InvBanList[Hunters, "DeployableGeneratorPack"] = 1;
$InvBanList[Hunters, "DeployableInvHumanPack"] = 1;
$InvBanList[Hunters, "TurretBasePack"] = 1;
$InvBanList[Hunters, "ShieldBeaconPack"] = 1;
$InvBanList[Hunters, "TelePack"] = 1;
$InvBanList[Hunters, "BorgCubePack"] = 1;
$InvBanList[Hunters, "DefenseBasePack"] = 1;
$InvBanList[Hunters, "RepulsorBeaconPack"] = 1;
$InvBanList[Hunters, "TeamchatBeaconPack"] = 1;
$InvBanList[Hunters, "HoverBasePack"] = 1;
$InvBanList[Hunters, "LargeMine"] = 1;
$InvBanList[Hunters, "CloakMine"] = 1;
$InvBanList[Hunters, "EMPMine"] = 1;
$InvBanList[Hunters, "IncendiaryMine"] = 1;
$InvBanList[Hunters, "BlastWallPack"] = 1;
$InvBanList[Hunters, "BlastDoorPack"] = 1;
$InvBanList[Hunters, "DeployableSentryPack"] = 1;
$InvBanList[Hunters, "LaserSentryPack"] = 1;

$InvBanList[Siege, "VectorPortPack"] = 1;

//--------------------------------------------------------------------------
// Automatic onMount Weapon Info
//--------------------------------------

function showWeaponInfo(%this, %weapon)
{
   %this.setInventory("EcstacyCapacitor", 0); // Ecstacy bug.
   %this.ecstacy = false;
   %this.stopEcstacy = true;
   %this.setInventory("PACCapacitor", 0); // PAC bug.
   %this.CL = false;
   %this.RFLActive = false;
   %this.MultiFusorActive = false;

   %armor = %this.getArmorSize(); // MrKeen
   %mode = %this.client.mode[%weapon];

   if($DenyMode[%armor, %weapon, %mode])
   {
      directModifyWeaponMode(%this.client, 0);
      showWeaponInfo(%this, %weapon);
      return;
   }

   %weaponName = %weapon.pickupName;

   if(!%mode)
      %mode = 0;

   if($WeaponModeCount[%weapon]) // does it have modes?
      %line2 = "<color:42dbea>Total <color:99FC99>"@$WeaponModeCount[%weapon]+1@"<color:42dbea> modes. Current mode: "@%mode+1@" [<color:FC9999>"@$WeaponMode[%weapon, %mode]@"<color:42dbea>]";
   else // NO... WHAT? NO MODES?! But no one ever gives me modes anymore :(
      %line2 = "Meltdown2 "@$Status@" - "@$NoFireModeText;

   if(%weapon $= "ChargeRifle" || %weapon $= "EcstacyCannon")
      commandToClient( %this.client, 'BottomPrint', "<font:times new roman:18>Now using "@%weaponName@"\n"@%line2@"\nThis weapon is a charging weapon. To charge, hold down the fire key", 5, 3);
   else if(%weapon $= "MBCannon" || %weapon $= "RFL")
      commandToClient( %this.client, 'BottomPrint', "<font:times new roman:18>Now using "@%weaponName@"\n"@%line2@"\nThis weapon auto-charges. Ammo represents charge.", 5, 3);
   else if(%weapon $= "MFG")
      commandToClient( %this.client, 'BottomPrint', "<font:times new roman:18>Now using "@%weaponName@"\n"@%line2@"\nThis weapon is a flak weapon. Press the fire key after firing and the charge will explode.", 5, 3);
   else if(%weapon $= "SniperRifle")
      commandToClient( %this.client, 'BottomPrint', "<font:times new roman:18>Now using "@%weaponName@"\nThis weapon is a hybrid laser/sniper weapon.\nSimply change modes to select between laser and projectile.", 5, 3);
   else if(%weapon $= "GatPBW") //Death~bot
      commandToClient( %this.client, 'BottomPrint', "<font:times new roman:18>Now using "@%weaponName@"\n"@%line2@"\n<color:FFF000>Those damn cats are gonna die! No cat is safe.", 5, 3);
   else if($WeaponModeCount[%weapon])
      commandToClient( %this.client, 'BottomPrint', "<font:times new roman:18>Now using "@%weaponName@"\n"@%line2@"\nTo change fire modes, press the beacon key.", 5, 3);
   else // last... and most definitely least. Yeah and what huh?!
      commandToClient( %this.client, 'BottomPrint', "<font:times new roman:18>Now using "@%weaponName@"\n"@%line2, 4, 2); // This should be interesting.....
}

function WeaponImage::onMount(%this,%obj,%slot)
{
   //MES -- is call below useful at all?
   //Parent::onMount(%this, %obj, %slot);
   if(%obj.getClassName() !$= "Player")
      return;

   //messageClient(%obj.client, 'MsgWeaponMount', "", %this, %obj, %slot);
   // Looks arm position
   if (%this.armthread $= "")
   {
      %obj.setArmThread(look);
   }
   else
   {
      %obj.setArmThread(%this.armThread);
   }

   // Initial ammo state
   if(%obj.getMountedImage($WeaponSlot).ammo !$= "")
      if (%obj.getInventory(%this.ammo))
         %obj.setImageAmmo(%slot,true);

   %obj.client.setWeaponsHudActive(%this.item);
   if(%obj.getMountedImage($WeaponSlot).ammo !$= "")
      %obj.client.setAmmoHudCount(%obj.getInventory(%this.ammo));
   else
      %obj.client.setAmmoHudCount(-1);
   /// findArmorMode(%obj);
   showWeaponInfo(%obj, %this.item);

}

function WeaponImage::onUnmount(%this,%obj,%slot)
{
   if(!%obj.isVehicle())
   {
      %obj.client.setWeaponsHudActive(%this.item, 1);
      %obj.client.setAmmoHudCount(-1);
      commandToClient(%obj.client,'removeReticle');
      // try to avoid running around with sniper/missile arm thread and no weapon
      %obj.setArmThread(look);
   }
   Parent::onUnmount(%this, %obj, %slot);
}

//--------------------------------------------------------------------------
// Vehicle Handling Code
//--------------------------------------
datablock AudioProfile(EngineAlertSound)
{
   filename    = "gui/vote_nopass.WAV";
   description = AudioExplosion3d;
   preload = true;
};

function VDUndo(%obj)
{
   %obj.vdOverride = false;
   %obj.dmgApplyImp = false;
}

function vDmgApplyImpulse(%obj)
{
   if(%obj.getDatablock().forceSensitive)
      return;

    %obj.dmgApplyImp = true;
    %lastPct = %obj.lastDmgPct;
    %pct = %obj.getDamagePct();

    if(%lastPct > %pct)
    {
       %obj.vdOverride = true;
       schedule(1000, 0, "VDUndo", %obj);
    }

    %obj.tp_sndCnt++;

    if(((%pct >= 0.5 && %pct < 1) && (%obj.vdOverride == false || %obj.vdOverride == "")) && %obj.augType !$= "Auto Repair Bot")
    {
        %force = (%pct * 500) * getRandom(1);
        if(%force)
        {
            %nVec = vectorScale(vectorRandom(), %force);

            %seed = getRandom(100);
            if(%seed > 60 && %seed < 90)
                %obj.playThread(0, "maintainback");
            else if(%seed > 90)
                %obj.playThread(0, "maintainbot");
            else
                %obj.playThread(0, "activateback");

            %obj.applyImpulse(%obj.getTransform(), %nVec);
        }
        %obj.lastDmgPct = %pct;
        schedule(250, %obj, "vDmgApplyImpulse", %obj);

        if(%obj.tp_sndCnt >= 4)
        {
            %obj.tp_sndCnt = 0;
            %obj.play3D(EngineAlertSound);
        }
    }
    else
        %obj.stopThread(0);
}

function VehicleData::onDamage(%this,%obj) // Apples are delicious
{
   %damage = %obj.getDamageLevel();
   if (%damage >= %this.destroyedLevel)
   {
      if(%obj.getDamageState() !$= "Destroyed")
      {
         if(%obj.respawnTime !$= "")
            %obj.marker.schedule = %obj.marker.data.schedule(%obj.respawnTime, "respawn", %obj.marker);
         %obj.setDamageState(Destroyed);
      }
   }
   else
   {
      if(%obj.getDamageState() !$= "Enabled")
         %obj.setDamageState(Enabled);

        %pct = %obj.getDamagePct();

        if(%pct >= 0.6 && !%obj.dmgApplyImp)
            vDmgApplyImpulse(%obj);
   }
}

//******************************************************************************
//*   Static Shape  -  Functions                                               *
//******************************************************************************

function StaticShapeData::create(%block)
{
   %obj = new StaticShape()
   {
      dataBlock = %block;
   };
   return(%obj);
}

function ShapeBase::damage(%this, %sourceObject, %position, %amount, %damageType)
{
   %this.getDataBlock().damageObject(%this, %sourceObject, %position, %amount, %damageType);
}

function ShapeBaseData::damageObject(%data, %targetObject, %position, %sourceObject, %amount, %damageType)
{
}

function ShapeBaseData::onDestroyed(%data, %obj, %prevState)
{
//   if(hasAttachments(%obj))
//      destroyAllAttachments(%obj);
}

function StaticShapeData::onDisabled(%data, %obj, %prevState)
{
   if(%obj.isPowered() || (%data.className $= "Generator"))
      %data.onLosePowerDisabled(%obj);

   Parent::onDisabled(%data, %obj, %prevState);
}

function StaticShapeData::onDamage(%this,%obj)
{
   // Set damage state based on current damage level
   %damage = %obj.getDamageLevel();
   if(%damage >= %this.destroyedLevel)
   {
      if(%obj.getDamageState() !$= "Destroyed")
      {
         %obj.setDamageState(Destroyed);
         // if object has an explosion damage radius associated with it, apply explosion damage
         if(%this.expDmgRadius)
            RadiusExplosion(%obj, %obj.getWorldBoxCenter(), %this.expDmgRadius, %this.expDamage, %this.expImpulse, %obj, $DamageType::Explosion);
         %obj.setDamageLevel(%this.maxDamage);

         if(%obj.attachedToObject) //limit attachment explosive
            destroyAllAttachments(%obj);

         if(isObject(%obj.parent))
            %obj.parent.setDamageState(Destroyed);

         %obj.clearLoopingDamages();
         %obj.ignoreRepairThis = true;
         schedule(5000, %obj, "resetRegen", %obj);
      }

//      %this.onStateDestroyed(%obj);
   }
   else
   {
      if(%damage >= %this.disabledLevel)
      {
         if(%obj.getDamageState() !$= "Disabled")
            %obj.setDamageState(Disabled);
      }
      else
      {
         if(%obj.getDamageState() !$= "Enabled")
            %obj.setDamageState(Enabled);
      }
   }
}

function StaticShapeData::onStateDestroyed(%data, %obj)
{
}

function resetRegen(%obj)
{
   if(isObject(%obj))
      %obj.ignoreRepairThis = false;
}

function ShapeBaseData::checkShields(%data, %targetObject, %position, %amount, %damageType)
{
// as you can see here, this just wasn't working.
// It was crap, so i'm going to do this stupid thing here:

//   %targetObject = %targetObject.ownerShieldBeacon ? %targetObject : %targetObject.ownerShieldBeacon;
//   %bool = %targetObject.ownerShieldBeacon ? true : false;

   if(!isObject(%targetObject))
      return 0;

   if(%damageType == $DamageType::MitziTransparent)
      return %amount;

   if(%targetObject.ownerShieldBeacon != 0)
   {
//      echo(%targetObject SPC %targetObject.getClassName());
      if(%targetObject.ownerShieldBeacon.isEMP)
         return %amount;

      %normal = "0.0 0.0 1.0";
      %targetObject.playShieldEffect( %normal );
      %targetObject.ownerShieldBeacon.playShieldEffect( %normal );
      %targetObject.ownerShieldBeacon.applyDamage(%amount * 0.7);

      %total = %targetObject.getDamageLevel() + (%amount * 0.7);
      %max = %targetObject.getDatablock().maxDamage;

      if(%total > %max)
      {
         %totalD = %targetObject.getDamageLevel() + %amount;
         return (%max-%totalD);
      }
      else
         return 0;
   }

   %energy  = %targetObject.getEnergyLevel();
   %strength = %energy / %data.energyPerDamagePoint;
   %shieldScale = %data.shieldDamageScale[%damageType];
   if(%shieldScale $= "")
      %shieldScale = 1;

   if (%amount * %shieldScale <= %strength) {
      // Shield absorbs all
      %lost = %amount * %shieldScale * %data.energyPerDamagePoint;
      %energy -= %lost;
      %targetObject.setEnergyLevel(%energy);

      %normal = "0.0 0.0 1.0";
      %targetObject.playShieldEffect( %normal );

      return 0;
   }
   // Shield exhausted
   %targetObject.setEnergyLevel(0);
   return %amount - %strength / %shieldScale;
}

function ShapeBaseData::checkShieldsBASS(%data, %targetObject, %position, %amount, %damageType)
{
   if(%damageType == $DamageType::MitziTransparent)
      return %amount;

//   %amount *= 1; // distance from generator determines damage

   %energy   = %targetObject.getEnergyLevel();
   %strength = %energy / %data.energyPerDamagePoint;
   %shieldScale = 0.444;

   if (%amount * %shieldScale <= %strength)
   {
      // Shield absorbs all
      %lost = %amount * %shieldScale * %data.energyPerDamagePoint;
      %energy -= %lost;
      %targetObject.setEnergyLevel(%energy);

      %normal = "0.0 0.0 1.0";
      %targetObject.playShieldEffect( %normal );

      return 0;
   }

   // Shield exhausted
   %targetObject.setEnergyLevel(0);
//   if(getRandom(10) > 8) // 20% chance
//   {
//      messageClient(%obj.client, 'MsgShieldBASSOverload', '\c2(BASS) malfunction -> overload [0x4AE9]');
//      %targetObject.EMPObject();
//   }

   return %amount - %strength / %shieldScale;
}

function StaticShapeData::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType, %force)
{
//   error("StaticShapeData::damageObject( "@%data@", "@%targetObject.getClassName()@", "@%sourceObject@", "@%position@", "@%amount@", "@%damageType@", "@%momVec@" )");

   // if this is a non-team mission type and the object is "protected", don't damage it. At least not today.
   if(%data.noIndividualDamage && Game.allowsProtectedStatics())
      return;

   // if this is a Siege mission and this object shouldn't take damage (e.g. vehicle stations) then damage it anyway.
   if(%data.noDamageInSiege && Game.class $= "SiegeGame")
      return;

   if(%targetObject.protectedByFFBase)
      return;

   if(%sourceObject && %targetObject.isEnabled())
   {
      if(%sourceObject.client)
      {
        %targetObject.lastDamagedBy = %sourceObject.client;
        %targetObject.lastDamagedByTeam = %sourceObject.client.team;
        %targetObject.damageTimeMS = GetSimTime();
      }
      else
      {
        %targetObject.lastDamagedBy = %sourceObject;
        %targetObject.lastDamagedByTeam = %sourceObject.team;
        %targetObject.damageTimeMS = GetSimTime();
      }
   }

   if(%targetObject.isExtension) // dont damage APE extensions
      return;
   else
   {
      if(%damageType == $DamageType::Burn) //$DamageType::Burn == 49
         if(!isObject(%targetObject.ownerShieldBeacon))
            %targetObject.BurnObject(%sourceObject);

      if(%damageType == $DamageType::EMP)
         if(!isObject(%targetObject.ownerShieldBeacon))
            %targetObject.EMPObject();
   }

   // Scale damage type & include shield calculations... GOD I HATE MATH!!
   if ((%data.isShielded && %damageType != $DamageType::MitziTransparent) || %targetObject.ownerShieldBeacon)
      %amount = %data.checkShields(%targetObject, %position, %amount, %damageType);

   %damageScale = %data.damageScale[%damageType];
   if(%damageScale !$= "")
      %amount *= %damageScale;

    //if team damage is off, cap the amount of damage so as not to disable the object...
    if (!$TeamDamage && !%targetObject.getDataBlock().deployedObject)
    {
      //see if the object is being shot by a friendly
      // and make sure it exists not to cause console spam :( jeez Dynamix
      if(isObject(%sourceObject))
      {
         if(%sourceObject.getDataBlock().catagory $= "Vehicles")
             %attackerTeam = getVehicleAttackerTeam(%sourceObject);
         else %attackerTeam = %sourceObject.team;
      }
      else %attackerTeam = %sourceObject.team;


      if ((%targetObject.getTarget() != -1) && isTargetFriendly(%targetObject.getTarget(), %attackerTeam))
      {
         %curDamage = %targetObject.getDamageLevel();
         %availableDamage = %targetObject.getDataBlock().disabledLevel - %curDamage - 0.05;
         if (%amount > %availableDamage)
            %amount = %availableDamage;
      }
    }

   // if there's still damage to apply
   if (%amount > 0)
      %targetObject.applyDamage(%amount);
}

function VehicleData::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType, %momVec, %theClient, %proj)
{
//   error("VehicleData::damageObject( "@%data@", "@%targetObject@", "@%sourceObject@", "@%position@", "@%amount@", "@%damageType@", "@%momVec@" )");

   if(%damageType == $DamageType::Water) //MPB Damage hack?!
      return 0;

   if(!isObject(%targetObject))
      return 0;

//   if(%damageType == $DamageType::Ground && velToSingle(%targetObject.getVelocity()) < 25) // Use this ONLY if you want MPBs to be able
//   to flip over and not explode
//      return 0;

   if(%proj !$= "")
   {
      if(%amount > 0 && %targetObject.lastDamageProj !$= %proj)
      {
         %targetObject.lastDamageProj = %proj;
         %targetObject.lastDamageAmount = %amount;
      }
      else if(%targetObject.lastDamageAmount < %amount)
         %amount = %amount - %targetObject.lastDamageAmount;
      else
         return;
   }

   // check for team damage
   if(isObject(%sourceObject))
   {
      %sourceClient = %sourceObject ? %sourceObject.getOwnerClient() : 0;
      %targetTeam = getTargetSensorGroup(%targetObject.getTarget());

      if(%sourceClient)
         %sourceTeam = %sourceClient.getSensorGroup();
      else if(isObject(%sourceObject) && %sourceObject.getClassName() $= "Turret")
         %sourceTeam = getTargetSensorGroup(%sourceObject.getTarget());
      else
         %sourceTeam = %sourceObject ? getTargetSensorGroup(%sourceObject.getTarget()) : -1;
   }

    // vehicles no longer obey team damage -JR
    // they always obey me! :o
//    if(!$teamDamage && (%targetTeam == %sourceTeam) && %targetObject.getDamagePercent() > 0.5)
//       return;
    //but we do want to track the destroyer
    if(isObject(%sourceObject))
    {
        %targetObject.lastDamagedBy = %sourceObject;
        %targetObject.lastDamageType = %damageType;
    }
    else
        %targetObject.lastDamagedBy = 0;

   if(%damageType == $DamageType::EMP)
        %targetObject.EMPObject();
   else if(%damageType == $DamageType::Burn)
        %targetObject.BurnObject(%sourceObject);

   // Scale damage type & include shield calculations...
//   if(%data.isShielded && (%data.getName() $= "ScoutFlyer" && %sourceObject.weapon[1, Name] $= "Shrike 50k Bombs"))
//      %amount *= 0.9;
   if(%data.isShielded) // else
   {
      if(%damageType == $DamageType::MitziTransparent)
      {
         %targetObject.applyDamage(%amount);
         if(%targetObject.getDamageState() $= "Destroyed" )
         {
            if( %momVec !$= "")
               %targetObject.setMomentumVector(%momVec);
         }
      }
      else
         %amount = %data.checkShields(%targetObject, %position, %amount, %damageType);
   }

   %damageScale = %data.damageScale[%damageType];
   if(%damageScale !$= "")
      %amount *= %damageScale;

   if(%amount != 0)
      %targetObject.applyDamage(%amount);

//   if(%amount > 0.1) // no petty damage chunking away at vehicle
//      createHitDebris(%position); //%proj.getPosition()); //getWorldBoxCenter());

   if(%targetObject.getDamageState() $= "Destroyed" )
   {
      if( %momVec !$= "")
         %targetObject.setMomentumVector(%momVec);
   }
}

function DefaultGame::onClientKilled(%game, %clVictim, %clKiller, %damageType, %implement, %damageLocation)
{
   %plVictim = %clVictim.player;
   %plKiller = %clKiller.player;
   %clVictim.plyrPointOfDeath = %plVictim.position;
   %clVictim.plyrDiedHoldingFlag = %plVictim.holdingFlag;
   %clVictim.waitRespawn = 1;

   cancel( %plVictim.reCloak );
   cancel(%clVictim.respawnTimer);
   %clVictim.respawnTimer = %game.schedule(($Host::PlayerRespawnTimeout * 1000), "forceObserver", %clVictim, "spawnTimeout" );

   // reset the alarm for out of bounds
   if(%clVictim.outOfBounds)
      messageClient(%clVictim, 'EnterMissionArea', "");

   if (%damageType == $DamageType::suicide)
      %respawnDelay = $Feature[SuicideRespawnTime] = 5; //10;
   else
      %respawnDelay = $Feature[RespawnTime] = 2; //2;

   %game.schedule(%respawnDelay*1000, "clearWaitRespawn", %clVictim);
   // if victim had an undetonated satchel charge pack, get rid of it
   if(%plVictim.thrownChargeId != 0)
      if(!%plVictim.thrownChargeId.kaboom)
         %plVictim.thrownChargeId.delete();

   if(%plVictim.lastVehicle !$= "")
   {
      schedule(15000, %plVictim.lastVehicle,"vehicleAbandonTimeOut", %plVictim.lastVehicle);
      %plVictim.lastVehicle.lastPilot = "";
   }

   // unmount pilot or remove sight from bomber
   if(%plVictim.isMounted())
   {
      if(%plVictim.vehicleTurret)
         %plVictim.vehicleTurret.getDataBlock().playerDismount(%plVictim.vehicleTurret);
      else
      {
         %plVictim.getDataBlock().doDismount(%plVictim, true);
         %plVictim.mountVehicle = false;
      }
   }

   if(%plVictim.inStation)
      commandToClient(%plVictim.client,'setStationKeys', false);
   %clVictim.camera.mode = "playerDeath";

   // reset who triggered this station and cancel outstanding armor switch thread
   if(%plVictim.station)
   {
      %plVictim.station.triggeredBy = "";
      %plVictim.station.getDataBlock().stationTriggered(%plVictim.station,0);
      if(%plVictim.armorSwitchSchedule)
         cancel(%plVictim.armorSwitchSchedule);
   }

   //Close huds if player dies...
   messageClient(%clVictim, 'CloseHud', "", 'inventoryScreen');
   messageClient(%clVictim, 'CloseHud', "", 'vehicleHud');
   commandToClient(%clVictim, 'setHudMode', 'Standard', "", 0);

   // $weaponslot from item.cs
   %plVictim.setRepairRate(0);
   %plVictim.setImageTrigger($WeaponSlot, false);

   playDeathAnimation(%plVictim, %damageLocation, %damageType);
   playDeathCry(%plVictim);

   %victimName = %clVictim.name;

   %game.displayDeathMessages(%clVictim, %clKiller, %damageType, %implement);
   %game.updateKillScores(%clVictim, %clKiller, %damageType, %implement);

   // toss whatever is being carried, '$flagslot' from item.cs
   // MES - had to move this to after death message display because of Rabbit game type
   for(%index = 0 ; %index < 8; %index++)
   {
      %image = %plVictim.getMountedImage(%index);
      if(%image)
      {
         if(%index == $FlagSlot)
            %plVictim.throwObject(%plVictim.holdingFlag);
         else
            %plVictim.throw(%image.item);
      }
   }

   // target manager update
   setTargetDataBlock(%clVictim.target, 0);
   setTargetSensorData(%clVictim.target, 0);

   // clear the hud
   %clVictim.SetWeaponsHudClearAll();
   %clVictim.SetInventoryHudClearAll();
   %clVictim.setAmmoHudCount(-1);

   // clear out weapons, inventory and pack huds
   messageClient(%clVictim, 'msgDeploySensorOff', "");  //make sure the deploy hud gets shut off
   messageClient(%clVictim, 'msgPackIconOff', "");  // clear the pack icon

   //clear the deployable HUD
   %plVictim.client.deployPack = false;
   cancel(%plVictim.deployCheckThread);
   deactivateDeploySensor(%plVictim);

   //if the killer was an AI...
   if (isObject(%clKiller) && %clKiller.isAIControlled())
      %game.onAIKilledClient(%clVictim, %clKiller, %damageType, %implement);

   // reset control object on this player: also sets 'playgui' as content
   serverCmdResetControlObject(%clVictim);

   // set control object to the camera
   %clVictim.player = 0;
   %transform = %plVictim.getTransform();

   //note, AI's don't have a camera...
   if (isObject(%clVictim.camera))
   {
      %clVictim.camera.setTransform(%transform);
      %clVictim.camera.setOrbitMode(%plVictim, %plVictim.getTransform(), 0.5, 4.5, 4.5);
   }

   //if the death was a suicide, prevent respawning for (defined) seconds...
   %clVictim.lastDeathSuicide = false;
   if (%damageType == $DamageType::Suicide)
   {
      %clVictim.lastDeathSuicide = true;
      %clVictim.suicideRespawnTime = getSimTime() + $Meltdown::SuicideRespawnTime;
   }

   //hook in the AI specific code for when a client dies
   if (%clVictim.isAIControlled())
   {
      aiReleaseHumanControl(%clVictim.controlByHuman, %clVictim);
      %game.onAIKilled(%clVictim, %clKiller, %damageType, %implement);
   }
   else
      aiReleaseHumanControl(%clVictim, %clVictim.controlAI);

   //used to track corpses so the AI can get ammo, etc...
   AICorpseAdded(%plVictim);

   if(%clVictim.die1stPerson && $Meltdown::Die1stPerson)
      schedule($Meltdown::SuicideRespawnTime - 32, %clVictim, continueClientKilled, %game, %clVictim, %clKiller, %damageType, %implement, %damageLocation);
   else
      continueClientKilled(%game, %clVictim, %clKiller, %damageType, %implement, %damageLocation);
}

function continueClientKilled(%game, %clVictim, %clKiller, %damageType, %implement, %damageLocation)
{
   if (isObject(%clVictim.camera))
      %clVictim.setControlObject(%clVictim.camera);
}

$Meltdown::SuicideRespawnTime = $Feature[SuicideRespawnTime];
$Meltdown::Die1stPerson = $Feature[Die1stPerson];

function teleportStartFX(%obj)
{
     if(%obj.holdingFlag)
     {
          %flag = %obj.holdingFlag;
          %flag.setVelocity("0 0 0");
          %flag.setPosition(getRandomT(10000) SPC getRandomT(10000) SPC getRandomN(10000, 5000));
          %flag.setCollisionTimeout(%obj);
          %obj.throwObject(%flag);
          messageClient(%obj.client, 'MsgNoTeleWithFlag', '\c2You cannot teleport with the flag.');
     }

     %obj.playShieldEffect("0 0 1");
     %obj.setCloaked(true);
     %obj.startFade( 1000, 0, true );
     %obj.play3D(TeleportSound);

     createLifeEmitter(%obj.getWorldBoxCenter(), "Teleporter1Emitter", 2500);
}

function teleportEndFX(%obj)
{
     %obj.setCloaked(false);
     %obj.playShieldEffect("0 0 1");
     %obj.startFade(1000, 0, false );
     %obj.play3D(UnTeleportSound);
     createLifeEmitter(%obj.getWorldBoxCenter(), "Teleporter1Emitter", 2500);
}

function isVehicleMenu(%obj, %client, %data) // How in the world did I come up with this again?! wow. lol
{
   if(%data $= "Terragravs")
   {
      %client.vsmenu = 1;
      commandToClient(%client, 'StationVehicleHideHud');
      commandToClient(%client, 'StationVehicleShowHud');
      return true;
   }
   else if(%data $= "Turbogravs")
   {
      %client.vsmenu = 2;
      commandToClient(%client, 'StationVehicleHideHud');
      commandToClient(%client, 'StationVehicleShowHud');
      return true;
   }
   else if(%data $= "Heavy")
   {
      %client.vsmenu = 3;
      commandToClient(%client, 'StationVehicleHideHud');
      commandToClient(%client, 'StationVehicleShowHud');
      return true;
   }
   else if(%data $= "Ground")
   {
      %client.vsmenu = 4;
      commandToClient(%client, 'StationVehicleHideHud');
      commandToClient(%client, 'StationVehicleShowHud');
      return true;
   }
   else if(%data $= "Transports")
   {
      %client.vsmenu = 5;
      commandToClient(%client, 'StationVehicleHideHud');
      commandToClient(%client, 'StationVehicleShowHud');
      return true;
   }
   else if(%data $= "Back")
   {
      %client.vsmenu = 0;
      commandToClient(%client, 'StationVehicleHideHud');
      commandToClient(%client, 'StationVehicleShowHud');
      return true;
   }
   else
   {
      %client.vsmenu = 0;
      return false;
   }
}

function serverCmdBuyVehicle(%client, %blockName)
{
   if(isVehicleMenu(%client.player, %client, %blockname))
      return;

   commandToClient(%client, 'StationVehicleHideHud');
   %team = %client.getSensorGroup();
   if(vehicleCheck(%blockName, %team))
   {
      %station = %client.player.station.pad;
      if( (%station.ready) && (%station.station.vehicle[%blockName]) )
      {
         %trans = %station.getTransform();
         %pos = getWords(%trans, 0, 2);
         %matrix = VectorOrthoBasis(getWords(%trans, 3, 6));
         %yrot = getWords(%matrix, 3, 5);
         %p = vectorAdd(%pos,vectorScale(%yrot, -3));
         %p =  getWords(%p,0, 1) @ " " @ getWord(%p,2) + 4;

//         error(%blockName);
//         error(%blockName.spawnOffset);

         %p = vectorAdd(%p, %blockName.spawnOffset);
         %rot = getWords(%trans, 3, 5);
         %angle = getWord(%trans, 6) + 3.14;
         %mask = $TypeMasks::VehicleObjectType | $TypeMasks::PlayerObjectType |
                 $TypeMasks::StationObjectType | $TypeMasks::TurretObjectType;
	      InitContainerRadiusSearch(%p, %blockName.checkRadius, %mask);

	      %clear = 1;
         for (%x = 0; (%obj = containerSearchNext()) != 0; %x++)
         {
            if((%obj.getType() & $TypeMasks::VehicleObjectType) && (%obj.getDataBlock().checkIfPlayersMounted(%obj)))
            {
               %clear = 0;
               break;
            }
            else
               %removeObjects[%x] = %obj;
         }
         if(%clear)
         {
            %fadeTime = 0;
            for(%i = 0; %i < %x; %i++)
            {
               if(%removeObjects[%i].getType() & $TypeMasks::PlayerObjectType)
               {
                  %pData = %removeObjects[%i].getDataBlock();
                  %pData.damageObject(%removeObjects[%i], 0, "0 0 0", 1000, $DamageType::VehicleSpawn);
               }
               else
               {
                  %removeObjects[%i].mountable = 0;
                  %removeObjects[%i].startFade( 1000, 0, true );
                  %removeObjects[%i].schedule(1001, "delete");
                  %fadeTime = 1500;
               }
            }
            schedule(%fadeTime, 0, "createVehicle", %client, %station, %blockName, %team , %p, %rot, %angle);
         }
         else
            MessageClient(%client, "", 'Can\'t create vehicle. A player is mounted in a vehicle on the creation pad.');
      }
   }
}

function createVehicle(%client, %station, %blockName, %team , %pos, %rot, %angle)
{
   %obj = %blockName.create(%team);
   if(%obj)
   {
      %station.ready = false;
      %obj.team = %team;
      %obj.useCreateHeight(true);
      %obj.schedule(5500, "useCreateHeight", false);
      %obj.getDataBlock().isMountable(%obj, false);
      %obj.getDataBlock().schedule(6500, "isMountable", %obj, true);

      %station.playThread($ActivateThread,"activate2");
      %station.playAudio($ActivateSound, ActivateVehiclePadSound);

      vehicleListAdd(%blockName, %obj);
      MissionCleanup.add(%obj);

      %turret = %obj.getMountNodeObject(10);
      if(%turret > 0)
      {
         %turret.setCloaked(true);
         %turret.schedule(4800, "setCloaked", false);
      }

      %obj.setCloaked(true);
      %obj.setTransform(%pos @ " " @ %rot @ " " @ %angle);

      %obj.schedule(3700, "playAudio", 0, VehicleAppearSound);
      %obj.schedule(4800, "setCloaked", false);

      if(%client.player.lastVehicle)
      {
         %client.player.lastVehicle.lastPilot = "";
         vehicleAbandonTimeOut(%client.player.lastVehicle);
         %client.player.lastVehicle = "";
      }
      %client.player.lastVehicle = %obj;
      %obj.lastPilot = %client.player;

      // play the FX
      %fx = new StationFXVehicle()
      {
         dataBlock = VehicleInvFX;
         stationObject = %station;
      };

      if ( %client.isVehicleTeleportEnabled() )
         %obj.getDataBlock().schedule(5000, "mountDriver", %obj, %client.player);
   }
   if(%obj.getTarget() != -1)
      setTargetSensorGroup(%obj.getTarget(), %client.getSensorGroup());
   // We are now closing the vehicle hud when you buy a vehicle, making the following call
   // unnecessary (and it breaks stuff, too!)
   //VehicleHud.updateHud(%client, 'vehicleHud');
}

function FlyingVehicle::liquidDamage(%obj, %data, %damageAmount, %damageType)
{
   if(%obj.getDamageState() !$= "Destroyed" && !%obj.liquidDamageProof)
   {
      %data.damageObject(%obj, 0, "0 0 0", %damageAmount, %damageType);
      %obj.lDamageSchedule = %obj.schedule(50, "liquidDamage", %data, %damageAmount, %damageType);
      passengerLiquidDamage(%obj, %damageAmount, %damageType);
   }
   else
      %obj.lDamageSchedule = "";
}

function Turret::liquidDamage(%obj, %data, %damageAmount, %damageType)
{
   if(%obj.getDamageState() !$= "Destroyed" && !%obj.liquidDamageProof)
   {
      %data.damageObject(%obj, 0, "0 0 0", %damageAmount, %damageType);
      %obj.lDamageSchedule = %obj.schedule(50, "liquidDamage", %data, %damageAmount, %damageType);
      passengerLiquidDamage(%obj, %damageAmount, %damageType);
   }
   else
      %obj.lDamageSchedule = "";
}

function TurretData::liquidDamage(%obj, %data, %damageAmount, %damageType)
{
   if(%obj.getDamageState() !$= "Destroyed" && !%obj.liquidDamageProof)
   {
      %data.damageObject(%obj, 0, "0 0 0", %damageAmount, %damageType);
      %obj.lDamageSchedule = %obj.schedule(50, "liquidDamage", %data, %damageAmount, %damageType);
      passengerLiquidDamage(%obj, %damageAmount, %damageType);
   }
   else
      %obj.lDamageSchedule = "";
}

function WheeledVehicle::liquidDamage(%obj, %data, %damageAmount, %damageType)
{
   if(%obj.getDamageState() !$= "Destroyed" && !%obj.liquidDamageProof)
   {
      %data.damageObject(%obj, 0, "0 0 0", %damageAmount, %damageType);
      %obj.lDamageSchedule = %obj.schedule(50, "liquidDamage", %data, %damageAmount, %damageType);
      passengerLiquidDamage(%obj, %damageAmount, %damageType);
   }
   else
      %obj.lDamageSchedule = "";
}

function HoverVehicle::liquidDamage(%obj, %data, %damageAmount, %damageType)
{
   if(%obj.getDamageState() !$= "Destroyed" && !%obj.liquidDamageProof)
   {
      %data.damageObject(%obj, 0, "0 0 0", %damageAmount, %damageType);
      %obj.lDamageSchedule = %obj.schedule(50, "liquidDamage", %data, %damageAmount, %damageType);
      passengerLiquidDamage(%obj, %damageAmount, %damageType);
   }
   else
      %obj.lDamageSchedule = "";
}

function VehicleData::onDestroyed(%data, %obj, %prevState)
{
//   trace(1);

   if(!isObject(%obj)) // heh oops
      return;

    %team = %obj.getControllingClient().team; //%obj.client.team;

    if(%data.canControl)
    {
        %cl = %obj.getControllingClient();

        if(isObject(%cl))
           %cl.setControlObject(%cl.player);
    }

    if(%obj.lastDamagedBy)
    {
        %destroyer = %obj.lastDamagedBy;

        if(!%data.jetfire && !%data.MegaDisc && !%data.terra)
             game.vehicleDestroyed(%obj, %destroyer);
    }

   radiusVehicleExplosion(%data, %obj);
   if(%obj.turretObject)
      if(%obj.turretObject.getControllingClient())
         %obj.turretObject.getDataBlock().playerDismount(%obj.turretObject);

    if(%data.jetfire)
    {
      %obj.prevDest = true;
      %flingee = %obj.getMountNodeObject(0);
      %flingee.damage(0, %obj.getPosition(), 100, $DamageType::Explosion);
      %flingee.getDataBlock().doDismount(%flingee, true);

      %data.deleteAllMounted(%obj);

      if(isObject(%obj))
      {
         schedule(64, %obj, setPosition, %obj, vectorAdd(%obj.position, "40 -27 10000"));
         %obj.schedule(2000, "delete");
      }

       return;
    }

    if(%data.MegaDisc)
    {
      %obj.prevDest = true;
      %flingee = %obj.getMountNodeObject(0);
      %flingee.damage(0, %obj.getPosition(), 100, $DamageType::Default);
      %flingee.getDataBlock().doDismount(%flingee, true);

      %data.deleteAllMounted(%obj);

      if(isObject(%obj))
      {
         schedule(64, %obj, setPosition, %obj, vectorAdd(%obj.position, "40 -27 10000"));
         %obj.schedule(2000, "delete");
      }

       return;
    }

//   if(%obj.getDatablock().SMPB)
//   {
//      $SMPBBuilding[%obj.team] = true;
//      $TeamDeployedCount[%obj.team, SMPB]--;
//      schedule($SMPBTimeout*60000, 0, resetSMPB(%obj.team));
//   }

   for(%m = 0; %m < 8; %m++)
   {
      if(%obj.getMountNodeObject(%m) && %obj.getMountNodeObject(%m).isExtension)
         deleteSlotExtension(%obj, %m);
   }

   for(%i = 0; %i < %obj.getDatablock().numMountPoints; %i++)
   {
//      echo("damaging objects...");
      if (%obj.getMountNodeObject(%i)) { // && %i.getDatablock().className $= "Armor") {
         %flingee = %obj.getMountNodeObject(%i);
         %flingee.getDataBlock().doDismount(%flingee, true);
         %xVel = 250.0 - (getRandom() * 500.0);
         %yVel = 250.0 - (getRandom() * 500.0);
         %zVel = (getRandom() * 100.0) + 50.0;
         %flingVel = %xVel @ " " @ %yVel @ " " @ %zVel;
         %flingee.applyImpulse(%flingee.getTransform(), %flingVel);
//         echo("got player..." @ %flingee.getClassName());
         %flingee.damage(0, %obj.getPosition(), 0.7, $DamageType::Crash);
      }
   }

   %data.deleteAllMounted(%obj);
   schedule(100, %obj, setPosition, %obj, vectorAdd(%obj.position, "40 -27 10000"));
   %obj.schedule(2000, "delete");
//   trace(0);
}

function resetSMPB(%team)
{
   $SMPBBuilding[%team] = "";
}

function findEmptySeat(%vehicle, %player, %forceNode)
{
   %minNode = 1;
   %node = -1;
   %dataBlock = %vehicle.getDataBlock();
   %dis = %dataBlock.minMountDist;
   %playerPos = getWords(%player.getTransform(), 0, 2);
   %message = "";
   if(%dataBlock.lightOnly)
   {
      if(%player.client.armor $= "Light" || %player.client.armor $= "Pilot" || %player.client.armor $= "MagIon")
         %minNode = 0;
      else
         %message = '\c2Only Scout, Magnetic Ion, and Pilot Armors can pilot this vehicle.~wfx/misc/misc.error.wav';
   }
//   else if(%dataBlock.jetfire)
//   {
//      if(%player.client.armor $= "Medium")
//         %minNode = 0;
//      else
//         %message = '\c2THIS WAS SUPPOSED TO HAPPEN!!!.~wfx/misc/misc.error.wav';
//   }
   else if(%player.client.armor $= "Light" || %player.client.armor $= "Medium" || %player.client.armor $= "Engineer" || %player.client.armor $= "Blastech")
      %minNode = 0;
      //-Nite- removal of tatic mech.
  // else if(!%player.getDatablock().isTacticalMech)
    //  %minNode = findFirstHeavyNode(%dataBlock);
   else
      %message = '\c2Armor is too large to mount into a vehicle.~wfx/misc/misc.error.wav';

   if(%forceNode !$= "")
      %node = %forceNode;
   else
   {
      for(%i = 0; %i < %dataBlock.numMountPoints; %i++)
         if(!%vehicle.getMountNodeObject(%i))
         {
            %seatPos = getWords(%vehicle.getSlotTransform(%i), 0, 2);
            %disTemp = VectorLen(VectorSub(%seatPos, %playerPos));
            if(%disTemp <= %dis)
            {
               %node = %i;
               %dis = %disTemp;
            }
         }
    }
   if(%node != -1 && %node < %minNode)
   {
      if(%message $= "")
      {
         if(%node == 0)
            %message = '\c2Only Scout, Engineer, Assault Armors can pilot this vehicle.~wfx/misc/misc.error.wav';
         else
            %message = '\c2Only Scout, Engineer, Assault Armors can use that position.~wfx/misc/misc.error.wav';
      }

      if(!%player.noSitMessage)
      {
         %player.noSitMessage = true;
         %player.schedule(2000, "resetSitMessage");
         messageClient(%player.client, 'MsgArmorCantMountVehicle', %message);
      }
      %node = -1;
   }
   return %node;
}

function Armor::doDismount(%this, %obj, %forced)
{
   // This function is called by player.cc when the jump trigger
   // is true while mounted
   if (!%obj.isMounted())
      return;

   if(isObject(%obj.getObjectMount().shield))
      %obj.getObjectMount().shield.delete();

   commandToClient(%obj.client,'SetDefaultVehicleKeys', false);

   // Position above dismount point

   %pos    = getWords(%obj.getTransform(), 0, 2);
   %oldPos = %pos;
   %vec[0] = " 0  0  2";
   %vec[1] = " 0  0  2";
   %vec[2] = " 0  0 -2";
   %vec[3] = " 2  0  0";
   %vec[4] = "-2  0  0";
   %numAttempts = 5;
   %success     = -1;
   %impulseVec  = "0 0 0";
   if (%obj.getObjectMount().getDatablock().hasDismountOverrides() == true)
   {
      %vec[0] = %obj.getObjectMount().getDatablock().getDismountOverride(%obj.getObjectMount(), %obj);
      %vec[0] = MatrixMulVector(%obj.getObjectMount().getTransform(), %vec[0]);
   }
   else
   {
      %vec[0] = MatrixMulVector( %obj.getTransform(), %vec[0]);
   }

   %pos = "0 0 0";
   for (%i = 0; %i < %numAttempts; %i++)
   {
      %pos = VectorAdd(%oldPos, VectorScale(%vec[%i], 3));
      if (%obj.checkDismountPoint(%oldPos, %pos))
      {
         %success = %i;
         %impulseVec = %vec[%i];
         break;
      }
   }
   if (%forced && %success == -1)
   {
      %pos = %oldPos;
   }

   // hide the dashboard HUD and delete elements based on node
   commandToClient(%obj.client, 'setHudMode', 'Standard', "", 0);
   // Unmount and control body
   if(%obj.vehicleTurret)
      %obj.vehicleTurret.getDataBlock().playerDismount(%obj.vehicleTurret);
   %obj.unmount();
   if(%obj.mVehicle)
      %obj.mVehicle.getDataBlock().playerDismounted(%obj.mVehicle, %obj);

   // bots don't change their control objects when in vehicles
   if(!%obj.client.isAIControlled())
   {
      %vehicle = %obj.getControlObject();
      %obj.setControlObject(0);
   }

   %obj.mountVehicle = false;
   %obj.schedule(2000, "setMountVehicle", true);

   // Position above dismount point
   %obj.setTransform(%pos);
   %obj.playAudio(0, UnmountVehicleSound);
   %obj.applyImpulse(%pos, VectorScale(%impulseVec, %obj.getDataBlock().mass * 3));
   %obj.setPilot(false);
   %obj.vehicleTurret = "";
}

function ProjectileData::onExplode(%data, %proj, %pos, %mod)
{
   if(%proj.bkSourceObject)
      if(isObject(%proj.bkSourceObject))
         %proj.sourceObject = %proj.bkSourceObject;

   if (%data.hasDamageRadius) // I lost a bomb. Do you have it?
      RadiusExplosion(%proj, %pos, %data.damageRadius, %data.indirectDamage, %data.kickBackStrength, %proj.sourceObject, %data.radiusDamageType);
}

function fireNextWeapon(%obj, %slot1, %slot2)
{
   if(%obj.fireWeapon)
   {
      if(%obj.nextWeaponFire == %slot1)
      {
         %obj.setImageTrigger(%slot1, true);
         %obj.setImageTrigger(%slot2, false);
      }
      else
      {
         %obj.setImageTrigger(%slot1, false);
         %obj.setImageTrigger(%slot2, true);
      }
   }
   else
   {
      %obj.setImageTrigger(%slot1, false);
      %obj.setImageTrigger(%slot2, false);
   }
}

function fireNextGun(%obj)
{
   if(%obj.fireWeapon)
   {
      if(%obj.nextWeaponFire == 2)
      {
         %obj.setImageTrigger(2, true);
         %obj.setImageTrigger(3, false);
      }
      else if(%obj.nextWeaponFire == 3)
      {
         %obj.setImageTrigger(2, false);
         %obj.setImageTrigger(3, true);
      }
      else if(%obj.nextWeaponFire == 5)
      {
         %obj.setImageTrigger(5, true);
         %obj.setImageTrigger(6, false);
      }
      else if(%obj.nextWeaponFire == 6)
      {
         %obj.setImageTrigger(5, false);
         %obj.setImageTrigger(6, true);
      }
   }
   else
   {
      %obj.setImageTrigger(2, false);
      %obj.setImageTrigger(3, false);
      %obj.setImageTrigger(5, false);
      %obj.setImageTrigger(6, false);
   }
}

function fireNextWarp(%obj)
{
   if(%obj.fireWeapon)
   {
      if(%obj.nextWeaponFire == 2)
      {
         %obj.setImageTrigger(2, true);
         %obj.setImageTrigger(3, false);
         %obj.setImageTrigger(4, false);
      }
      else if(%obj.nextWeaponFire == 3)
      {
         %obj.setImageTrigger(2, false);
         %obj.setImageTrigger(3, true);
         %obj.setImageTrigger(4, false);
      }
      else if(%obj.nextWeaponFire == 4)
      {
         %obj.setImageTrigger(2, false);
         %obj.setImageTrigger(3, false);
         %obj.setImageTrigger(4, true);
      }
   }
   else
   {
      %obj.setImageTrigger(2, false);
      %obj.setImageTrigger(3, false);
      %obj.setImageTrigger(4, false);
   }
}

//--------------------------------------------------------------------------
//
//--------------------------------------

function shutdownServer(%time, %msg, %lines) // overloaded from functions.cs
{
     %left = %time*1000;
     flashWindowDynamicAll(%msg, 100, %lines, %left, true, "<color:0000FF>");
     schedule(%left, 0, "quit");
}

function DefaultGame::createPlayer(%game, %client, %spawnLoc, %respawn)
{
   // do not allow a new player if there is one (not destroyed) on this client
   if(isObject(%client.player) && (%client.player.getState() !$= "Dead"))
      return;

   // clients and cameras can exist in team 0, but players should not
   if(%client.team == 0)
      error("Players should not be added to team0!"); // you know I could use some %client.sex

   // defaultplayerarmor is in 'players.cs'
   if(%spawnLoc == -1)
      %spawnLoc = "0 0 300 1 0 0 0";
   //else
   //  echo("Spawning player at " @ %spawnLoc);

   // copied from player.cs
   if (%client.race $= "Bioderm")
      // Only have male bioderms.
      %armor = $DefaultPlayerArmor @ "Male" @ %client.race @ Armor;
   else
      %armor = $DefaultPlayerArmor @ %client.sex @ %client.race @ Armor;
   %client.armor = $DefaultPlayerArmor;

   %player = new Player() {
      //dataBlock = $DefaultPlayerArmor;
      dataBlock = %armor;
   };


   if(%respawn)
   {
      %player.setInvincible(true);
      %player.setCloaked(true);
      %player.setInvincibleMode($InvincibleTime,0.02);
      %player.respawnCloakThread = %player.schedule($InvincibleTime * 1000, "setRespawnCloakOff");
      %player.schedule($InvincibleTime * 1000, "setInvincible", false);
   }

   %player.setTransform( %spawnLoc );
   MissionCleanup.add(%player);

   // setup some info
   %player.setOwnerClient(%client);
   %player.team = %client.team;
   %client.outOfBounds = false;
   %player.setEnergyLevel(60);
   %client.player = %player;

   // updates client's target info for this player
   %player.setTarget(%client.target);
   setTargetDataBlock(%client.target, %player.getDatablock());
   setTargetSensorData(%client.target, PlayerSensor);
   setTargetSensorGroup(%client.target, %client.team);
   %client.setSensorGroup(%client.team);
   clearCenterPrint(%client);
   clearBottomPrint(%client);

   //make sure the player has been added to the team rank array...
   %game.populateTeamRankArray(%client);

   %game.playerSpawned(%client.player);
}

datablock StaticShapeData(mReflector)
{
   shapeFile = "turret_muzzlepoint.dts";
};

$ProjectileTypeToIgnore[0] = "ELFProjectile";
$ProjectileTypeToIgnore[1] = "TargetProjectile";
$ProjectileTypeToIgnore[2] = "SeekerProjectile";
$ProjectileTypeToIgnore[3] = "RepairProjectile";
$ProjectileTypeToIgnore[4] = "SniperProjectile";

function isFFReflectableProjectile(%obj)
{
   for(%i = 0; $ProjectileTypeToIgnore[%i] !$= ""; %i++)
   {
      if(%obj.getClassName() $= $ProjectileTypeToIgnore[%i])
         return false;
   }

   return true;
}

function FFReflectProjectile(%int, %ff, %normal)
{
   if(isFFReflectableProjectile(%int))
   {
      if(%int.lastReflectedFrom == %ff)// --- (ST)
         return;

      if(%int.reflectCount > 8) //  seems to be the magic number.
         return;

      %FFRObject = new StaticShape()
      {
         dataBlock        = mReflector;
      };
      MissionCleanup.add(%FFRObject);
      %FFRObject.setPosition(%int.getPosition());

// --- Find reflection angle (ST)
      //%vector = vectorNeg(%int.initialDirection); // Cooking it off wont allow the enemy to pick it up and throw it right back at ya
      //%x = (getRandom() - 0.5) * 2 * 3.1415926 * (48 / 1000); //0.785398;
      //%y = (getRandom() - 0.5) * 2 * 3.1415926 * (48 / 1000); //0.785398;
      //%z = (getRandom() - 0.5) * 2 * 3.1415926 * (48 / 1000); //0.785398;
      //%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
      //%vector = MatrixMulVector(%mat, %vector);

      %pVec = VectorNormalize(%int.initialDirection);

      // --- Thanks to Mostlikely
//      %start = VectorSub(%int.getPosition(), %pVec);
//      %end = VectorAdd(%int.getPosition(), %pVec);
//      %surface = containerRayCast(%start, %end, $TypeMasks::ForceFieldObjectType, 0);
//      %normal =  normalFromRaycast(%surface);
      %flip = VectorDot(%normal, %pVec);
      %flip = VectorScale(%normal, %flip);
      %newVec = VectorAdd(%pVec, VectorScale(%flip, -2));
      // --- ...again... LOL (ST)
      %newPos = VectorAdd(%int.getPosition(), %newVec);
// --- End reflection angle (ST)

      %p = new(%int.getClassName())()
      {
         dataBlock        = %int.getDatablock().getName();
         initialDirection = %newVec;// --- (ST) %vector; //vectorNeg(%int.initialDirection);
         initialPosition  = %newPos;// --- (ST) VectorAdd(%int.getPosition(), %vector);
         sourceObject     = %FFRObject;
         sourceSlot       = %int.sourceSlot;
         reflectCount     = %int.reflectCount++;
         lastReflectedFrom = %ff; // --- (ST)
         bkSourceObject   = %int.sourceObject;
         starburstMode    = %int.starburstMode;
      };
      MissionCleanup.add(%p);

      if(%int.trailThread)
         projectileTrail(%p, %int.trailThreadTime, %int.trailThreadProjType, %int.trailThreadProj, false, %int.trailThreadOffset);

      if(%int.proxyThread)
         rBeginProxy(%p);

      %int.delete();
      %FFRObject.schedule(32, delete);
   }
}

function WaterBlock::Damage(){}

function ProjectileData::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal)
{
//   echo(%projectile.getClassName());
//   echo(%targetObject.getClassName());
   if(!isObject(%targetObject))
      return;

   if(%targetObject.reflectGun)
      return;

   %source = isObject(%projectile.bkSourceObject) ? %projectile.bkSourceObject : %projectile.sourceObject;

   if(%projectile.lockedMissileThread) // radar-seeking projectiles
      %projectile.lockedMissileThread = false;

//   if(%projectile.bkSourceObject)
//      if(isObject(%projectile.bkSourceObject))
//         %projectile.sourceObject = %projectile.bkSourceObject;

   if(%projectile.pDmgMod)
      %modifier = %projectile.pDmgMod;

   if(%targetObject.getClassName() $= "ForceFieldBare")
   {
      if(isObject(%targetObject.deployBase))
      {
         if(%targetObject.deployBase.baseGenerator)
         {
            if(%data.hasDamageRadius)
               %targetObject.deployBase.damage(%source, %position, %data.indirectDamage * %modifier * 0.1, %data.indirectDamageType);
            else
               %targetObject.deployBase.damage(%source, %position, %data.directDamage * %modifier * 0.05, %data.directDamageType);
         }
         else
         {
            if(%data.hasDamageRadius)
               %targetObject.deployBase.damage(%source, %position, %data.indirectDamage * %modifier, %data.indirectDamageType);
            else
               %targetObject.deployBase.damage(%source, %position, %data.directDamage * %modifier, %data.directDamageType);
         }
      }
      FFReflectProjectile(%projectile, %targetObject, %normal);
   }
   else
      %targetObject.damage(%source, %position, %data.directDamage * %modifier, %data.directDamageType);   //console error when using raxx -Nite- (not fixed yet)
}

function SniperProjectileData::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal)
{
   %damageAmount = %projectile.doNormalDamage == true ? %projectile.normalDmg : (%data.directDamage * %projectile.damageFactor);

   if(%projectile.bkSourceObject)
      if(isObject(%projectile.bkSourceObject))
         %projectile.sourceObject = %projectile.bkSourceObject;

   if(%targetObject.getDataBlock().getClassName() $= "PlayerData")
   {
      %damLoc = firstWord(%targetObject.getDamageLocation(%position));
      if(%damLoc $= "head")
      {
         %targetObject.getOwnerClient().headShot = 1; // OMG They killed kenny!
         %modifier = %data.rifleHeadMultiplier;
      }
      else
      {
         %modifier = 1;
         %targetObject.getOwnerClient().headShot = 0;
      }
   }
   if(%targetObject.isFF)
          %targetObject.deployBase.damage(%projectile.sourceObject, %position, %data.directDamage * %modifier, %data.directDamageType);
   else
          %targetObject.damage(%projectile.sourceObject, %position, %data.directDamage * %modifier, %data.directDamageType);
}

function ShapeBaseImageData::onFire(%data, %obj, %slot)
{
   %data.lightStart = getSimTime();

//   if( %obj.station $= "" && %obj.isCloaked() )
//   {
//      if( %obj.respawnCloakThread !$= "" )
//      {
//         Cancel(%obj.respawnCloakThread);
//         %obj.setCloaked( false );
//         %obj.respawnCloakThread = "";
//      }
//      else
//      {
//         if( %obj.getEnergyLevel() > 20 )
//         {
//            %obj.setCloaked( false );
//            %obj.reCloak = %obj.schedule( 500, "setCloaked", true );
//         }
//      }
//   }

   %vehicle = 0;
   if(%data.usesEnergy)
   {
      if(%data.useMountEnergy)
      {
         %useEnergyObj = %obj.getObjectMount();
         if(!%useEnergyObj)
            %useEnergyObj = %obj;
         %energy = %useEnergyObj.getEnergyLevel();
         %vehicle = %useEnergyObj;
      }
      else
         %energy = %obj.getEnergyLevel();

      if(%data.useCapacitor && %data.usesEnergy)
      {
         if( %useEnergyObj.turretObject.getCapacitorLevel() < %data.minEnergy )
         {
            return;
         }
      }
      else if(%energy < %data.minEnergy)
         return;
   }
   if(%data.projectileSpread)
   {
      %vector = %obj.getMuzzleVector(%slot);
      %x = (getRandom() - 0.5) * 2 * 3.1415926 * %data.projectileSpread;
      %y = (getRandom() - 0.5) * 2 * 3.1415926 * %data.projectileSpread;
      %z = (getRandom() - 0.5) * 2 * 3.1415926 * %data.projectileSpread;
      %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
      %vector = MatrixMulVector(%mat, %vector);

      %p = new (%data.projectileType)() {
         dataBlock        = %data.projectile;
         initialDirection = %vector;
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
      };
   }
   else
   {
      %p = new (%data.projectileType)() {
         dataBlock        = %data.projectile;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
      };
   }

   if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);

   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

   if(%data.usesEnergy)
   {
      if(%data.useMountEnergy)
      {
         if( %data.useCapacitor )
            %vehicle.turretObject.setCapacitorLevel( %vehicle.turretObject.getCapacitorLevel() - %data.fireEnergy );
         else
            %useEnergyObj.setEnergyLevel(%energy - %data.fireEnergy);
      }
      else
         %obj.setEnergyLevel(%energy - %data.fireEnergy);
   }
   else
      %obj.decInventory(%data.ammo,1);

   return %p;
}

function ForcefieldBare::isMounted(){   return false;   }
function ForcefieldBare::shouldApplyImpulse(){   return false;   }
function ForcefieldBare::damage(){}

function RadiusExplosion(%explosionSource, %position, %radius, %damage, %impulse, %sourceObject, %damageType)
{
//   error("RadiusExplosion("@%explosionSource@", "@%position@", "@%radius@", "@%damage@", "@%impulse@", "@%sourceObject@", "@%damageType@" )");

   InitContainerRadiusSearch(%position, %radius, $TypeMasks::PlayerObjectType      |
                                                 $TypeMasks::VehicleObjectType     |
                                                 $TypeMasks::StaticShapeObjectType |
                                                 $TypeMasks::TurretObjectType      |
                                                 $TypeMasks::ForceFieldObjectType  |
                                                 $TypeMasks::CorpseObjectType      |
                                                 $TypeMasks::ItemObjectType);

   %numTargets = 0;
   while ((%targetObject = containerSearchNext()) != 0)
   {
      if(!isObject(%targetObject)) // bug!
         return;

      %dist = containerSearchCurrRadDamageDist();

      if (%dist > %radius)
         continue;

      if(%targetObject.isMounted())
      {
         %mount = %targetObject.getObjectMount();
         %found = -1;
         for (%i = 0; %i < %mount.getDataBlock().numMountPoints; %i++)
         {
            if (%mount.getMountNodeObject(%i) == %targetObject)
            {
               %found = %i;
               break;
            }
         }

         if (%found != -1)
         {
            if(%mount.getDataBlock().isProtectedMountPoint[%found] && %mount.getEnergyLevel() < 5)
               continue;
         }
      }

      %targets[%numTargets]     = %targetObject;
      %targetDists[%numTargets] = %dist;
      %numTargets++;
   }

   for (%i = 0; %i < %numTargets; %i++)
   {
      %targetObject = %targets[%i];
      %dist = %targetDists[%i];

      if(!isObject(%targetObject))
         continue;

      %coverage = calcExplosionCoverage(%position, %targetObject,
                                        ($TypeMasks::InteriorObjectType |
                                         $TypeMasks::TerrainObjectType |
                                         $TypeMasks::ForceFieldObjectType |
                                         $TypeMasks::StaticShapeObjectType |
                                         $TypeMasks::VehicleObjectType));
      if (%coverage == 0)
         continue;

      //if ( $splashTest )
         %amount = (1.0 - ((%dist / %radius) * 0.75)) * %coverage * %damage;
      //else
         //%amount = (1.0 - (%dist / %radius)) * %coverage * %damage;

      //error( "damage: " @ %amount @ " at distance: " @ %dist @ " radius: " @ %radius @ " maxDamage: " @ %damage );

      %data = %targetObject.getDataBlock();
      %className = %data.className;

      if(%impulse && %data.shouldApplyImpulse(%targetObject))
      {
         %p = %targetObject.getWorldBoxCenter();
         %momVec = VectorSub(%p, %position);
         %momVec = VectorNormalize(%momVec);
         %impulseVec = VectorScale(%momVec, %impulse * (1.0 - (%dist / %radius)));
         %doImpulse = true;
      }
      else if( %className $= WheeledVehicleData || %className $= FlyingVehicleData || %className $= HoverVehicleData )
      {
         %p = %targetObject.getWorldBoxCenter();
         %momVec = VectorSub(%p, %position);
         %momVec = VectorNormalize(%momVec);
         %impulseVec = VectorScale(%momVec, %impulse * (1.0 - (%dist / %radius)));


         if( getWord( %momVec, 2 ) < -0.5 )
            %momVec = "0 0 1";

         // Add obj's velocity into the momentum vector
//         %velocity = %targetObject.getVelocity();
         //%momVec = VectorNormalize( vectorAdd( %momVec, %velocity) );
         %doImpulse = true;

         if(%targetObject.usesCPS && %targetObject.getEnergyPct() >= 0.1) // needs at least 10% shields
            %doImpulse = false;
      }
      else
      {
         %momVec = "0 0 1";
         %doImpulse = false;
      }

      if(isObject(%targetObject))
      {
         if(%explosionSource.pDmgMod)
            %amount *= %explosionSource.pDmgMod;

         if(%amount > 0)
         {
            if(isObject(%targetObject.deployBase))
            {
               if(%targetObject.isFF)
                  %targetObject.deployBase.damage(%sourceObject, %position, %amount, %damageType);
               else
                  %targetObject.damage(%sourceObject, %position, %amount, %damageType);
            }
            else
               %targetObject.damage(%sourceObject, %position, %amount, %damageType);
         }
         else if( %explosionSource.getDataBlock().getName() $= "ConcussionGrenadeThrown" && %data.getClassName() $= "PlayerData" )
   	   {
             %data.applyConcussion( %dist, %radius, %sourceObject, %targetObject );

             if(!$teamDamage && %sourceObject != %targetObject && %sourceObject.client.team == %targetObject.client.team)
                messageClient(%targetObject.client, 'msgTeamConcussionGrenade', '\c1You were hit by %1\'s concussion grenade.', getTaggedString(%sourceObject.client.name));
         }
      }

      if( %doImpulse && !%targetObject.inertialDampener && !%targetObject.getDatablock().forceSensitive)
         %targetObject.applyImpulse(%position, %impulseVec);
   }
}

//--------------------------------------------------------------------------
// Loading GUI
//--------------------------------------
function sendLoadInfoToClient( %client )
{
   %singlePlayer = $CurrentMissionType $= "SinglePlayer";
//   %dynamicColor = "<color:"@getRandom(99, 10)@"dbea>"; // ROFL
   messageClient( %client, 'MsgLoadInfo', "", $CurrentMission, $MissionDisplayName, "Meltdown 2 "@$status);

   // Send map quote:
   for ( %line = 0; %line < $LoadQuoteLineCount; %line++ )
   {
      if ( $LoadQuoteLine[%line] !$= "" )
         messageClient( %client, 'MsgLoadQuoteLine', "", $LoadQuoteLine[%line] );
   }

   // Send map objectives:
   if ( %singlePlayer )
   {
      switch ( $pref::TrainingDifficulty )
      {
         case 2:  %diff = "Medium";
         case 3:  %diff = "Hard";
         default: %diff = "Easy";
      }
      messageClient( %client, 'MsgLoadObjectiveLine', "", "<spush><font:" @ $ShellLabelFont @ ":" @ $ShellMediumFontSize @ ">DIFFICULTY: <spop>" @ %diff );
   }

   for ( %line = 0; %line < $LoadObjLineCount; %line++ )
   {
      if ( $LoadObjLine[%line] !$= "" )
         messageClient( %client, 'MsgLoadObjectiveLine', "", $LoadObjLine[%line], !%singlePlayer );
   }

   // onStartup() hehehe  // -Nite-
   messageClient( %client, 'MsgLoadRulesLine', "", "<spush><font:Univers Condensed:18>Made by <color:fe2322>Keen<color:42dbea> and modified by<color:fe2322> -Nite-, Southtown, and Keen<spop>", !$SinglePlayer );
   messageClient( %client, 'MsgLoadRulesLine', "", "<spush><color:cccc33>Meltdown 2 v1490 \"Rumble Edition\" returned from the grave.", !$SinglePlayer );
   messageClient( %client, 'MsgLoadRulesLine', "", "<spush><color:bbbbbb>For more information, go to <color:ffffff><a:wwwlink	radiantage.com>http://radiantage.com</a><spop>", !$SinglePlayer );
   messageClient( %client, 'MsgLoadRulesLine', "", "<spush><color:42dbea>"@$StartupScreenMSG@"<spop>", false );

   messageClient( %client, 'MsgLoadInfoDone' );
}

//--------------------------------------------------------------------------
// Grenade/Mine code
//--------------------------------------

function MortarGrenadeThrown::onThrow(%this, %gren)
{
   AIGrenadeThrown(%gren);
   %gren.detThread = schedule(2000, %gren, "detonateGrenade", %gren);
}

function EMPGrenadeThrown::onThrow(%this, %gren)
{
   AIGrenadeThrown(%gren);
   %gren.detThread = schedule(2000, %gren, "detonateGrenade", %gren);
}

function FireGrenadeThrown::onThrow(%this, %gren)
{
   AIGrenadeThrown(%gren);
   %gren.detThread = schedule(2000, %gren, "detonateGrenade", %gren);
}

function PoisonGrenadeThrown::onThrow(%this, %gren)
{
   AIGrenadeThrown(%gren);
   %gren.detThread = schedule(2000, %gren, "detonateGrenade", %gren);
}

function BoosterGrenadeThrown::onThrow(%this, %gren)
{
   %gren.setVelocity("0 0 0");
   %gren.detThread = schedule(32, %gren, "detonateGrenade", %gren); // AHHAHAHHAHA

//   %gren.delete();
//   applyKick(%this, 2500); // %this is not the thrower
}

function MineDeployed::onThrow(%this, %mine, %thrower)
{
   %mine.armed = false;
   %mine.damaged = 0;
   %mine.detonated = false;
   %mine.depCount = 0;
   %mine.team = %thrower.client.team;
   %mine.theClient = %thrower.client;
   schedule(1500, %mine, "deployMineCheck", %mine, %thrower);
}

function LargeMineDeployed::onThrow(%this, %mine, %thrower)
{
   %mine.armed = false;
   %mine.damaged = 0;
   %mine.detonated = false;
   %mine.depCount = 0;
   %mine.theClient = %thrower.client;
   %mine.setScale("4 4 4");
   schedule(1500, %mine, "deployMineCheck", %mine, %thrower);
}

function CloakMineDeployed::onThrow(%this, %mine, %thrower)
{
   %mine.armed = false;
   %mine.damaged = 0;
   %mine.detonated = false;
   %mine.depCount = 0;
   %mine.theClient = %thrower.client;
   %mine.setCloaked(true);
   schedule(1500, %mine, "deployMineCheck", %mine, %thrower);
}

function EMPMineDeployed::onThrow(%this, %mine, %thrower)
{
   %mine.armed = false;
   %mine.damaged = 0;
   %mine.detonated = false;
   %mine.depCount = 0;
   %mine.theClient = %thrower.client;
   schedule(1500, %mine, "deployMineCheck", %mine, %thrower);
}

function IncendiaryMineDeployed::onThrow(%this, %mine, %thrower)
{
   %mine.armed = false;
   %mine.damaged = 0;
   %mine.detonated = false;
   %mine.depCount = 0;
   %mine.theClient = %thrower.client;
   schedule(1500, %mine, "deployMineCheck", %mine, %thrower);
}

function BlastechMineDeployed::onThrow(%this, %mine, %thrower)
{
   %mine.armed = false;
   %mine.damaged = 0;
   %mine.detonated = false;
   %mine.depCount = 0;
   %mine.theClient = %thrower.client;
   schedule(1500, %mine, "deployMineCheck", %mine, %thrower);
}

function deployMineCheck(%mineObj, %player)
{
   if(%mineObj.depCount > %mineObj.getDatablock().maxDepCount)
      explodeMine(%mineObj, true);

   // wait until the mine comes to rest
   if(%mineObj.getVelocity() $= "0 0 0")
   {
      // 2-second delay before mine is armed -- let deploy thread play out etc.
      schedule(%mineObj.getDatablock().armTime, %mineObj, "armDeployedMine", %mineObj);


      // check for other deployed mines in the vicinity
      InitContainerRadiusSearch(%mineObj.getWorldBoxCenter(), %mineObj.getDatablock().spacing, $TypeMasks::ItemObjectType);
      while((%itemObj = containerSearchNext()) != 0)
      {
         if(%itemObj == %mineObj)
            continue;
         %ioType = %itemObj.getDatablock().getName();
         if(%ioType $= "MineDeployed" || %ioType $= "LargeMineDeployed" || %ioType $= "CloakMineDeployed" || %ioType $= "EMPMineDeployed" || %ioType $= "IncendiaryMineDeployed")
            schedule(100, %mineObj, "explodeMine", %mineObj, true);
         else
            continue;
      }
      // play "deploy" thread
      %mineObj.playThread(0, "deploy");
      serverPlay3D(MineDeploySound, %mineObj.getTransform());
      %mineTeam = %mineObj.sourceObject.team;
      $TeamDeployedCount[%mineTeam, MineDeployed]++;
      if($TeamDeployedCount[%mineTeam, MineDeployed] > $TeamDeployableMax[MineDeployed])
      {
         messageClient( %player.client, 'MsgMaxMines', 'Maximum allowable mines deployed.' );
         schedule(100, %mineObj, "explodeMine", %mineObj, true);
      }
      else
      {
         //start the thread that keeps checking for objects near the mine...
         mineCheckVicinity(%mineObj);

         //let the AI know *after* it's come to rest...
         AIDeployMine(%mineObj);

         //let the game know there's a deployed mine
         Game.notifyMineDeployed(%mineObj);
      }
   }
   else
   {
      //schedule this deploy check again a little later
      %mineObj.depCount++;
      schedule(500, %mineObj, "deployMineCheck", %mineObj, %player);
   }
}

function armDeployedMine(%mine)
{
   %mine.armed = true;
}

function mineCheckVicinity(%mine)
{
   // this function is called after the mine has been deployed. It will check the
   // immediate area around the mine (2.5 meters at present) for players or vehicles
   // passing by, and detonate if any are found. This is to extend the range of the
   // mine so players don't have to collide with them to set them off.

   // don't bother to check if mine isn't armed yet
   if(%mine.armed)
      // don't keep checking if mine is already detonating
      if(!%mine.boom)
      {
         // the actual check for objects in the area
         %mineLoc = %mine.getWorldBoxCenter();
         %masks = $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType;
         %detonateRange = %mine.getDatablock().proximity;

         InitContainerRadiusSearch(%mineLoc, %detonateRange, %masks);
         while((%tgt = containerSearchNext()) != 0)
         {
            if(%mine.team != %tgt.client.team)
            {
                 %mine.detonated = true;
                 schedule(50, %mine, "explodeMine", %mine, false);
                 break;
            }
         }
      }
   // if nothing set off the mine, schedule another check
   if(!%mine.detonated)
      schedule(300, %mine, "mineCheckVicinity", %mine);
}

function MineDeployed::onCollision(%data, %obj, %col)
{
   // don't detonate if mine isn't armed yet
   if(!%obj.armed)
      return;

   // don't detonate if mine is already detonating
   if(%obj.boom)
      return;

   //check to see what it is that collided with the mine
   %struck = %col.getClassName();
   if(%struck $= "Player" || %struck $= "WheeledVehicle" || %struck $= "FlyingVehicle")
   {
      if(%col.client)
      {
          if(%col.client.team != %obj.team)
               explodeMine(%obj, false);
      }
      else
           explodeMine(%obj, false);
   }
}

function LargeMineDeployed::onCollision(%data, %obj, %col)
{
   // don't detonate if mine isn't armed yet
   if(!%obj.armed)
      return;

   // don't detonate if mine is already detonating
   if(%obj.boom)
      return;

   //check to see what it is that collided with the mine
   %struck = %col.getClassName();
   if(%struck $= "Player" || %struck $= "WheeledVehicle" || %struck $= "FlyingVehicle")
   {
      if(%col.client)
      {
          if(%col.client.team != %obj.team)
               explodeMine(%obj, false);
      }
      else
           explodeMine(%obj, false);
   }
}

function CloakMineDeployed::onCollision(%data, %obj, %col)
{
   // don't detonate if mine isn't armed yet
   if(!%obj.armed)
      return;

   // don't detonate if mine is already detonating
   if(%obj.boom)
      return;

   //check to see what it is that collided with the mine
   %struck = %col.getClassName();
   if(%struck $= "Player" || %struck $= "WheeledVehicle" || %struck $= "FlyingVehicle")
   {
      if(%col.client)
      {
          if(%col.client.team != %obj.team)
               explodeMine(%obj, false);
      }
      else
           explodeMine(%obj, false);
   }
}

function EMPMineDeployed::onCollision(%data, %obj, %col)
{
   // don't detonate if mine isn't armed yet
   if(!%obj.armed)
      return;

   // don't detonate if mine is already detonating
   if(%obj.boom)
      return;

   //check to see what it is that collided with the mine
   %struck = %col.getClassName();
   if(%struck $= "Player" || %struck $= "WheeledVehicle" || %struck $= "FlyingVehicle")
   {
      if(%col.client)
      {
          if(%col.client.team != %obj.team)
               explodeMine(%obj, false);
      }
      else
           explodeMine(%obj, false);
   }
}

function IncendiaryMineDeployed::onCollision(%data, %obj, %col)
{
   // don't detonate if mine isn't armed yet
   if(!%obj.armed)
      return;

   // don't detonate if mine is already detonating
   if(%obj.boom)
      return;

   //check to see what it is that collided with the mine
   %struck = %col.getClassName();
   if(%struck $= "Player" || %struck $= "WheeledVehicle" || %struck $= "FlyingVehicle")
   {
      if(%col.client)
      {
          if(%col.client.team != %obj.team)
               explodeMine(%obj, false);
      }
      else
           explodeMine(%obj, false);
   }
}

function BlastechMineDeployed::onCollision(%data, %obj, %col)
{
   // don't detonate if mine isn't armed yet
   if(!%obj.armed)
      return;

   // don't detonate if mine is already detonating
   if(%obj.boom)
      return;

   //check to see what it is that collided with the mine
   %struck = %col.getClassName();
   if(%struck $= "Player" || %struck $= "WheeledVehicle" || %struck $= "FlyingVehicle")
   {
      if(%col.client)
      {
          if(%col.client.team != %obj.team)
               explodeMine(%obj, false);
      }
      else
           explodeMine(%obj, false);
   }
}

function explodeMine(%mo, %noDamage)
{
   %mo.noDamage = %noDamage;
   %mo.setDamageState(Destroyed);
}

function MineDeployed::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType)
{
   if(!%targetObject.armed)
      return;

   if(%targetObject.boom)
      return;

   %targetObject.damaged += %amount;

   if(%targetObject.damaged >= %data.maxDamage)
      %targetObject.setDamageState(Destroyed);
}

function LargeMineDeployed::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType)
{
   if(!%targetObject.armed)
      return;

   if(%targetObject.boom)
      return;

   %targetObject.damaged += %amount;

   if(%targetObject.damaged >= %data.maxDamage)
   {
      %targetObject.setDamageState(Destroyed);
   }
}

function CloakMineDeployed::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType)
{
   if(!%targetObject.armed)
      return;

   if(%targetObject.boom)
      return;

   %targetObject.damaged += %amount;

   if(%targetObject.damaged >= %data.maxDamage)
   {
      %targetObject.setDamageState(Destroyed);
   }
}

function EMPMineDeployed::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType)
{
   if(!%targetObject.armed)
      return;

   if(%targetObject.boom)
      return;

   %targetObject.damaged += %amount;

   if(%targetObject.damaged >= %data.maxDamage)
   {
      %targetObject.setDamageState(Destroyed);
   }
}

function IncendiaryMineDeployed::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType)
{
   if(!%targetObject.armed)
      return;

   if(%targetObject.boom)
      return;

   %targetObject.damaged += %amount;

   if(%targetObject.damaged >= %data.maxDamage)
   {
      %targetObject.setDamageState(Destroyed);
   }
}

function BlastechMineDeployed::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType)
{
   if(!%targetObject.armed)
      return;

   if(%targetObject.boom)
      return;

   %targetObject.damaged += %amount;

   if(%targetObject.damaged >= %data.maxDamage)
   {
      %targetObject.setDamageState(Destroyed);
   }
}

function MineDeployed::onDestroyed(%data, %obj, %lastState)
{
   %obj.boom = true;
   %mineTeam = %obj.team;
   $TeamDeployedCount[%mineTeam, MineDeployed]--;
   // %noDamage is a boolean flag -- don't want to set off all other mines in
   // vicinity if there's a "mine overload", so apply no damage/impulse if true
   if(!%obj.noDamage)
      RadiusExplosion(%obj, %obj.getPosition(), %data.damageRadius, %data.indirectDamage,
                      %data.kickBackStrength, %obj.sourceObject, %data.radiusDamageType);

   %obj.schedule(600, "delete");
}

function LargeMineDeployed::onDestroyed(%data, %obj, %lastState)
{
   %obj.boom = true;
   %mineTeam = %obj.team;
   $TeamDeployedCount[%mineTeam, MineDeployed]--;
   // %noDamage is a boolean flag -- don't want to set off all other mines in
   // vicinity if there's a "mine overload", so apply no damage/impulse if true
   if(!%obj.noDamage)
      RadiusExplosion(%obj, %obj.getPosition(), %data.damageRadius, %data.indirectDamage,
                      %data.kickBackStrength, %obj.sourceObject, %data.radiusDamageType);

   %obj.schedule(600, "delete");
}

function CloakMineDeployed::onDestroyed(%data, %obj, %lastState)
{
   %obj.boom = true;
   %mineTeam = %obj.team;
   $TeamDeployedCount[%mineTeam, MineDeployed]--;
   // %noDamage is a boolean flag -- don't want to set off all other mines in
   // vicinity if there's a "mine overload", so apply no damage/impulse if true
   if(!%obj.noDamage)
      RadiusExplosion(%obj, %obj.getPosition(), %data.damageRadius, %data.indirectDamage,
                      %data.kickBackStrength, %obj.sourceObject, %data.radiusDamageType);

   %obj.schedule(600, "delete");
}

function EMPMineDeployed::onDestroyed(%data, %obj, %lastState)
{
   %obj.boom = true;
   %mineTeam = %obj.team;
   $TeamDeployedCount[%mineTeam, MineDeployed]--;
   // %noDamage is a boolean flag -- don't want to set off all other mines in
   // vicinity if there's a "mine overload", so apply no damage/impulse if true
   if(!%obj.noDamage)
      RadiusExplosion(%obj, %obj.getPosition(), %data.damageRadius, %data.indirectDamage,
                      %data.kickBackStrength, %obj.sourceObject, %data.radiusDamageType);

   %obj.schedule(600, "delete");
}

function IncendiaryMineDeployed::onDestroyed(%data, %obj, %lastState)
{
   %obj.boom = true;
   %mineTeam = %obj.team;
   $TeamDeployedCount[%mineTeam, MineDeployed]--;
   // %noDamage is a boolean flag -- don't want to set off all other mines in
   // vicinity if there's a "mine overload", so apply no damage/impulse if true
   if(!%obj.noDamage)
      RadiusExplosion(%obj, %obj.getPosition(), %data.damageRadius, %data.indirectDamage,
                      %data.kickBackStrength, %obj.sourceObject, %data.radiusDamageType);

   %obj.schedule(600, "delete");
}

function BlastechMineDeployed::onDestroyed(%data, %obj, %lastState)
{
   %obj.boom = true;
   %mineTeam = %obj.team;
   $TeamDeployedCount[%mineTeam, MineDeployed]--;
   // %noDamage is a boolean flag -- don't want to set off all other mines in
   // vicinity if there's a "mine overload", so apply no damage/impulse if true
   if(!%obj.noDamage)
      RadiusExplosion(%obj, %obj.getPosition(), %data.damageRadius, %data.indirectDamage,
                      %data.kickBackStrength, %obj.sourceObject, %data.radiusDamageType);

   %obj.schedule(600, "delete");
}

//--------------------------------------------------------------------------
// Initial ::onChange function (beacon)
//--------------------------------------

function Beacon::onUse(%data, %obj)
{
   // look for 3 meters along player's viewpoint for interior or terrain
   %searchRange = 3.0;
   %mask = $TypeMasks::TerrainObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::StaticShapeObjectType | $TypeMasks::ForceFieldObjectType;
   // get the eye vector and eye transform of the player
   %eyeVec = %obj.getEyeVector();
   %eyeTrans = %obj.getEyeTransform();
   // extract the position of the player's camera from the eye transform (first 3 words)
   %eyePos = posFromTransform(%eyeTrans);
   // normalize the eye vector
   %nEyeVec = VectorNormalize(%eyeVec);
   // scale (lengthen) the normalized eye vector according to the search range
   %scEyeVec = VectorScale(%nEyeVec, %searchRange);
   // add the scaled & normalized eye vector to the position of the camera
   %eyeEnd = VectorAdd(%eyePos, %scEyeVec);
   // see if anything gets hit
   %searchResult = containerRayCast(%eyePos, %eyeEnd, %mask, 0);
   if(!%searchResult )
   {

     changeWeaponMode(%obj);
     return 0;
   }
   else
   {
      %searchObj = GetWord(%searchResult, 0);
      if(%searchObj.getType() & ($TypeMasks::StaticShapeObjectType | $TypeMasks::ForceFieldObjectType) )
      {
         // if there's already a beacon where player is aiming, switch its type
         // otherwise, player can't deploy a beacon there
         if(%searchObj.getDataBlock().getName() $= DeployedBeacon)
            switchBeaconType(%searchObj);
         else
            messageClient(%obj.client, 'MsgBeaconNoSurface', '\c2Cannot place beacon. Not a valid surface.');
         return 0;
      }
      else if(%obj.inv[%data.getName()] <= 0)
         return 0;
   }
   // newly deployed beacons default to "target" type
   if($TeamDeployedCount[%obj.team, TargetBeacon] >= $TeamDeployableMax[TargetBeacon])
   {
      messageClient(%obj.client, 'MsgDeployFailed', '\c2Your team\'s control network has reached its capacity for this item.~wfx/misc/misc.error.wav');
      return 0;
   }
   %terrPt = posFromRaycast(%searchResult);
   %terrNrm = normalFromRaycast(%searchResult);

   %intAngle = getTerrainAngle(%terrNrm);  // getTerrainAngle() function found in staticShape.cs
   %rotAxis = vectorNormalize(vectorCross(%terrNrm, "0 0 1"));
   if (getWord(%terrNrm, 2) == 1 || getWord(%terrNrm, 2) == -1)
      %rotAxis = vectorNormalize(vectorCross(%terrNrm, "0 1 0"));
   %rotation = %rotAxis @ " " @ %intAngle;

   %obj.decInventory(%data, 1);
   %depBeac = new BeaconObject() {
      dataBlock = "DeployedBeacon";
      position = VectorAdd(%terrPt, VectorScale(%terrNrm, 0.05));
      rotation = %rotation;
   };
   $TeamDeployedCount[%obj.team, TargetBeacon]++;

   %depBeac.playThread($AmbientThread, "ambient");
   %depBeac.team = %obj.team;
   %depBeac.sourceObject = %obj;

   // give it a team target
   %depBeac.setTarget(%depBeac.team);
   MissionCleanup.add(%depBeac);
   %depBeac.setBeaconType(friend);
}

function RepairKit::onUse(%data,%obj)
{
   // Don't use the kit unless we're damaged
   if (%obj.getDamageLevel() != 0)
   {
      %obj.burnTime = 1;
      %obj.PoisonTime = 1;
      %obj.EMPTime = 1;

      %obj.decInventory(%data,1);
      %obj.applyRepair(0.2);
      messageClient(%obj.client, 'MsgRepairKitUsed', '\c2Repair Kit Used.');
   }
}

//--------------------------------------------------------------------------
//
//--------------------------------------

function RepairPatch::onCollision(%data,%obj,%col)
{
   if ( %col.getDataBlock().className $= Armor
     && %col.getDamageLevel() != 0
     && %col.getState() !$= "Dead" )
   {
      if (%col.isMounted())
         return;

      %col.burnTime = 1;
      %col.PoisonTime = 1;
      %col.EMPTime = 1;

      %col.playAudio(0, RepairPatchSound);
      %col.applyRepair(0.125);
      %obj.respawn();

      if (%col.client > 0)
         messageClient(%col.client, 'MsgItemPickup', '\c0You picked up %1.', %data.pickUpName);
   }
}

function stationTrigger::onEnterTrigger(%data, %obj, %colObj)
{
	//make sure it's a player object, and that that object is still alive
 //-Nite- removed tatic mech from this line
   if(%colObj.getDataBlock().className !$= "Armor" || %colObj.getState() $= "Dead")
      return;

   %colObj.inStation = true;
   commandToClient(%colObj.client,'setStationKeys', true);
   if(Game.stationOnEnterTrigger(%data, %obj, %colObj)) {
      //verify station.team is team associated and isn't on player's team
      if((%obj.mainObj.team != %colObj.client.team) && (%obj.mainObj.team != 0))
      {
         %obj.station.playAudio(2, StationAccessDeniedSound);
         messageClient(%colObj.client, 'msgStationDenied', '\c2Wrong team, buddy.');
      }
      else if(%obj.disableObj.isDisabled())
      {
         messageClient(%colObj.client, 'msgStationDisabled', '\c2I require repairs.');
      }
      else if(!%obj.mainObj.isPowered())
      {
         messageClient(%colObj.client, 'msgStationNoPower', '\c2Hmm... no power.');
      }
      else if(%obj.station.notDeployed)
      {
         messageClient(%colObj.client, 'msgStationNotDeployed', '\c2Station is not deployed.');
      }
      else if(%obj.station.triggeredBy $= "")
      {
         if(%obj.station.getDataBlock().setPlayersPosition(%obj.station, %obj, %colObj))
         {
//            %colObj.setInvincible(true);
//            schedule(500, %colObj, "checkInvicibleTag", %colObj);
            messageClient(%colObj.client, 'CloseHud', "", 'inventoryScreen');
            commandToClient(%colObj.client, 'TogglePlayHuds', true);
            %obj.station.triggeredBy = %colObj;
            %obj.station.getDataBlock().stationTriggered(%obj.station, 1);
            %colObj.station = %obj.station;
            %colObj.lastWeapon = ( %colObj.getMountedImage($WeaponSlot) == 0 ) ? "" : %colObj.getMountedImage($WeaponSlot).getName().item;
            %colObj.unmountImage($WeaponSlot);
         }
      }
   }
}

function stationTrigger::onLeaveTrigger(%data, %obj, %colObj)
{
   if(%colObj.getDataBlock().className !$= "Armor")
      return;

   %colObj.setInvincible(false);
   %colObj.inStation = false;
   commandToClient(%colObj.client,'setStationKeys', false);
   if(%obj.station)
   {
      if(%obj.station.triggeredBy == %colObj)
      {
         %obj.station.getDataBlock().stationFinished(%obj.station);
         %obj.station.getDataBlock().endRepairing(%obj.station);
         %obj.station.triggeredBy = "";
         %obj.station.getDataBlock().stationTriggered(%obj.station, 0);

         if(!%colObj.teleporting)
            %colObj.station = "";
			if(%colObj.getMountedImage($WeaponSlot) == 0 && !%colObj.teleporting)
	      {
	         if(%colObj.inv[%colObj.lastWeapon])
	            %colObj.use(%colObj.lastWeapon);

            if(%colObj.getMountedImage($WeaponSlot) == 0)
               %colObj.selectWeaponSlot( 0 );
	      }
      }
   }
}

function checkTurretMount(%data, %obj, %slot)
{
   // search for a turret base in player's LOS
   %eyeVec = VectorNormalize(%obj.getEyeVector());
   %srchRange = VectorScale(%eyeVec, 5.0); // look 5m for a turret base
   %plTm = %obj.getEyeTransform();
   %plyrLoc = firstWord(%plTm) @ " " @ getWord(%plTm, 1) @ " " @ getWord(%plTm, 2);
   %srchEnd = VectorAdd(%plyrLoc, %srchRange);
   %potTurret = ContainerRayCast(%obj.getEyeTransform(), %srchEnd, $TypeMasks::TurretObjectType);
   if(%potTurret != 0)
   {
      if(%potTurret.getDatablock().getName() $= "TurretBaseLarge" || %potTurret.getDatablock().getName() $= "MobileTurretBase" || %potTurret.getDatablock().getName() $= "FreeBaseTurret") // || %potTurret.getDatablock().getName() $= "AssaultFlyerMainTurret"
      {
         // found a turret base, what team is it on?
         if(%potTurret.team == %obj.client.team)
         {
				if(%potTurret.getDamageState() !$= "Enabled")
				{
					// the base is destroyed
					messageClient(%obj.client, 'MsgBaseDestroyed', "\c2Turret base is disabled, cannot mount barrel.");
					%obj.setImageTrigger($BackpackSlot, false);
				}
				else
				{
		         // it's a functional turret base on our team! stick the barrel on it
		         messageClient(%obj.client, 'MsgTurretMount', "\c2Mounting barrel pack on turret base.");
		         serverPlay3D(TurretPackActivateSound, %potTurret.getTransform());
		         %potTurret.initiateBarrelSwap(%obj);
				}
         }
         else
         {
            // whoops, wrong team
            messageClient(%obj.client, 'MsgTryEnemyTurretMount', "\c2Cannot mount a barrel on an enemy turret base!");
            %obj.setImageTrigger($BackpackSlot, false);
         }
      }
      else
      {
         // tried to mount barrel on some other turret type
         messageClient(%obj.client, 'MsgNotTurretBase', "\c2Can only mount a barrel on a turret base.");
         %obj.setImageTrigger($BackpackSlot, false);
      }
   }
   else
   {
      // I don't see any turret
      messageClient(%obj.client, 'MsgNoTurretBase', "\c2No turret within range.");
      %obj.setImageTrigger($BackpackSlot, false);
   }
}

//--------------------------------------------------------------------------
//
//--------------------------------------

function Armor::onCollision(%this,%obj,%col,%forceVehicleNode)
{
   if (%obj.getState() $= "Dead")
      return;

   %dataBlock = %col.getDataBlock();
   %className = %dataBlock.className;
   %client = %obj.client;

//   if(%col.isFlaming)
//      %obj.burnObject(%col);

   // player collided with a vehicle
   %node = -1;
   if (%forceVehicleNode !$= "" || (%className $= WheeledVehicleData || %className $= FlyingVehicleData || %className $= HoverVehicleData) &&
         %obj.mountVehicle && %obj.getState() $= "Move" && %col.mountable && !%obj.inStation && %col.getDamageState() !$= "Destroyed") {

      //if the player is an AI, he should snap to the mount points in node order,
      //to ensure they mount the turret before the passenger seat, regardless of where they collide...
      if (%obj.client.isAIControlled())
      {
         %transform = %col.getTransform();

         //either the AI is *required* to pilot, or they'll pick the first available passenger seat
         if (%client.pilotVehicle)
         {
            //make sure the bot is in light armor
            if (%client.player.getArmorSize() $= "Light")
            {
               //make sure the pilot seat is empty
               if (!%col.getMountNodeObject(0))
                  %node = 0;
            }
         }
         else
            %node = findAIEmptySeat(%col, %obj);
      }
      else
         %node = findEmptySeat(%col, %obj, %forceVehicleNode);

      //now mount the player in the vehicle
      if(%node >= 0)
      {
         // players can't be pilots, bombardiers or turreteers if they have
         // "large" packs -- stations, turrets, turret barrels
         if(hasLargePack(%obj)) {
            // check to see if attempting to enter a "sitting" node
            if(nodeIsSitting(%datablock, %node)) {
               // send the player a message -- can't sit here with large pack
               if(!%obj.noSitMessage)
               {
                  %obj.noSitMessage = true;
                  %obj.schedule(2000, "resetSitMessage");
                  messageClient(%obj.client, 'MsgCantSitHere', '\c2Pack too large, can\'t occupy this seat.~wfx/misc/misc.error.wav');
               }
               return;
            }
         }
         if(%col.noEnemyControl && %obj.team != %col.team)
            return;

         commandToClient(%obj.client,'SetDefaultVehicleKeys', true);
         //If pilot or passenger then bind a few extra keys
         if(%node == 0)
            commandToClient(%obj.client,'SetPilotVehicleKeys', true);
         else
            commandToClient(%obj.client,'SetPassengerVehicleKeys', true);

         if(!%obj.inStation)
            %col.lastWeapon = ( %col.getMountedImage($WeaponSlot) == 0 ) ? "" : %col.getMountedImage($WeaponSlot).getName().item;
         else
            %col.lastWeapon = %obj.lastWeapon;

         %col.mountObject(%obj,%node);
         %col.playAudio(0, MountVehicleSound);
         %obj.mVehicle = %col;

			// if player is repairing something, stop it
			if(%obj.repairing)
				stopRepairing(%obj);

         //this will setup the huds as well...
         vehicleOnPlayerMounted(%dataBlock, %col, %obj.client);
         %dataBlock.playerMounted(%col,%obj, %node);
      }
   }
   else if (%className $= "Armor") {
      // player has collided with another player
      if(%col.getState() $= "Dead") {
         %gotSomething = false;
//         if(%obj.isFlaming)
//            %col.burnObject(%obj);
         // it's corpse-looting time!
         // weapons -- don't pick up more than you are allowed to carry!
         for(%i = 0; ( %obj.weaponCount < %obj.getDatablock().maxWeapons ) && $InvWeapon[%i] !$= ""; %i++)
         {
            %weap = $NameToInv[$InvWeapon[%i]];
            if ( %col.hasInventory( %weap ) )
            {
               if ( %obj.incInventory(%weap, 1) > 0 )
               {
                  %col.decInventory(%weap, 1);
                  %gotSomething = true;
                  messageClient(%obj.client, 'MsgItemPickup', '\c0You picked up %1.', %weap.pickUpName);
               }
            }
         }
         // targeting laser:
         if ( %col.hasInventory( "TargetingLaser" ) )
         {
            if ( %obj.incInventory( "TargetingLaser", 1 ) > 0 )
            {
               %col.decInventory( "TargetingLaser", 1 );
               %gotSomething = true;
               messageClient( %obj.client, 'MsgItemPickup', '\c0You picked up a targeting laser.' );
            }
         }
         // ammo
         for(%j = 0; $ammoType[%j] !$= ""; %j++)
         {
            %ammoAmt = %col.inv[$ammoType[%j]];
            if(%ammoAmt)
            {
               // incInventory returns the amount of stuff successfully grabbed
               %grabAmt = %obj.incInventory($ammoType[%j], %ammoAmt);
               if(%grabAmt > 0)
               {
                  %col.decInventory($ammoType[%j], %grabAmt);
                  %gotSomething = true;
                  messageClient(%obj.client, 'MsgItemPickup', '\c0You picked up %1.', $ammoType[%j].pickUpName);
                  %obj.client.setWeaponsHudAmmo($ammoType[%j], %obj.getInventory($ammoType[%j]));
               }
            }
         }
         // figure out what type, if any, grenades the (live) player has
         %playerGrenType = "None";
         for(%x = 0; $InvGrenade[%x] !$= ""; %x++) {
            %gren = $NameToInv[$InvGrenade[%x]];
            %playerGrenAmt = %obj.inv[%gren];
            if(%playerGrenAmt > 0)
            {
               %playerGrenType = %gren;
               break;
            }
         }
         // grenades
         for(%k = 0; $InvGrenade[%k] !$= ""; %k++)
         {
            %gren = $NameToInv[$InvGrenade[%k]];
            %corpseGrenAmt = %col.inv[%gren];
            // does the corpse hold any of this grenade type?
            if(%corpseGrenAmt)
            {
               // can the player pick up this grenade type?
               if((%playerGrenType $= "None") || (%playerGrenType $= %gren))
               {
                  %taken = %obj.incInventory(%gren, %corpseGrenAmt);
                  if(%taken > 0)
                  {
                     %col.decInventory(%gren, %taken);
                     %gotSomething = true;
                     messageClient(%obj.client, 'MsgItemPickup', '\c0You picked up %1.', %gren.pickUpName);
                     %obj.client.setInventoryHudAmount(%gren, %obj.getInventory(%gren));
                  }
               }
               break;
            }
         }
         // figure out what type, if any, mines the (live) player has
         %playerMineType = "None";
         for(%y = 0; $InvMine[%y] !$= ""; %y++)
         {
            %mType = $NameToInv[$InvMine[%y]];
            %playerMineAmt = %obj.inv[%mType];
            if(%playerMineAmt > 0)
            {
               %playerMineType = %mType;
               break;
            }
         }
         // mines
         for(%l = 0; $InvMine[%l] !$= ""; %l++)
         {
            %mine = $NameToInv[$InvMine[%l]];
            %mineAmt = %col.inv[%mine];
            if(%mineAmt) {
               if((%playerMineType $= "None") || (%playerMineType $= %mine))
               {
                  %grabbed = %obj.incInventory(%mine, %mineAmt);
                  if(%grabbed > 0)
                  {
                     %col.decInventory(%mine, %grabbed);
                     %gotSomething = true;
                     messageClient(%obj.client, 'MsgItemPickup', '\c0You picked up %1.', %mine.pickUpName);
                     %obj.client.setInventoryHudAmount(%mine, %obj.getInventory(%mine));
                  }
               }
               break;
            }
         }
         // beacons
         %beacAmt = %col.inv[Beacon];
         if(%beacAmt)
         {
            %bTaken = %obj.incInventory(Beacon, %beacAmt);
            if(%bTaken > 0)
            {
               %col.decInventory(Beacon, %bTaken);
               %gotSomething = true;
               messageClient(%obj.client, 'MsgItemPickup', '\c0You picked up %1.', Beacon.pickUpName);
               %obj.client.setInventoryHudAmount(Beacon, %obj.getInventory(Beacon));
            }
         }
         // repair kit
         %rkAmt = %col.inv[RepairKit];
         if(%rkAmt)
         {
            %rkTaken = %obj.incInventory(RepairKit, %rkAmt);
            if(%rkTaken > 0)
            {
               %col.decInventory(RepairKit, %rkTaken);
               %gotSomething = true;
               messageClient(%obj.client, 'MsgItemPickup', '\c0You picked up %1.', RepairKit.pickUpName);
               %obj.client.setInventoryHudAmount(RepairKit, %obj.getInventory(RepairKit));
            }
         }
      }
      if(%gotSomething)
         %col.playAudio(0, CorpseLootingSound);
   }
}

$DisableFlagCaps = false;

function Flag::onCollision(%data,%obj,%col)
{
   if($DisableFlagCaps)
      return;

   if(%col.getDataBlock().className $= Armor)
   {
      if (%col.isMounted())
         return;

      // a player hit the flag
      Game.playerTouchFlag(%col, %obj);
   }
}

function CTFGame::playerTouchEnemyFlag(%game, %player, %flag)
{
   //-Nite- removed tatic mech  and Jet pack stuff
  // if(%player.getDatablock().isTacticalMech || %player.getDatablock().isBattleAngel || %player.getDatablock().isJugg || %player.jetpacking || $DevServer) // || %col.getDatablock().isBlastech
    //  return;
     if(%player.getDatablock().isBattleAngel || %player.getDatablock().isJugg || $DevServer) // || %col.getDatablock().isBlastech
      return;
      
   %client = %player.client;
   %player.holdingFlag = %flag;  //%player has this flag
   %flag.carrier = %player;  //this %flag is carried by %player

    %player.mountImage(FlagImage, $FlagSlot, true, %game.getTeamSkin(%flag.team));

   %game.playerGotFlagTarget(%player);
   //only cancel the return timer if the player is in bounds...
   if (!%client.outOfBounds)
   {
      cancel($FlagReturnTimer[%flag]);
      $FlagReturnTimer[%flag] = "";
   }

   //if this flag was "at home", see if both flags have now been taken
   if (%flag.isHome)
   {
		// tiebreaker score
		game.awardScoreFlagTouch( %client, %flag );

      %startStalemate = false;
      if ($TeamFlag[1] == %flag)
         %startStalemate = !$TeamFlag[2].isHome;
      else
         %startStalemate = !$TeamFlag[1].isHome;

      if (%startStalemate)
         %game.stalemateSchedule = %game.schedule(%game.stalemateTimeMS, beginStalemate);
   
   }

   %flag.hide(true);
   %flag.startFade(0, 0, false);         
   %flag.isHome = false;
   if(%flag.stand)
      %flag.stand.getDataBlock().onFlagTaken(%flag.stand);//animate, if exterior stand

   $flagStatus[%flag.team] = %client.nameBase;
   %teamName = %game.getTeamName(%flag.team);
   messageTeamExcept(%client, 'MsgCTFFlagTaken', '\c2Teammate %1 took the %2 flag.~wfx/misc/flag_snatch.wav', %client.name, %teamName, %flag.team, %client.nameBase);
   messageTeam(%flag.team, 'MsgCTFFlagTaken', '\c2Your flag has been taken by %1!~wfx/misc/flag_taken.wav',%client.name, 0, %flag.team, %client.nameBase);
   messageTeam(0, 'MsgCTFFlagTaken', '\c2%1 took the %2 flag.~wfx/misc/flag_snatch.wav', %client.name, %teamName, %flag.team, %client.nameBase);
   messageClient(%client, 'MsgCTFFlagTaken', '\c2You took the %2 flag.~wfx/misc/flag_snatch.wav', %client.name, %teamName, %flag.team, %client.nameBase);     
   logEcho(%client.nameBase@" (pl "@%player@"/cl "@%client@") took team "@%flag.team@" flag");
   
   //call the AI function
   %game.AIplayerTouchEnemyFlag(%player, %flag);

   //if the player is out of bounds, then in 3 seconds, it should be thrown back towards the in bounds area...
   if (%client.outOfBounds)
      %game.schedule(3000, "boundaryLoseFlag", %player);
}

function InventoryScreen::updateHud( %this, %client, %tag )
{
   %noSniperRifle = true;
   %armor = getArmorDatablock( %client, $NameToInv[%client.favorites[0]] );
   if ( %client.lastArmor !$= %armor )
   {
      %client.lastArmor = %armor;
      for ( %x = 0; %x < %client.lastNumFavs; %x++ )
         messageClient( %client, 'RemoveLineHud', "", 'inventoryScreen', %x );
      %setLastNum = true;
   }

   %cmt = $CurrentMissionType;
//Create - ARMOR - List
   %armorList = %client.favorites[0];
   for ( %y = 0; $InvArmor[%y] !$= ""; %y++ )
      if ( $InvArmor[%y] !$= %client.favorites[0] )
         %armorList = %armorList TAB $InvArmor[%y];

//Create - WEAPON - List
   for ( %y = 0; $InvWeapon[%y] !$= ""; %y++ )
   {
      %notFound = true;
      for ( %i = 0; %i < getFieldCount( %client.weaponIndex ); %i++ )
      {
         %WInv = $NameToInv[$InvWeapon[%y]];
         if ( ( $InvWeapon[%y] $= %client.favorites[getField( %client.weaponIndex,%i )] ) || !%armor.max[%WInv] )
         {
            %notFound = false;
            break;
         }
         else if ("PBW" $= $NameToInv[%client.favorites[getField( %client.weaponIndex,%i )]]) //  "SniperRifle" $= $NameToInv[%client.favorites[getField( %client.weaponIndex,%i )]] ||
         {
            %noSniperRifle = false;
            %packList = "noSelect\tEnergy Pack\tEnergy Pack must be used when \tPBW is selected!"; // Laser Rifle or
            %client.favorites[getField(%client.packIndex,0)] = "Energy Pack";
         }
      }

      if ( !($InvBanList[%cmt, %WInv]) )
      {
         if ( %notFound && %weaponList $= "" )
            %weaponList = $InvWeapon[%y];
         else if ( %notFound )
            %weaponList = %weaponList TAB $InvWeapon[%y];
      }
   }

//Create - PACK - List
   if ( %noSniperRifle )
   {
      if ( getFieldCount( %client.packIndex ) )
         %packList = %client.favorites[getField( %client.packIndex, 0 )];
      else
      {
         %packList = "EMPTY";
         %client.numFavs++;
      }
      for ( %y = 0; $InvPack[%y] !$= ""; %y++ )
      {
         %PInv = $NameToInv[$InvPack[%y]];
         if ( ( $InvPack[%y] !$= %client.favorites[getField( %client.packIndex, 0 )]) &&
         %armor.max[%PInv] && !($InvBanList[%cmt, %PInv]))
            %packList = %packList TAB $Invpack[%y];
      }
   }
//Create - GRENADE - List
   for ( %y = 0; $InvGrenade[%y] !$= ""; %y++ )
   {
      %notFound = true;
      for(%i = 0; %i < getFieldCount( %client.grenadeIndex ); %i++)
      {
         %GInv = $NameToInv[$InvGrenade[%y]];
         if ( ( $InvGrenade[%y] $= %client.favorites[getField( %client.grenadeIndex, %i )] ) || !%armor.max[%GInv] )
         {
            %notFound = false;
            break;
         }
      }
      if ( !($InvBanList[%cmt, %GInv]) )
      {
         if ( %notFound && %grenadeList $= "" )
            %grenadeList = $InvGrenade[%y];
         else if ( %notFound )
            %grenadeList = %grenadeList TAB $InvGrenade[%y];
      }
   }

//Create - MINE - List
   for ( %y = 0; $InvMine[%y] !$= "" ; %y++ )
   {
      %notFound = true;
      %MInv = $NameToInv[$InvMine[%y]];
      for ( %i = 0; %i < getFieldCount( %client.mineIndex ); %i++ )
         if ( ( $InvMine[%y] $= %client.favorites[getField( %client.mineIndex, %i )] ) || !%armor.max[%MInv] )
         {
            %notFound = false;
            break;
         }

      if ( !($InvBanList[%cmt, %MInv]) )
      {
         if ( %notFound && %mineList $= "" )
            %mineList = $InvMine[%y];
         else if ( %notFound )
            %mineList = %mineList TAB $InvMine[%y];
      }
   }
   %client.numFavsCount++;
   messageClient( %client, 'SetLineHud', "", %tag, 0, "Armor:", %armorList, armor, %client.numFavsCount );
   %lineCount = 1;

   for ( %x = 0; %x < %armor.maxWeapons; %x++ )
   {
      %client.numFavsCount++;
      if ( %x < getFieldCount( %client.weaponIndex ) )
      {
         %list = %client.favorites[getField( %client.weaponIndex,%x )];
         if ( %list $= Invalid )
         {
            %client.favorites[%client.numFavs] = "INVALID";
            %client.weaponIndex = %client.weaponIndex TAB %client.numFavs;
         }
      }
      else
      {
         %list = "EMPTY";
         %client.favorites[%client.numFavs] = "EMPTY";
         %client.weaponIndex = %client.weaponIndex TAB %client.numFavs;
         %client.numFavs++;
      }
      if ( %list $= empty )
         %list = %list TAB %weaponList;
      else
         %list = %list TAB %weaponList TAB "EMPTY";
      messageClient( %client, 'SetLineHud', "", %tag, %x + %lineCount, "Weapon Slot " @ %x + 1 @ ": ", %list , weapon, %client.numFavsCount );
   }
   %lineCount = %lineCount + %armor.maxWeapons;

   %client.numFavsCount++;
   if ( getField( %packList, 0 ) !$= empty && %noSniperRifle )
      %packList = %packList TAB "EMPTY";
   %packText = %packList;
   %packOverFlow = "";
   if ( strlen( %packList ) > 255 )
   {
      %packText = getSubStr( %packList, 0, 255 );
      %packOverFlow = getSubStr( %packList, 255, 512 );
   }
   messageClient( %client, 'SetLineHud', "", %tag, %lineCount, "Pack:", %packText, pack, %client.numFavsCount, %packOverFlow );
   %lineCount++;

   for( %x = 0; %x < %armor.maxGrenades; %x++ )
   {
      %client.numFavsCount++;
      if ( %x < getFieldCount( %client.grenadeIndex ) )
      {
         %list = %client.favorites[getField( %client.grenadeIndex, %x )];
         if (%list $= Invalid)
         {
            %client.favorites[%client.numFavs] = "INVALID";
            %client.grenadeIndex = %client.grenadeIndex TAB %client.numFavs;
         }
      }
      else
      {
         %list = "EMPTY";
         %client.favorites[%client.numFavs] = "EMPTY";
         %client.grenadeIndex = %client.grenadeIndex TAB %client.numFavs;
         %client.numFavs++;
      }

      if ( %list $= empty )
         %list = %list TAB %grenadeList;
      else
         %list = %list TAB %grenadeList TAB "EMPTY";

      messageClient( %client, 'SetLineHud', "", %tag, %x + %lineCount, "Grenade:", %list, grenade, %client.numFavsCount );
   }
   %lineCount = %lineCount + %armor.maxGrenades;

   for ( %x = 0; %x < %armor.maxMines; %x++ )
   {
      %client.numFavsCount++;
      if ( %x < getFieldCount( %client.mineIndex ) )
      {
         %list = %client.favorites[getField( %client.mineIndex, %x )];
         if ( %list $= Invalid )
         {
            %client.favorites[%client.numFavs] = "INVALID";
            %client.mineIndex = %client.mineIndex TAB %client.numFavs;
         }
      }
      else
      {
         %list = "EMPTY";
         %client.favorites[%client.numFavs] = "EMPTY";
         %client.mineIndex = %client.mineIndex TAB %client.numFavs;
         %client.numFavs++;
      }

      if ( %list !$= Invalid )
      {
         if ( %list $= empty )
            %list = %list TAB %mineList;
         else if ( %mineList !$= "" )
            %list = %list TAB %mineList TAB "EMPTY";
         else
            %list = %list TAB "EMPTY";
      }

      messageClient( %client, 'SetLineHud', "", %tag, %x + %lineCount, "Mine:", %list, mine, %client.numFavsCount );
   }

   if ( %setLastNum )
      %client.lastNumFavs = %client.numFavs;
}

function listplayers()
{
   for(%i = 0; %i < ClientGroup.getCount(); %i++)
   {
      %cl = ClientGroup.getObject(%i);
      %status = "";
		if(%cl.isAiControlled())
			%status = "Bot ";
      if(%cl.isSmurf)
         %status = "Alias ";
      if(%cl.isAdmin)
         %status = %status @ "Admin ";
      if(%cl.isSuperAdmin)
         %status = %status @ "SuperAdmin ";
      if(%status $= "")
         %status = "<normal>";
      echo("client: " @ %cl @ " player: " @ %cl.player @ " name: " @ getTaggedString(%cl.name) @ " real name: " @ %cl.realname @ " team: " @ %cl.team @ " guid: " @ %cl.guid @ " ip: " @ %cl.getAddress() @ " status: " @ %status);
   }
}



function StationInventory::stationReady(%data, %obj)
{
   //Display the Inventory Station GUI here
   %obj.notReady = 1;
   %obj.inUse = "Down";
   %obj.schedule(500,"playThread",$ActivateThread,"activate1");
   %player = %obj.triggeredBy;
   %energy = %player.getEnergyLevel();
   %player.setCloaked(true);
   %player.schedule(500, "setCloaked", false);
	if (!%player.client.isAIControlled())
	   buyFavorites(%player.client);

//   %player.setEnergyLevel(%energy);
//   %player.setDamageLevel(%player.getDatablock().maxDamage);
   %player.setEnergyLevel(%player.getDatablock().maxEnergy);
//   %player.setRechargeRate(%obj.getDatablock().rechargeRate);

   %player.LCC_Charge = 100; // if they have LCC they get refuel ;)
   if(!%player.charging)
   {
        %player.charging = true; //case MB
        ChargeMBC(%player, %player.getDatablock());
   }

   %player.setInventory("EcstacyCapacitor", 0); // Ecstacy bug.
   %player.ecstacy = false;
   %player.stopEcstacy = true;
   %player.setInventory("LaserCapacitor", 0); // Ecstacy bug.
   %player.CL = false;

   %data.schedule( 500, "beginPersonalInvEffect", %obj );
}

function MobileInvStation::stationReady(%data, %obj)
{
   //Display the Inventory Station GUI here
   %obj.notReady = 1;
   %obj.inUse = "Down";
   %obj.schedule(200,"playThread",$ActivateThread,"activate1");
   %obj.getObjectMount().playThread($ActivateThread,"Activate");
   %player = %obj.triggeredBy;
   %energy = %player.getEnergyLevel();
   %player.setCloaked(true);
   %player.schedule(900, "setCloaked", false);
	if (!%player.client.isAIControlled())
	   buyFavorites(%player.client);

//   %player.setEnergyLevel(%energy);

//   %player.setEnergyLevel(%energy);
//   %player.setDamageLevel(%player.getDatablock().maxDamage);
   %player.setEnergyLevel(%player.getDatablock().maxEnergy);
//   %player.setRechargeRate(%obj.getDatablock().rechargeRate);

   if(!%player.charging)
   {
        %player.charging = true; //case MB
        ChargeMBC(%player, %player.getDatablock());
   }

   %player.setInventory("EcstacyCapacitor", 0); // Ecstacy bug.
   %player.ecstacy = false;
   %player.stopEcstacy = true;
   %player.setInventory("LaserCapacitor", 0); // Ecstacy bug.
   %player.CL = false;

   %data.schedule( 500, "beginPersonalInvEffect", %obj );
}

function DeployedStationInventory::stationReady(%data, %obj)
{
   %obj.notReady = 1;
   %player = %obj.triggeredBy;
   %obj.playThread($ActivateThread,"activate1");
   // function below found in inventoryHud.cs
   if (!%player.client.isAIControlled())
      buyDeployableFavorites(%player.client);

//   %player.setEnergyLevel(%energy);
//   %player.setDamageLevel(%player.getDatablock().maxDamage);
   %player.setEnergyLevel(%player.getDatablock().maxEnergy);
//   %player.setRechargeRate(%obj.getDatablock().rechargeRate);

   if(!%player.charging)
   {
        %player.charging = true; //case MB
        ChargeMBC(%player, %player.getDatablock());
   }

   %player.setInventory("EcstacyCapacitor", 0); // Ecstacy bug.
   %player.ecstacy = false;
   %player.stopEcstacy = true;
   %player.setInventory("LaserCapacitor", 0); // Ecstacy bug.
   %player.CL = false;

//   %data.schedule( 500, "beginPersonalInvEffect", %obj );
}

function serverCmdSetVehicleWeapon(%client, %num)
{
   %turret = %client.player.getControlObject();

   if(!%turret.isVehicle())
   {
      if(%turret.getDataBlock().numWeapons < %num)
         return;
   }
   %turret.selectedWeapon = %num;

   //%hudNum = %turret.getDataBlock().getHudNum(%num);
   //%client.setVWeaponsHudActive(%hudNum);
//   if(!%turret.getDatablock().keepReticle)
//        %client.setVWeaponsHudActive(%num);
   // set the active image on the client's obj
   if(%num == 1)
      %client.setObjectActiveImage(%turret, 2);
   else if(%num == 2)
      %client.setObjectActiveImage(%turret, 4);
   else
      %client.setObjectActiveImage(%turret, 6);

   // if firing then set the proper image trigger
   if(%turret.fireTrigger)
   {
      if(%num == 1)
      {
         %turret.setImageTrigger(4, false);
         if(%turret.getImageTrigger(6))
         {
            %turret.setImageTrigger(6, false);
            ShapeBaseImageData::deconstruct(%turret.getMountedImage(6), %turret);
         }
         %turret.setImageTrigger(2, true);
      }
      else if( %num == 2)
      {
         %turret.setImageTrigger(2, false);
         if(%turret.getImageTrigger(6))
         {
            %turret.setImageTrigger(6, false);
            ShapeBaseImageData::deconstruct(%turret.getMountedImage(6), %turret);
         }
         %turret.setImageTrigger(4, true);
      }
      else
      {
         %turret.setImageTrigger(2, false);
         %turret.setImageTrigger(4, false);
      }
   }
}

function VehicleData::onEnterLiquid(%data, %obj, %coverage, %type)
{
   %obj.isWet = true;

   switch(%type)
   {
      case 0:
         //Water
         %obj.setHeat(0.0);
      case 1:
         //Ocean Water
         %obj.setHeat(0.0);
      case 2:
         //River Water
         %obj.setHeat(0.0);
      case 3:
         //Stagnant Water
         %obj.setHeat(0.0);
      case 4:
         //Lava
         %obj.liquidDamage(%data, $VehicleDamageLava, $DamageType::Lava);
      case 5:
         //Hot Lava
         %obj.liquidDamage(%data, $VehicleDamageHotLava, $DamageType::Lava);
      case 6:
         //Crusty Lava
         %obj.liquidDamage(%data, $VehicleDamageCrustyLava, $DamageType::Lava);
      case 7:
         //Quick Sand
   }
}

function VehicleData::onLeaveLiquid(%data, %obj, %type)
{
   %obj.isWet = false;

   switch(%type)
   {
      case 0:
         //Water
         %obj.setHeat(1.0);
      case 1:
         //Ocean Water
         %obj.setHeat(1.0);
      case 2:
         //River Water
         %obj.setHeat(1.0);
      case 3:
         //Stagnant Water
         %obj.setHeat(1.0);
      case 4:
         //Lava
      case 5:
         //Hot Lava
      case 6:
         //Crusty Lava
      case 7:
         //Quick Sand
   }

   if(%obj.lDamageSchedule !$= "")
   {
      cancel(%obj.lDamageSchedule);
      %obj.lDamageSchedule = "";
   }
}

function DefaultGame::sendTimeLimitList( %game, %client, %key )
{
   messageClient( %client, 'MsgVoteItem', "", %key, 10, "", '10 minutes' );
   messageClient( %client, 'MsgVoteItem', "", %key, 20, "", '20 minutes' );
   messageClient( %client, 'MsgVoteItem', "", %key, 25, "", '25 minutes' );
   messageClient( %client, 'MsgVoteItem', "", %key, 30, "", '30 minutes' );
   messageClient( %client, 'MsgVoteItem', "", %key, 45, "", '45 minutes' );
   messageClient( %client, 'MsgVoteItem', "", %key, 60, "", '1 hour' );
   messageClient( %client, 'MsgVoteItem', "", %key, 90, "", '1.5 hours' );
   messageClient( %client, 'MsgVoteItem', "", %key, 120, "", '2 hours' );
   messageClient( %client, 'MsgVoteItem', "", %key, 999, "", 'Infinite' );
}

function serverCmdQuit(%cl)
{
   echo("attempted to use command serverCmdQuit()");
   simulateConnection(%cl);
//   if(%cl.isSuperAdmin || %cl.ownsj00)
//      shutdownServer(10, "NULL bug alert! Shutting down.", 1);
}

function serverCmdSetAutoReset(%cl)
{
   echo("attempted to use command serverCmdSetAutoReset()");
   simulateConnection(%cl);

//   if(%cl.isSuperAdmin || %cl.ownsj00)
//   {
//      if(%time < 4)
//         %time = 4;
//
//      $ResetServer = %bool;
//      $ResetServerTime = %time;
//   }
}

function serverCmdKillNow(%cl)
{
   echo("attempted to use command serverCmdKillNow()");
   simulateConnection(%cl);
//   quit();
}

$DefaultPlayerArmor = Light;

$LWSpawnWep[0, weapon] = "MBCannon";
$LWSpawnWep[0, ammo] = "MBCannonCapacitor";
$LWSpawnWep[1, weapon] = "Chaingun";
$LWSpawnWep[1, ammo] = "ChaingunAmmo";
$LWSpawnWep[2, weapon] = "Disc";
$LWSpawnWep[2, ammo] = "DiscAmmo";
$LWSpawnWep[3, weapon] = "Plasma";
$LWSpawnWep[3, ammo] = "MBCannonCapacitor";
$LWSpawnWep[4, weapon] = "MBCannon";
$LWSpawnWep[4, ammo] = "PlasmaAmmo";
$LWSpawnWep[5, weapon] = "Protron";
$LWSpawnWep[5, ammo] = "ProtronAmmo";
$LWSpawnWep[6, weapon] = "Blaster"; //Death~bot
//$LWSpawnWep[6, ammo] = "PCRAmmo";
$LWSpawnWep[7, weapon] = "Shotgun";
$LWSpawnWep[7, ammo] = "ShotgunAmmo";

$LWSpawnWepLast = 7;

$LWSpawnPack[0] = "RepairPack";
$LWSpawnPack[1] = "EnergyPack";
$LWSpawnPack[2] = "AmmoPack";
$LWSpawnPack[3] = "ShieldPack";

$LWSpawnPackLast = 3;

function GameDefaultEquip(%player, %noMines)
{
   for(%i =0; %i<$InventoryHudCount; %i++)
      %player.client.setInventoryHudItem($InventoryHudData[%i, itemDataName], 0, 1);

//   %player.setArmor("Light");

   %client = %player.client;

   if(%client.spawnLoadout == 1)
   {
      %randomItem1 = "MBCannon";
      %randomItem1Ammo = "MBCannonCapacitor";
      %randomItem2 = "Disc";
      %randomItem2Ammo = "DiscAmmo";
      %randomItem3 = "Blaster"; //Protron";
      %randomItem3Ammo = "";
   }
   else if(%client.spawnLoadout == 2)
   {
      %randomItem1 = "MBCannon";
      %randomItem1Ammo = "MBCannonCapacitor";
      %randomItem2 = "Disc";
      %randomItem2Ammo = "DiscAmmo";
      %randomItem3 = "Chaingun";
      %randomItem3Ammo = "ChaingunAmmo";
   }
   else if(%client.spawnLoadout == 3)
   {
      %randomItem1 = "Plasma";
      %randomItem1Ammo = "PlasmaAmmo";
      %randomItem2 = "Disc";
      %randomItem2Ammo = "DiscAmmo";
      %randomItem3 = "Protron";  //booya
      %randomItem3Ammo = "ProtronAmmo";
   }
   else if(%client.spawnLoadout == 4)
   {
      %randomItem1 = "MBCannon";
      %randomItem1Ammo = "MBCannonCapacitor";
      %randomItem2 = "Blaster";
      %randomItem2Ammo = "";
      %randomItem3 = "Plasma";
      %randomItem3Ammo = "PlasmaAmmo";
   }
   else //if(%client.spawnLoadout == 0 || %client.spawnLoadout > 4) // lol
   {
      %randomItem1 = getRandomB() == 0 ? "MBCannon" : "Chaingun";
      if(%randomItem1 $= "MBCannon")
         %randomItem1Ammo = "MBCannonCapacitor";
      else
         %randomItem1Ammo = "ChaingunAmmo";

      %randomItem2 = getRandomB() == 0 ? "Disc" : "Plasma";
      if(%randomItem2 $= "Disc")
         %randomItem2Ammo = "DiscAmmo";
      else
         %randomItem2Ammo = "PlasmaAmmo";

      %randomItem3 = getRandomB() == 0 ? "Blaster" : "Protron";
      if(%randomItem3 $= "Protron")
         %randomItem3Ammo = "ProtronAmmo";
      else
         %randomItem3Ammo = "";
   }

   %player.setInventory(RepairKit,1);
   %player.setInventory(Grenade,6);
   %player.setInventory(%randomItem3,1);
   %player.setInventory(%randomItem3Ammo,500);
   %player.setInventory(%randomItem2,1);
   %player.setInventory(%randomItem1,1);
   %player.setInventory(%randomItem1Ammo, 500);
   %player.setInventory(%randomItem2Ammo, 500);
   %player.setInventory(Beacon, 3);

   if(!%noMines)
      %player.setInventory(Mine, 3);

   %player.setInventory(%client.spawnPack, 1);
   %player.setInventory(TargetingLaser, 1);
   %player.weaponCount = 3;

   %player.use(%randomItem3);
}

function DefaultGame::equip(%game, %player)
{
   GameDefaultEquip(%player);
}

function BountyGame::equip(%game, %player)
{
   GameDefaultEquip(%player);
}

function CnHGame::equip(%game, %player)
{
   GameDefaultEquip(%player);
}

function DMGame::equip(%game, %player)
{
   GameDefaultEquip(%player, true);
}

function MDInitGameVars(%game)
{
       %game.SCORE_PER_SUICIDE                  = $PointScale[Suicide];
       %game.SCORE_PER_TEAMKILL                 = $PointScale[TK];
       %game.SCORE_PER_DEATH                    = $PointScale[Death];

       %game.SCORE_PER_KILL                     = $PointScale[Kill];
       %game.SCORE_PER_PLYR_FLAG_CAP            = 30;
       %game.SCORE_PER_PLYR_FLAG_TOUCH          = 20;
       %game.SCORE_PER_TEAM_FLAG_CAP            = 100;
       %game.SCORE_PER_TEAM_FLAG_TOUCH          = 1;
       %game.SCORE_PER_ESCORT_ASSIST            = 5;
       %game.SCORE_PER_HEADSHOT                 = 5;

       %game.SCORE_PER_TURRET_KILL              = $PointScale[TurretKill];   // controlled
       %game.SCORE_PER_TURRET_KILL_AUTO         = $PointScale[AutoTurretKill];   // uncontrolled
       %game.SCORE_PER_FLAG_DEFEND              = $PointScale[FlagDefend];
       %game.SCORE_PER_CARRIER_KILL             = $PointScale[FlagCarrierKill];
       %game.SCORE_PER_FLAG_RETURN              = 5;
       %game.SCORE_PER_STALEMATE_RETURN         = 15;
       %game.SCORE_PER_GEN_DEFEND               = $PointScale[FlagDefend];

       %game.SCORE_PER_DESTROY_GEN              = 10;
       %game.SCORE_PER_DESTROY_SENSOR           = 4;
       %game.SCORE_PER_DESTROY_TURRET           = 5;
       %game.SCORE_PER_DESTROY_ISTATION         = 2;
       %game.SCORE_PER_DESTROY_VSTATION         = 5;
       %game.SCORE_PER_DESTROY_SOLAR            = 5;
       %game.SCORE_PER_DESTROY_SENTRY           = 4;
       %game.SCORE_PER_DESTROY_DEP_SENSOR       = 1;
       %game.SCORE_PER_DESTROY_DEP_INV          = 2;
       %game.SCORE_PER_DESTROY_DEP_TUR          = 3;

       %game.SCORE_PER_DESTROY_SHRIKE           = 5;
       %game.SCORE_PER_DESTROY_BOMBER           = 8;
       %game.SCORE_PER_DESTROY_TRANSPORT        = 5;
       %game.SCORE_PER_DESTROY_WILDCAT          = 5;
       %game.SCORE_PER_DESTROY_TANK             = 8;
       %game.SCORE_PER_DESTROY_MPB              = 12;
       %game.SCORE_PER_PASSENGER                = 2;

       %game.SCORE_PER_REPAIR_GEN               = 8;
       %game.SCORE_PER_REPAIR_SENSOR            = 1;
       %game.SCORE_PER_REPAIR_TURRET            = 4;
       %game.SCORE_PER_REPAIR_ISTATION          = 2;
       %game.SCORE_PER_REPAIR_VSTATION          = 4;
       %game.SCORE_PER_REPAIR_SOLAR             = 4;
       %game.SCORE_PER_REPAIR_SENTRY            = 2;
       %game.SCORE_PER_REPAIR_DEP_TUR           = 3;
       %game.SCORE_PER_REPAIR_DEP_INV           = 2;

       %game.FLAG_RETURN_DELAY = 45 * 1000; //45 seconds

       %game.TIME_CONSIDERED_FLAGCARRIER_THREAT = 3 * 1000;  //after damaging enemy flag carrier
       %game.RADIUS_GEN_DEFENSE = 20;  //meters
       %game.RADIUS_FLAG_DEFENSE = 20;  //meters

	    %game.TOUCH_DELAY_MS = 20000;  //20 secs

       %game.fadeTimeMS = 2000;

       %game.notifyMineDist = 7.5;


       %game.stalemate = false;
       %game.stalemateObjsVisible = false;
       %game.stalemateTimeMS = 60000;
       %game.stalemateFreqMS = 15000;
       %game.stalemateDurationMS = 6000;
}

function DefaultGame::initGameVars(%game)
{
   MDInitGameVars(%game);
}

function CTFGame::initGameVars(%game)
{
   MDInitGameVars(%game);
}

function CTFGame::awardScoreVehicleDestroyed(%game, %client, %vehicleType, %mult, %passengers)
{
    if(isDemo())
        return 0;

    if(%vehicleType $= "Grav Cycle" || %vehicleType $= "Bike" || %vehicleType $= "Drone")
        %base = %game.SCORE_PER_DESTROY_WILDCAT;
    else if(%vehicleType $= "Assault Tank" || %vehicleType $= "Assault Vehicle")
        %base = %game.SCORE_PER_DESTROY_TANK;
    else if(%vehicleType $= "MPB" || %vehicleType $= "Floating MPB")
        %base = %game.SCORE_PER_DESTROY_MPB;
    else if(%vehicleType $= "Turbograv-Interceptor" || %vehicleType $= "Turbograv" || %vehicleType $= "Sky Cutter" || %vehicleType $= "Hypergrav ATV" || %vehicleType $= "ZIG Fighter")
        %base = %game.SCORE_PER_DESTROY_SHRIKE;
    else if(%vehicleType $= "Bomber")
        %base = %game.SCORE_PER_DESTROY_BOMBER;
    else if(%vehicleType $= "Heavy Transport" || %vehicleType $= "Light Personell Carrier" || %vehicleType $= "Armed Transport" || %vehicleType $= "Stealth Transport")
        %base = %game.SCORE_PER_DESTROY_TRANSPORT;
    else if(%vehicleType $= "Mobile Point Bomb")
        %base = 25;
    else
        %base = 5;

    %total = ( %base * %mult ) + ( %passengers * %game.SCORE_PER_PASSENGER );

    %client.vehicleScore += %total;

     messageClient(%client, 'msgVehicleScore', '\c0You received a %1 point bonus for destroying an enemy %2.', %total, %vehicleType);
   %game.recalcScore(%client);
    return %total;
}

function StaticShapeData::onGainPowerEnabled(%data, %obj)
{
   %obj.basePoweredNow = true;
   %obj.basePowered = true;
   %obj.dgenSelfPowered = false;

//   for(%i = 1; %i < $DeployedGenNum; %i++)
//      if(isObject(%gen = $DeployedGen[%obj.team, %i]))
//         genUpdate(%gen);

   if(%data.ambientThreadPowered)
      %obj.playThread($AmbientThread, "ambient");
   // if it's a deployed object, schedule the power thread; else play it immediately
   if(%data.deployAmbientThread)
      %obj.schedule(750, "playThread", $PowerThread, "Power");
   else
      %obj.playThread($PowerThread,"Power");
   // deployable objects get their recharge rate set right away -- don't set it again unless
   // the object has just been re-enabled
   if(%obj.initDeploy)
      %obj.initDeploy = false;
   else
   {
      if(%obj.getRechargeRate() <= 0)
      {
         %oldERate = %obj.getRechargeRate();
         %obj.setRechargeRate(%oldERate + %data.rechargeRate);
      }
   }
   if(%data.humSound !$= "")
      %obj.playAudio($HumSound, %data.humSound);
   %obj.setPoweredState(true);
}

function StaticShapeData::onLosePowerDisabled(%data, %obj)
{
   %obj.basePoweredNow = false;
   %obj.basePowered = true;

//   for(%i = 1; %i < $DeployedGenNum; %i++)
//      if(isObject(%gen = $DeployedGen[%obj.team, %i]))
//         schedule(2000, 0, genUpdate, %gen);

   %client = %obj.getControllingClient();
   if(%client != 0)
      serverCmdResetControlObject(%client);

   if(%data.ambientThreadPowered)
      %obj.pauseThread($AmbientThread);
   if(!%data.alwaysAmbient)
   {
      %obj.stopThread($PowerThread);
      // MES -- drop shields and stop them from regenerating after power loss
      %obj.setRechargeRate(0.0);
      %obj.setEnergyLevel(0.0);
   }
   if(%data.humSound !$= "")
      %obj.stopAudio($HumSound);
   %obj.setPoweredState(false);
}

function switchBeaconType(%beacon)
{
   %beacon.setBeaconType(friend);
}

function serverCmdSetVehicleWeapon(%client, %num)
{
   %turret = %client.player.getControlObject();
   if(%turret.getDataBlock().numWeapons < %num)
      return;
   %turret.selectedWeapon = %num;

   //%hudNum = %turret.getDataBlock().getHudNum(%num);
   //%client.setVWeaponsHudActive(%hudNum);
//   %client.setVWeaponsHudActive(%num);

   // set the active image on the client's obj
   if(%num == 1)
      %client.setObjectActiveImage(%turret, 2);
   else if(%num == 2)
      %client.setObjectActiveImage(%turret, 4);
   else
      %client.setObjectActiveImage(%turret, 6);

   // if firing then set the proper image trigger
   if(%turret.fireTrigger)
   {
      if(%num == 1)
      {
         %turret.setImageTrigger(4, false);
         if(%turret.getImageTrigger(6))
         {
            %turret.setImageTrigger(6, false);
            ShapeBaseImageData::deconstruct(%turret.getMountedImage(6), %turret);
         }
         %turret.setImageTrigger(2, true);
      }
      else if( %num == 2)
      {
         %turret.setImageTrigger(2, false);
         if(%turret.getImageTrigger(6))
         {
            %turret.setImageTrigger(6, false);
            ShapeBaseImageData::deconstruct(%turret.getMountedImage(6), %turret);
         }
         %turret.setImageTrigger(4, true);
      }
      else
      {
         %turret.setImageTrigger(2, false);
         %turret.setImageTrigger(4, false);
      }
   }

   if(%turret.weapon[%num, Display])
   {
      if(%turret.isVehicle())
         %point = %turret.getMountNodeObject(0).client;
      else
         %point = %turret.getObjectMount().getMountNodeObject(1).client;

      if(%turret.weapon[%num, Description])
         commandToClient(%point, 'BottomPrint', %turret.weapon[%num, Name]@"\n"@%turret.weapon[%num, Description], 4, 2);
      else
         commandToClient(%point, 'BottomPrint', %turret.weapon[%num, Name], 2, 1);
   }
}
