if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------------------------------------------
// Module File Handling System
//--------------------------------------

function ModuleControl::addModule(%this, %modName, %modVersion, %modNotes)
{
   if(%modName)
   {
      ModuleControl.loadedMods++;
      %modNum = ModuleControl.loadedMods;

      ModuleControl.loadedMod[%modNum] = %packageName;
      ModuleControl.loadedMod[%modNum].name = %modName;
      ModuleControl.loadedMod[%modNum].version = %modVersion;

      if(%modNotes)
         ModuleControl.loadedMod[%modNum].description = %modNotes;
      else
         ModuleControl.loadedMod[%modNum].description = "No Description";

      echo("Module Added: "@%modName);
   }
}

function ModuleControl::onInit(%this)
{
   if(!ModuleControl.alreadyInit)
   {
      ModuleControl.alreadyInit = true;
      ModuleControl.Version = 1.4;
      ModuleControl.loadedMods = 0;
   //   %this.minCompatibleVersion = 100;

      %search = "plugins/*.mod";

      for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search))
      {
         %type = fileBase(%file); // get the name of the script
         exec("plugins/"@%type@".mod");
         ModuleControl::addModule(%this, $ModuleName, $ModuleVersion, $ModuleDescription);
      }
   }
}

function ModuleControl::onDie(%this)
{
   ModuleControl.loadedMods = 0;
   ModuleControl.alreadyInit = false;
}

if(!isObject(ModuleControl))
   Meltdown.addClass(ModuleControl);

function listModules()
{
   for(%i = 1; %i <= ModuleControl.loadedMods; %i++)
   {
      echo(%i SPC ModuleControl.loadedMod[%i].name SPC ModuleControl.loadedMod[%i].version SPC ModuleControl.loadedMod[%i].description);
      echo("\n");
   }
   echo(ModuleControl.loadedMods@" plugins loaded in your server.");
}

function getMeltdownVersion()
{
   return Meltdown.Version;
}

ModuleControl.onInit(); // lets go!
