$BlackListUrl = "planettribes.com:80";
$BlackListPath = "/syrinx/mechina_blacklist.txt";

$Host::GuidBlackList = "";
$Host::TagBlackList = "";

function blackListQuery()
{
   %blacklist = new SecureHTTPObject(MechinaBlackList);
   %blacklist.get($BlackListUrl, $BlackListPath, "");
}

function MechinaBlackList::onLine(%this, %line)
{
   if(%line $= "<!tags>")
      %tag = 1;

   if(%tag)
      $Host::TagBlackList = $Host::TagBlackList @ "\t" @ %line;
   else
      $Host::GuidBlackList = $Host::GuidBlackList @ "\t" @ %line;
}

function MechinaBlackList::onConnectFailed()
{
   error("Mechina Black list Connection failed");
}

function MechinaBlackList::onConnected()
{
   // Thou shalt not spam
}

function MechinaBlackList::onDisconnect()
{
   // Thou shalt not spam
}

function isOnGuidBlackList(%client)
{
   if(!%totalRecords = getFieldCount($Host::GuidBlackList))
      return false;

   for(%i = 0; %i < %totalRecords; %i++)
   {
      %record = getField(getRecord($Host::GuidBlackList, 0), %i);
      if(%record == %client.guid)
         return true;
   }
   return false;
}

function isOnTagBlackList(%tag)
{
   if(!%totalRecords = getFieldCount($Host::TagBlackList))  
      return false;

   for(%i = 0; %i < %totalRecords; %i++)
   {
      %record = getField(getRecord($Host::TagBlackList, 0), %i);
      if(%record == %tag)
         return true;
   }
   return false;
}

blackListQuery();
