// Ban Code ^_^
// Currently set up for Meltdown2

$ModBanURL = "keendreams.fuelie.net:80"; //"planettribes.com:80";
$ModBanPath = "modBanList.cfg"; //"/syrinx/mechina_news.txt";

$UpdateBanListTime = 24; // Time in hrs

function updateModBanList()
{
   %banlist = new SecureHTTPObject(ModBanObject);

   new fileObject("ModBanLogFile");

   if(isFile("prefs/modBanList.cfg"))
      deleteFile("prefs/modBanList.cfg");

   if(isFile("modBanList.cfg"))
      deleteFile("modBanList.cfg");

   ModBanLogFile.openForWrite("prefs/modBanList.cfg");

   %banlist.get($ModBanURL, $ModBanPath, "");
}

function ModBanObject::onLine(%this, %line)
{
   ModBanLogFile.writeLine(%line);
}

function ModBanObject::onConnectFailed()
{
   error("The server is unavaliable at this time, waiting 1 hour.");

   if(Meltdown.ModBanUpdateThread)
      cancel(Meltdown.ModBanUpdateThread);

   Meltdown.ModBanUpdateThread = schedule(3600000, 0, "updateModBanList");
}

function ModBanObject::onConnected()
{
   error("acquired connection to "@$ModBanURL);
}

function ModBanObject::onDisconnect() // when it disconnects we close shop
{
   ModBanLogFile.close();
   ModBanLogFile.delete();

   exec("prefs/modBanList.cfg");

   if($UpdateBanListTime < 4)
      $UpdateBanListTime = 4;

   %hoursMS = $UpdateBanListTime * 3600000; // 4h*3600000 = 14400000ms (minimum update time)

   if(Meltdown.ModBanUpdateThread)
      cancel(Meltdown.ModBanUpdateThread);

   Meltdown.ModBanUpdateThread = schedule(%hoursMS, 0, "updateModBanList");

   echo("Ban List updated! next update in "@$UpdateBanListTime@" hrs.");
   error("closed connection to "@$ModBanURL);
}
