if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// ------------------------------------------------------------------
// Gravitron Field Pack
// decreases the player's weight by half

datablock ShapeBaseImageData(GravDecalImage)
{
   mountPoint = 1;
   shapeFile = "pack_upgrade_energy.dts";
   offset = "0 0 -0.175";
   rotation = "0 1 0 180";
};

datablock ShapeBaseImageData(GravitronPackImage)
{
   shapeFile = "pack_upgrade_sensorjammer.dts";
   item = GravitronPack;
   mountPoint = 1;
   offset = "0 0 0";
   mass = -60; // 60 - 65 - 75 -Nite- Due to the new skiing this was taken down a tad

	stateName[0] = "default";
	stateSequence[0] = "fire";
};

datablock ItemData(GravitronPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_upgrade_sensorjammer.dts";
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   mass = -75; // 60 - 65 - 75 -Nite- Due to the new Skiing this was taken down a tab
   image = "GravitronPackImage";
	pickUpName = "a gravitron pack";
};

function gravHeat(%obj)
{
     if(%obj.gravitronOn)
     {
          %obj.setHeat(0.3);
          schedule(250, %obj, "gravHeat", %obj);
     }
}

function GravitronPackImage::onMount(%data, %obj, %node)
{
   %obj.mountImage(GravDecalImage, 7);

//   %obj.gravitronOn = true;
//   gravHeat(%obj);
}

function GravitronPackImage::onUnmount(%data, %obj, %node)
{
   %obj.unmountImage(7);

//   %obj.gravitronOn = false;
}

function GravitronPack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}
