if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//==> Player External Hook
// Scripts

function BASelfDestruct(%obj)
{
   %p = new LinearFlareProjectile()
   {
      dataBlock        = BAArmorBlowout;
      initialDirection = vectorRandom();
      initialPosition  = %obj.getPosition();
      sourceObject     = %obj;
      sourceSlot       = 0;
   };
   MissionCleanup.add(%p);

   %obj.setDamageFlash(0.75);
   %obj.blowup();
   %obj.blowedup = true;
//   %obj.getDatablock().damageObject(%obj, %obj, %obj.position, 1000, %p.getDatablock().radiusDamageType, %obj.getVelocity(), false);
}
// -Nite- No mAsa jetpack
//function JPSelfDestruct(%obj)
//{
//   %p = new LinearFlareProjectile()
//   {
//      dataBlock        = JPArmorBlowout;
//      initialDirection = vectorRandom();
//      initialPosition  = %obj.getPosition();
//      sourceObject     = %obj;
//      sourceSlot       = 0;
//   };
//   MissionCleanup.add(%p);
//
//   %obj.setDamageFlash(0.75);
//   %obj.blowup();
//   %obj.blowedup = true;
//   %obj.getDatablock().damageObject(%obj, %obj, %obj.position, 1000, %p.getDatablock().radiusDamageType, %obj.getVelocity(), false);
//}
 //-nite- no mechie blow up
function TMSelfDestruct(%obj)
{
   %p = new LinearFlareProjectile()
   {
      dataBlock        = TacMechArmorBlowout;
      initialDirection = vectorRandom();
      initialPosition  = %obj.getPosition();
      sourceObject     = %obj;
      sourceSlot       = 0;
   };
   MissionCleanup.add(%p);

   %obj.setDamageFlash(0.75);
   %obj.blowup();
   %obj.blowedup = true;
   %obj.getDatablock().damageObject(%obj, %obj, %obj.position, 1000, %p.getDatablock().radiusDamageType, %obj.getVelocity(), false);
}

function BTSelfDestruct(%obj)
{
   %p = new LinearFlareProjectile()
   {
      dataBlock        = BTArmorBlowout;
      initialDirection = vectorRandom();
      initialPosition  = %obj.getPosition();
      sourceObject     = %obj;
      sourceSlot       = 0;
   };
   MissionCleanup.add(%p);

   %obj.setDamageFlash(0.75);
   %obj.blowup();
   %obj.blowedup = true;
//   %obj.getDatablock().damageObject(%obj, %obj, %obj.position, 1000, %p.getDatablock().radiusDamageType, %obj.getVelocity(), false);
}

function BAExplode(%targetObject)
{
   loopDamageFX(%targetObject, 4, 19, 4, LinearFlareProjectile, ReaverCharge);
   schedule(getRandom(6000, 4000), 0, "BASelfDestruct", %targetObject);
}

function MountAPEsToObject(%obj)
{
   if(isObject(%obj))
   {
//      echo("APEs mounted.");
      createSlotExtension(%obj, Meltdown.APE_mountPoint, "SlotExtension2"); // APE Slot Extension (SL2 - muzzlepoint)
      %obj.slotExtension[Meltdown.APE_mountPoint].isSyn = true; // avoid EMP

      %obj.slotExtension[Meltdown.APE_mountPoint].mountImage("EMPAPEImage", Meltdown.APE_EMP_Mount);
      %obj.slotExtension[Meltdown.APE_mountPoint].mountImage("FireVisAPEImage", Meltdown.APE_FireVis_Mount);
      %obj.slotExtension[Meltdown.APE_mountPoint].mountImage("FireSmokeAPEImage", Meltdown.APE_FireSmoke_Mount);
   }
   else
      error("Error! Cannot mount an APE to a non-existant object!");
}

//function Armor::onAdd(%data,%obj)
//{
//   Parent::onAdd(%data, %obj);
//   // Vehicle timeout
//   %obj.mountVehicle = true;
//
//   // Default dynamic armor stats
//   %obj.setRechargeRate(%data.rechargeRate);
//   %obj.setRepairRate(0);
//
//   %obj.setSelfPowered();
//
//   MountAPEsToObject(%obj);
//}


function Armor::onMount(%this,%obj,%vehicle,%node)
{
   if (%node == 0)
   {
      // Node 0 is the pilot's pos.
      %obj.setTransform("0 0 0 0 0 1 0");
      %obj.setActionThread(%vehicle.getDatablock().mountPose[%node],true,true);

      if(!%obj.inStation)
         %obj.lastWeapon = (%obj.getMountedImage($WeaponSlot) == 0 ) ? "" : %obj.getMountedImage($WeaponSlot).getName().item;

       %obj.unmountImage($WeaponSlot);

      if(!%obj.client.isAIControlled())
      {
         %obj.setControlObject(%vehicle);
         %obj.client.setObjectActiveImage(%vehicle, 2);
      }

      //E3 respawn...

      if(%obj == %obj.lastVehicle.lastPilot && %obj.lastVehicle != %vehicle)
      {
         schedule(15000, %obj.lastVehicle,"vehicleAbandonTimeOut", %obj.lastVehicle);
          %obj.lastVehicle.lastPilot = "";
      }
      if(%vehicle.lastPilot !$= "" && %vehicle == %vehicle.lastPilot.lastVehicle)
            %vehicle.lastPilot.lastVehicle = "";

      %vehicle.abandon = false;
      %vehicle.lastPilot = %obj;
      %obj.lastVehicle = %vehicle;

      // update the vehicle's team
      if((%vehicle.getTarget() != -1) && %vehicle.getDatablock().cantTeamSwitch $= "")
      {
         setTargetSensorGroup(%vehicle.getTarget(), %obj.client.getSensorGroup());
         if( %vehicle.turretObject > 0 )
            setTargetSensorGroup(%vehicle.turretObject.getTarget(), %obj.client.getSensorGroup());
      }

      // Send a message to the client so they can decide if they want to change view or not:
      commandToClient( %obj.client, 'VehicleMount' );

   }
   else
   {
      // tailgunner/passenger positions
      if(%vehicle.getDataBlock().mountPose[%node] !$= "")
         %obj.setActionThread(%vehicle.getDatablock().mountPose[%node]);
      else
         %obj.setActionThread("root", true);
   }
   // -------------------------------------------------------------------------
   // z0dd - ZOD, 6/18/02. announce to any other passengers that you've boarded
   if(%vehicle.getDatablock().numMountPoints > 1)
   {
      %nodeName = findNodeName(%vehicle, %node); // function in vehicle.cs
      for(%i = 0; %i < %vehicle.getDatablock().numMountPoints; %i++)
      {
         if (%vehicle.getMountNodeObject(%i) > 0)
         {
            messageClient( %vehicle.getMountNodeObject(%i).client, 'MsgShowPassenger', '\c3%1\c2 has boarded in the \c3%2\c2 position.', %obj.client.name, %nodeName, true );
            commandToClient( %vehicle.getMountNodeObject(%i).client, 'showPassenger', %node, true);
         }
      }
   }
   //make sure they don't have any packs active
//    if ( %obj.getImageState( $BackpackSlot ) $= "activate")
//       %obj.use("Backpack");
   if ( %obj.getImageTrigger( $BackpackSlot ) )
      %obj.setImageTrigger( $BackpackSlot, false );

   //AI hooks
   %obj.client.vehicleMounted = %vehicle;
   AIVehicleMounted(%vehicle);
   if(%obj.client.isAIControlled())
      %this.AIonMount(%obj, %vehicle, %node);
}

function Armor::onUnmount( %this, %obj, %vehicle, %node )
{
   if ( %node == 0 )
   {
      commandToClient( %obj.client, 'VehicleDismount' );
      commandToClient(%obj.client, 'removeReticle');

      if(%obj.inv[%obj.lastWeapon])
         %obj.use(%obj.lastWeapon);

      if(%obj.getMountedImage($WeaponSlot) == 0)
         %obj.selectWeaponSlot( 0 );

      //Inform gunner position when pilot leaves...
      //if(%vehicle.getDataBlock().showPilotInfo !$= "")
      //   if((%gunner = %vehicle.getMountNodeObject(1)) != 0)
      //      commandToClient(%gunner.client, 'PilotInfo', "PILOT EJECTED", 6, 1);
   }
   // ----------------------------------------------------------------------
   // z0dd - ZOD, 6/18/02. announce to any other passengers that you've left
   if(%vehicle.getDatablock().numMountPoints > 1)
   {
      %nodeName = findNodeName(%vehicle, %node); // function in vehicle.cs
      for(%i = 0; %i < %vehicle.getDatablock().numMountPoints; %i++)
      {
         if (%vehicle.getMountNodeObject(%i) > 0)
         {
            messageClient( %vehicle.getMountNodeObject(%i).client, 'MsgShowPassenger', '\c3%1\c2 has ejected from the \c3%2\c2 position.', %obj.client.name, %nodeName, false );
            commandToClient( %vehicle.getMountNodeObject(%i).client, 'showPassenger', %node, false);
         }
      }
   }
   //AI hooks
   %obj.client.vehicleMounted = "";
   if(%obj.client.isAIControlled())
      %this.AIonUnMount(%obj, %vehicle, %node);
}


function Armor::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType, %momVec, %mineSC)
{
   //error("Armor::damageObject( "@%data@", "@%targetObject@", "@%sourceObject@", "@%position@", "@%amount@", "@%damageType@", "@%momVec@" )");

   if(%targetObject.Angeling) // Double damage for BA Angel Wings - removed from BA - MrKeen
      %amount *= 2;

   if(%targetObject.invincible || %targetObject.getState() $= "Dead")
      return;
                                                                          //death~bot
   if((%damageType == $DamageType::Plasma || %damageType == $DamageType::FlameTurret || %damageType == $DamageType::Burn || %damageType == $DamageType::RAXX || %damageType == $DamageType::BurnLoop) && %targetObject.pack $= "HeatShieldPack")
      return;

   //if(%damageType == $DamageType::Plasma || %damageType == $DamageType::RAXX)
    //  %targetObject.jp_heatcount += 5000; // >8)
// -Nite- Jetpack Heat stuff
  // if(%damageType == $DamageType::Burn)
    //  %targetObject.jp_heatcount += 100;

   //----------------------------------------------------------------
   // z0dd - ZOD, 6/09/02. Check to see if this vehcile is destroyed,
   // if it is do no damage. Fixes vehicle ghosting bug. We do not
   // check for isObject here, destroyed objects fail it even though
   // they exist as objects, go figure.
   if(%damageType == $DamageType::Impact)
      if(%sourceObject.getDamageState() $= "Destroyed")
         return;

   if (%targetObject.isMounted() && %targetObject.scriptKilled $= "")
   {
      %mount = %targetObject.getObjectMount();
      if(%mount.team == %targetObject.team)
      {
         %found = -1;
         for (%i = 0; %i < %mount.getDataBlock().numMountPoints; %i++)
         {
            if (%mount.getMountNodeObject(%i) == %targetObject)
            {
               %found = %i;
               break;
            }
         }

         if (%found != -1)
         {
            if (%mount.getDataBlock().isProtectedMountPoint[%found])
            {
               %mount.getDataBlock().damageObject(%mount, %sourceObject, %position, %amount, %damageType);
               return;
            }
            else
               %amount *= 0.5; // cut in half
         }
      }
   }

   %targetClient = %targetObject.getOwnerClient();
   if(isObject(%mineSC))
      %sourceClient = %mineSC;
   else
      %sourceClient = isObject(%sourceObject) ? %sourceObject.getOwnerClient() : 0;

   %targetTeam = %targetClient.team;

   //if the source object is a player object, player's don't have sensor groups
   // if it's a turret, get the sensor group of the target
   // if its a vehicle (of any type) use the sensor group
   if (%sourceClient)
      %sourceTeam = %sourceClient.getSensorGroup();
   else if(%damageType == $DamageType::Suicide)
      %sourceTeam = 0;
   //--------------------------------------------------------------------------------------------------------------------
   // z0dd - ZOD, 5/8/02. Check to see if this turret has a valid owner, if not clear the owner varible.
   //else if(isObject(%sourceObject) && %sourceObject.getClassName() $= "Turret")
   //   %sourceTeam = getTargetSensorGroup(%sourceObject.getTarget());
   else if(isObject(%sourceObject) && %sourceObject.getClassName() $= "Turret")
   {
      %sourceTeam = getTargetSensorGroup(%sourceObject.getTarget());
      if(%sourceObject.owner !$="" && (%sourceObject.owner.team != %sourceObject.team || !isObject(%sourceObject.owner)))
         %sourceObject.owner = "";
   }
   // End z0dd - ZOD
   //--------------------------------------------------------------------------------------------------------------------
   else if( isObject(%sourceObject) &&
   	( %sourceObject.getClassName() $= "FlyingVehicle" || %sourceObject.getClassName() $= "WheeledVehicle" || %sourceObject.getClassName() $= "HoverVehicle"))
      %sourceTeam = getTargetSensorGroup(%sourceObject.getTarget());
   else
   {
      if (isObject(%sourceObject) && %sourceObject.getTarget() >= 0 )
      {
         %sourceTeam = getTargetSensorGroup(%sourceObject.getTarget());
      }
      else
      {
         %sourceTeam = -1;
      }
   }

   // if teamdamage is off, and both parties are on the same team
   // (but are not the same person), apply no damage
   if(!$teamDamage && (%targetClient != %sourceClient) && (%targetTeam == %sourceTeam))
      return;

   if(%targetObject.isShieldedBASS && %targetObject.inDEDField)
      %amount = %data.checkShieldsBASS(%targetObject, %position, %amount, %damageType);
   else if((%targetObject.isShielded || %targetObject.isShieldedBASS) && %damageType != $DamageType::Blaster || %targetObject.isShielded && %damageType != $DamageType::BlueBlaster)
      %amount = %data.checkShields(%targetObject, %position, %amount, %damageType);
      // removed tatic mech
    //if(!%targetObject.getDatablock().isTacticalMech && !%targetObject.isShieldedBASS)
   if(!%targetObject.isShieldedBASS)
   {
      //if(%damageType == $DamageType::PWT)
     // {
       //  if(getRandom(100) > 45)
        //   %targetObject.EMPObject();
     // }

      if(%damageType == $DamageType::Burn && %targetObject.pack $= "")
           %targetObject.BurnObject(%sourceObject);
      else if(%damageType == $DamageType::EMP || %amount < -50)
           %targetObject.EMPObject();
      else if(%damageType == $DamageType::Poison)
           %targetObject.PoisonObject(%sourceObject);

      if(%damageType == $DamageType::Plasma || %damageType == $DamageType::RAXX)
         if(getRandom(100) > 80 && %targetObject.pack $= "")
               %targetObject.BurnObject(%sourceObject);
   }

   if(%amount == 0)
      return;

   if(%targetObject.getArmorSize() $= "Blastech") // Set the damage flash, if not blastech and without power. - MrKeen
   {
      if(%targetObject.getEnergyLevel() <= 3)
         %antiBlastech = true;

      if(!%antiBlastech)
      {
         %lastAmount = %amount;
         %damageScale = %data.damageScale[%damageType];
         if(%damageScale !$= "")
            %amount *= %damageScale;

         if(%amount == 0)
         {
            %deflect = %lastAmount * (4 + getRandomT()); // MrKeen
            %targetObject.useEnergy(%deflect);
            %targetObject.playShieldEffect("0 0 0");
            %deflectd = mFloor(%deflect * 100) / 100;
            bottomPrint(%targetObject.client, "Protection deflected hit > "@%deflectd@"KW | Power remaining: "@%targetObject.getEnergyLevel()@"KW", 3, 1);
            return;
         }
      }
   }
   else
   {
      %damageScale = %data.damageScale[%damageType];
      if(%damageScale !$= "")
         %amount *= %damageScale;
   }

   %flash = %targetObject.getDamageFlash() + (%amount * 2);
   if (%flash > 0.75)
      %flash = 0.75;

   %previousDamage = %targetObject.getDamagePercent();
   %targetObject.setDamageFlash(%flash);
   %targetObject.applyDamage(%amount);
   Game.onClientDamaged(%targetClient, %sourceClient, %damageType, %sourceObject);

   %targetClient.lastDamagedBy = %damagingClient;
   %targetClient.lastDamaged = getSimTime();

   //now call the "onKilled" function if the client was... you know...
   if(%targetObject.getState() $= "Dead")
   {
      if(%targetObject.fake)
         %targetObject.sourceClient.setControlObject(%targetObject.sourceClient.player);

      if(%targetObject.getDatablock().isBattleAngel)
      {
         %targetObject.setMomentumVector(%momVec);
         Game.onClientKilled(%targetClient, %sourceClient, %damageType, %sourceObject, %damLoc);
         loopDamageFX(%targetObject, 4, 19, 4, LinearFlareProjectile, ReaverCharge); //BAMiniExplodeCharge);
         schedule(getRandom(6000, 4000), 0, "BASelfDestruct", %targetObject);
         return;
      }
      else if(%targetObject.getDatablock().isTacticalMech)
      {
         %targetObject.setMomentumVector(%momVec);
         Game.onClientKilled(%targetClient, %sourceClient, %damageType, %sourceObject, %damLoc);
         loopDamageFX(%targetObject, 8, 56, 8, LinearFlareProjectile, ReaverCharge); //BAMiniExplodeCharge);
         schedule(getRandom(7500, 5000), 0, "TMSelfDestruct", %targetObject);
         return;
      }
        //-Nite- removed Jetpack blowup
//      if(%targetObject.jetpackMounted && %targetObject.jp_heatcount > 0)
//      {
//         %targetObject.setMomentumVector(%momVec);
//         Game.onClientKilled(%targetClient, %sourceClient, %damageType, %sourceObject, %damLoc);
//         BASelfDestruct(%targetObject);
//         return;
//      }

      // where did this guy get it?
      %damLoc = %targetObject.getDamageLocation(%position);

//       should this guy be blown apart?
      if( %damageType == $DamageType::Explosion ||
          %damageType == $DamageType::TankMortar ||
          %damageType == $DamageType::Mortar ||
          %damageType == $DamageType::MortarTurret ||
          %damageType == $DamageType::BomberBombs ||
          %damageType == $DamageType::SatchelCharge ||
          %damageType == $DamageType::Disc ||
          %damageType == $DamageType::Annihalator ||
          %damageType == $DamageType::Gauss ||
          %damageType == $DamageType::PBW ||
          %damageType == $DamageType::PWT ||
          %damageType == $DamageType::Mine ||
          %damageType == $DamageType::Missile )
      {
         if( %previousDamage >= 0.42 ) // only if <= 40 percent damage remaining
         {
            %targetObject.setMomentumVector(%momVec);
            %targetObject.blowup();
            %targetObject.blowedUp = true;
         }
      }                                                       //death~bot
      else if(%damageType == $DamageType::Plasma || %damageType == $DamageType::FlameTurret || %damageType == $DamageType::RAXX || %damageType == $DamageType::BurnLoop && %targetObject.pack $= "")
      {
         %targetObject.setMomentumVector(%momVec);

         if(!%targetObject.blowedUp)
            %targetObject.burnObject(%sourceObject);
      }
      else if(%damageType == $DamageType::ELF || %damageType == $DamageType::ElectroMissile || %damageType == $DamageType::Lightning)
      {
         %targetObject.setMomentumVector(%momVec);

         if(!%targetObject.blowedUp)
            %targetObject.zapObject();
      }
      // this should be funny...
      if( %damageType == $DamageType::VehicleSpawn )
      {
         %targetObject.setMomentumVector("0 0 1");
         %targetObject.blowup();
         %targetObject.blowedUp = true;
      }

      // If we were killed, max out the flash
      %targetObject.setDamageFlash(0.75);

      if(%targetObject.blowedUp)
         %targetClient.die1stPerson = false;
      else
         %targetClient.die1stPerson = true;

      %damLoc = %targetObject.getDamageLocation(%position);
      Game.onClientKilled(%targetClient, %sourceClient, %damageType, %sourceObject, %damLoc);
   }
   else if ( %amount > 0.1 )
   {
      if( %targetObject.station $= "" && %targetObject.isCloaked() )
      {
         %targetObject.setCloaked( false );
         %targetObject.reCloak = %targetObject.schedule( 500, "setCloaked", true );
      }

      playPain( %targetObject );
   }
}

function Armor::onDisabled(%this,%obj,%state)
{
//   if(%obj.isFlaming)
//   {
//      createLifeEmitter(vectorAdd(%obj.getWorldBoxCenter(), "0 0 -0.5"), "StarburstFlameEmitter", $CorpseTimeoutValue);
//      createLifeEmitter(vectorAdd(%obj.getWorldBoxCenter(), "0 0 -0.5"), "HeavyDamageSmoke", $CorpseTimeoutValue);
//   }

   if(%obj.isFlaming && !%obj.blowedUp)
      %obj.schedule($CorpseTimeoutValue, "deleteSlotExtension", Meltdown.APE_mountPoint);
   else
   {
      %obj.isFlaming = false;
      %obj.burntime = 1;
      %obj.deleteSlotExtension(Meltdown.APE_mountPoint);
   }

   %fadeTime = 1000;
   %obj.startFade( %fadeTime, ($CorpseTimeoutValue) - %fadeTime, true );
   %obj.schedule($CorpseTimeoutValue, "delete");
}

function Player::getArmorSize(%this)
{
   // return size as "Light","Medium", "Heavy"
   %dataBlock = %this.getDataBlock().getName();
   if (getSubStr(%dataBlock, 0, 5) $= "Light")
      return "Light";
   else if (getSubStr(%dataBlock, 0, 6) $= "Medium")
      return "Medium";
   else if (getSubStr(%dataBlock, 0, 5) $= "Heavy")
      return "Heavy";
   else if (getSubStr(%dataBlock, 0, 6) $= "MagIon")
      return "MagIon";
   else if (getSubStr(%dataBlock, 0, 8) $= "Blastech")
      return "Blastech";
   else if (getSubStr(%dataBlock, 0, 8) $= "Engineer")
      return "Engineer";
   else if (getSubStr(%dataBlock, 0, 11) $= "BattleAngel")
      return "BattleAngel";
   else
      return "Unknown";
}

function Player::use( %this,%data )
{
   // If player is in a station then he can't use any items
   if(%this.station !$= "")
      return false;

   // Convert the word "Backpack" to whatever is in the backpack slot.
   if ( %data $= "Backpack" )
   {
      if ( %this.inStation )
         return false;

      if(%this.isPilot())
            toggleVehicleMod(%this);

      if ( %this.isWeaponOperator() )
      {
         messageClient( %this.client, 'MsgCantUsePack', '\c2You can\'t use your pack while in a weaponry position.~wfx/misc/misc.error.wav' );
         return( false );
      }

      %image = %this.getMountedImage( $BackpackSlot );
      if ( %image )
         %data = %image.item;
   }

   // Can't use some items when piloting or your a weapon operator
   if ( %this.isPilot() || %this.isWeaponOperator() )
      if ( %data !$= "RepairKit" )
         return;

   return ShapeBase::use( %this, %data );
}

function Player::liquidDamage(%obj, %data, %damageAmount, %damageType)
{
   if(%obj.pack !$= "HeatShieldPack")   //haha!
   {
        if(%obj.getState() !$= "Dead")
        {
           %data.damageObject(%obj, 0, "0 0 0", %damageAmount, %damageType);
           %obj.lDamageSchedule = %obj.schedule(50, "liquidDamage", %data, %damageAmount, %damageType);
        }
        else
           %obj.lDamageSchedule = "";
   }
   else
      %obj.lDamageSchedule = %obj.schedule(50, "liquidDamage", %data, %damageAmount, %damageType);
}

function Armor::onEnterLiquid(%data, %obj, %coverage, %type)
{
   %obj.isWet = true;

   switch(%type)
   {
      case 0:
          enterWaterClearIncen(%obj);
      case 1:
          enterWaterClearIncen(%obj);
      case 2:
          enterWaterClearIncen(%obj);
      case 3:
          enterWaterClearIncen(%obj);
      case 4:
         //Lava
         %obj.liquidDamage(%data, $DamageLava, $DamageType::Lava);
      case 5:
         //Hot Lava
         %obj.liquidDamage(%data, $DamageHotLava, $DamageType::Lava);
      case 6:
         //Crusty Lava
         %obj.liquidDamage(%data, $DamageCrustyLava, $DamageType::Lava);
      case 7:
         //Quick Sand
   }
}

function Armor::onLeaveLiquid(%data, %obj, %type)
{
   %obj.isWet = false;

   switch(%type)
   {
      case 0:
         //Water
      case 1:
         //Ocean Water
      case 2:
         //River Water
      case 3:
         //Stagnant Water
      case 4:
         //Lava
      case 5:
         //Hot Lava
      case 6:
         //Crusty Lava
      case 7:
         //Quick Sand
   }

   if(%obj.lDamageSchedule !$= "")
   {
      cancel(%obj.lDamageSchedule);
      %obj.lDamageSchedule = "";
   }
}

function Armor::onTrigger(%data, %player, %triggerNum, %val)
{
   if (%triggerNum == 4)
   {
      // Throw grenade
      if (%val == 1)
      {
         %player.grenTimer = 1;
      }
      else
      {
         if (%player.grenTimer == 0)
         {
            // Bad throw for some reason
         }
         else
         {
            %player.use(Grenade);
            %player.grenTimer = 0;
         }
      }
   }
   else if (%triggerNum == 5)
   {
      // Throw mine
      if (%val == 1)
         %player.mineTimer = 1;
      else
      {
         if (%player.mineTimer == 0)
         {
            // Bad throw for some reason
         }
         else
         {
            if(%player.getInventory(LargeMine))
               %player.use(LargeMine);
            else if(%player.getInventory(CloakMine))
               %player.use(CloakMine);
            else if(%player.getInventory(EMPMine))
               %player.use(EMPMine);
            else if(%player.getInventory(IncendiaryMine))
               %player.use(IncendiaryMine);
            else if(%player.getInventory(BlastechMine))
               %player.use(BlastechMine);
            else
               %player.use(Mine);

            %player.mineTimer = 0;
         }
      }
   }
   else if (%triggerNum == 2)
   {
      if(%val == 1)
         %player.isJumping = true;
      else
         %player.isJumping = false;
   }
   else if (%triggerNum == 3)
   {
      // val = 1 when jet key (LMB) first pressed down
      // val = 0 when jet key released
      // MES - do we need this at all any more?
      if(%val == 1)
         %player.isJetting = true;
      else
         %player.isJetting = false;
   }
}
 //-Nite- jetpack, this again?! 0_o Keen you weirdo coder u! =
//function assaultJuggSwitch()
//{
//   if(Meltdown.assaultJuggSwitch)
//   {
//      MediumMaleHumanArmor.max[JetPack] = 1;
//      MediumFemaleHumanArmor.max[JetPack] = 1;
//      MediumMaleBiodermArmor.max[JetPack] = 1;
//
//      HeavyMaleHumanArmor.max[JetPack] = 0;
//      HeavyFemaleHumanArmor.max[JetPack] = 0;
//      HeavyMaleBiodermArmor.max[JetPack] = 0;
//
//      Meltdown.assaultJuggSwitch = false;
//      echo("Assault Armor now has Jet Pack!");
//   }
//   else
//   {
//      MediumMaleHumanArmor.max[JetPack] = 0;
//      MediumFemaleHumanArmor.max[JetPack] = 0;
//      MediumMaleBiodermArmor.max[JetPack] = 0;
//
//      HeavyMaleHumanArmor.max[JetPack] = 1;
//      HeavyFemaleHumanArmor.max[JetPack] = 1;
//      HeavyMaleBiodermArmor.max[JetPack] = 1;
//
//      Meltdown.assaultJuggSwitch = true;
//      echo("Juggernaut Armor now has Jet Pack!");
//   }
//}

function nearbyGen(%pl)
{
   if(isObject(%pl))
   {
     InitContainerRadiusSearch(%pl.getWorldBoxCenter(), 32, $TypeMasks::GeneratorObjectType);

     while((%int = ContainerSearchNext()) != 0)
     {
          if(%int)
             return true;
          else continue;
     }
     return false;
   }
}

function nearbyBGen(%pl)// DOH!!!!!!!!!!!!!!!!!!!!1111
{
   if(isObject(%pl))
   {
      InitContainerRadiusSearch(%pl.getWorldBoxCenter(), 16, $TypeMasks::StaticShapeObjectType);

      while((%int = ContainerSearchNext()) != 0)
      {
         if(%int.getDatablock().depGenTime == 12)
            return true;
      }
      return false;
   }
}

function BlastechRecharge(%obj)
{
   if(isObject(%obj) && %obj.getDatablock().isBlastech)
   {
      if(%obj.bt_binswitch $= "")
         %obj.bt_binswitch = true;

//      echo(%obj.getState());
      if(%obj.getState() !$= "Dead")
      {
         if(nearbyGen(%obj) || %obj.isSyn)
         {
            %obj.setEnergyLevel(%obj.getEnergyLevel() + 10);
            %obj.playShieldEffect("0 0 1");

            if(%obj.isSyn)
               %obj.setVelocity("0 0 0");

            %pct = mFloor(%obj.getEnergyPct() * 100);
            %text = %pct == 100 ? "" : "<color:FFFF22>Recharging Blastech capacitor >> <color:FFFFFF>"@%pct@"%";

            if(%text !$= "")
               bottomPrint(%obj.client, %text, 0.5, 1);

            schedule(100, 0, "BlastechRecharge", %obj);
//            echo("ng | isSyn");
         }
         else if(nearbyBGen(%obj))
         {
            %obj.setEnergyLevel(%obj.getEnergyLevel() + 10);
            %obj.playShieldEffect("0 0 1");

            if(%obj.isSyn)
               %obj.setVelocity("0 0 0");

            %pct = mFloor(%obj.getEnergyPct() * 100);
            %text = %pct == 100 ? "" : "<color:FFFF22>Recharging Blastech capacitor >> <color:FFFFFF>"@%pct@"%";

            if(%text !$= "")
               bottomPrint(%obj.client, %text, 0.5, 1);

            schedule(100, 0, "BlastechRecharge", %obj);
//            echo("bg");
         }
         else
         {
            if(%obj.getEnergyLevel() <= 2)
            {
               %obj.bt_binswitch = %obj.bt_binswitch == true ? false : true;
               %color = %obj.bt_binswitch == true ? "<color:FFFF22>" : "<color:FF2222>";
               bottomPrint(%obj.client, %color@"ERROR! <color:FFFFFF>Blastech protection<color:42dbea> has failed! Not enough energy. Get to a\ngenerator or you can use your Targeting Laser to drain energy from objects.", 1.25, 2);
            }
            else if(%obj.getEnergyLevel() <= 250)
            {
               %pct = mFloor(%obj.getEnergyPct() * 100);
               bottomPrint(%obj.client, "<color:22FF22>Warning! <color:FFFFFF>Low energy ("@%obj.getEnergyLevel()@"KW | "@%pct@"%)<color:42dbea> - get to a power source to recharge.\nBlastech protection will fail if energy is depleted.", 1.25, 2);
            }
            schedule(1000, 0, "BlastechRecharge", %obj);
         }
      }
   }
}
