if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------------------------------------------
// Self Destruct Module
//--------------------------------------------------------------------------

function SelfDestructModImage::onActivate(%data, %obj, %slot)
{
   AttemptAugmentVehicle(%data, %obj, %slot);
}

function SelfDestructModImage::onDeactivate(%data, %obj, %slot)
{
	%obj.setImageTrigger($BackpackSlot, false);
}

function SelfDestructMod::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

function SelfDestructModImage::ApplyMod(%datablock, %player, %vehicle)
{
     %player.setInventory("SelfDestructMod", 0);
     %vehicle.augmented = true;
     %vehicle.augType = "Self Destruct";
     %vehicle.augName = "SelfDestruct";
}

function InitSelfDestructMod(%obj)
{
    if(isObject(%obj))
    {
        if(%obj.getMountNodeObject(%i)) // cant detonate outside of plane.
            %obj.setDamageState(Destroyed);
    }
}

