

//--------------------------------------------------------------------------
//
// Gattling Laser barrel pack
//
//--------------------------------------------------------------------------
$WeaponModeCount[BarrelSwapper] = 9;
$WeaponMode[BarrelSwapper, 0] = "AA";
$WeaponMode[BarrelSwapper, 1] = "ELF";
$WeaponMode[BarrelSwapper, 2] = "Missile";
$WeaponMode[BarrelSwapper, 3] = "Mortar";
$WeaponMode[BarrelSwapper, 4] = "Plasma";
$WeaponMode[BarrelSwapper, 5] = "Disc";
$WeaponMode[BarrelSwapper, 6] = "Energy";
$WeaponMode[BarrelSwapper, 7] = "Laser"; //chaingun...replaces the chaingun
$WeaponMode[BarrelSwapper, 8] = "Flame(RAXX)";
//$WeaponMode[BarrelSwapper, 8] = "Phaser";
$WeaponMode[BarrelSwapper, 9] = "Mitzi";
$WeaponModeName[BarrelSwapper] = "Barrel Swapper";
$WeaponModeSound[BarrelSwapper] = "";
$WeaponModeDescription[BarrelSwapper, 0] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 1] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 2] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 3] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 4] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 5] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 6] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 7] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 8] = "Can be mounted on any turret base or on the Wolfhound.";
$WeaponModeDescription[BarrelSwapper, 9] = "Can be mounted on any turret base or on the Wolfhound.";

function convertToUsableItemB(%int)
{
   switch(%int)
   {
      case 0:
         return "AABarrelLarge";
      case 1:
         return "ELFBarrelLarge";
      case 2:
         return "MissileBarrelLarge";
      case 3:
         return "MortarBarrelLarge";
      case 4:
         return "PlasmaBarrelLarge";
      case 5:
         return "DiscBarrelLarge";
      case 6:
         return "EnergyBarrelLarge";
      case 7:
         return "GatLaserBarrelLarge"; //ChaingunBarrelLarge here, change this
      case 8:
         return "FlameBarrelLarge"; //Death~Bot
      //case 8:
         //return "PhaserBarrelLarge";
      case 9:
         return "MitziBarrelLarge";
      default:
         return "PlasmaBarrelLarge";
   }
}

datablock SniperProjectileData(GatBeam)
{
  directDamage    = 0.017; // the high the setenergypct is the more damage it does.
  hasDamageRadius   = false;
  indirectDamage   = 0.0;
  damageRadius    = 0.0;
  velInheritFactor  = 1.0;
  sound          = SniperRifleProjectileSound;
  explosion      = "SniperExplosion";
  directDamageType  = $DamageType::Gat;

  maxRifleRange    = 500; // may need to bring this down more,500meter turret?! 0_0
  rifleHeadMultiplier = 0.0; // nooo..bad
  beamColor      = "0.0 0.0 1.0"; //BLUE beam
  fadeTime      = 0.4; //fades fast cause its gattling yanno =]

 startBeamWidth     = 0.3;
  endBeamWidth      = 0.3;
  pulseBeamWidth    = 0.7;
  beamFlareAngle    = 3.0;
  minFlareSize    = 0.0;
  maxFlareSize    = 400.0;
  pulseSpeed     = -0.2;
  pulseLength     = 0.03;

  lightRadius     = 1.0;
  lightColor     = "0.0 0.0 1.0";  // blue damnnit :P
  textureName[0]   = "special/flare";
  textureName[1]   = "special/nonlingradient";
  textureName[2]   = "special/laserrip01";
  textureName[3]   = "special/laserrip02";
  textureName[4]   = "special/laserrip03";
  textureName[5]   = "special/laserrip04";
  textureName[6]   = "special/laserrip05";
  textureName[7]   = "special/laserrip06";
  textureName[8]   = "special/laserrip07";
  textureName[9]   = "special/laserrip08";
  textureName[10]   = "special/laserrip09";
  textureName[11]   = "special/shocklance_effect02"; //blue blue! :D
};

datablock TurretImageData(GatLaserBarrelLarge)
{
   shapeFile = "TR2weapon_chaingun.dts";
   item      = GatLaserBarrelPack;

   projectile = GatBeam;
   projectileType = SniperProjectile;
   usesEnergy = true;
   fireEnergy = 1;
   minEnergy = 10;
   emap = true;

   // Turret parameters
   activationMS         = 250;
   deactivateDelayMS    = 500;
   thinkTimeMS          = 200;
   degPerSecTheta       = 600;
   degPerSecPhi         = 1080;
   attackRadius         = 300;

   projectileSpread = 5.0 / 900.0;

   // State transitions
   stateName[0]                     = "Activate";
   stateSpinThread[0] = Stop;
   stateTransitionOnNotLoaded[0]    = "Dead";
   stateTransitionOnLoaded[0]       = "ActivateReady";

   stateName[1]                     = "ActivateReady";
   stateSequence[1]                 = "Activate";
   stateSpinThread[1] = SpinUp;
   stateSound[1]                    = AASwitchSound;
   stateTimeoutValue[1]             = 1.0;
   stateTransitionOnTimeout[1]      = "Ready";
   stateTransitionOnNotLoaded[1]    = "Deactivate";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";
   stateScript[1]                   = "AAActivateReady";

   stateName[2]                     = "Ready";
   stateSpinThread[2]   = FullSpeed;
   stateTransitionOnNotLoaded[2]    = "Deactivate";
   stateTransitionOnTriggerDown[2]  = "Fire1";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateScript[2]                   = "AAReady";

   stateName[3]                     = "Fire1";
   stateSpinThread[3]       = FullSpeed;
   stateTransitionOnTimeout[3]      = "Reload1";
   stateTimeoutValue[3]             = 0.1;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire_vis";
   stateSound[3]                    = SniperRifleFireSound;
   stateScript[3]                   = "onFire";

   stateName[4]                     = "Reload1";
   stateSpinThread[4]       = FullSpeed;
   stateTimeoutValue[4]             = 0.05;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateTransitionOnTimeout[4]      = "Fire2";
   stateTransitionOnNotLoaded[4]    = "Deactivate";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";

   stateName[5]                     = "Fire2";
   stateSpinThread[5]       = FullSpeed;
   stateTransitionOnTimeout[5]      = "Reload2";
   stateTimeoutValue[5]             = 0.1;
   stateFire[5]                     = true;
   stateRecoil[5]                   = LightRecoil;
   stateAllowImageChange[5]         = false;
   stateSequence[5]                 = "Fire_vis";
   stateSound[5]                    = SniperRifleFireSound;
   stateScript[5]                   = "onFire";

   stateName[6]                     = "Reload2";
   stateSpinThread[6]       = FullSpeed;
   stateTimeoutValue[6]             = 0.05;
   stateAllowImageChange[6]         = false;
   stateSequence[6]                 = "Reload";
   stateTransitionOnTimeout[6]      = "Ready";
   stateTransitionOnNotLoaded[6]    = "Deactivate";
   stateTransitionOnNoAmmo[6]       = "NoAmmo";

   stateName[7]                     = "Deactivate";
   stateSpinThread[7] = SpinDown;
   stateSequence[7]                 = "Activate";
   stateDirection[7]                = false;
   stateTimeoutValue[7]             = 1.0;
   stateTransitionOnLoaded[7]       = "ActivateReady";
   stateTransitionOnTimeout[7]      = "Dead";

   stateName[8]                    = "Dead";
   stateSpinThread[8] = Stop;
   stateTransitionOnLoaded[8]      = "ActivateReady";

   stateName[9]                    = "NoAmmo";
   stateSpinThread[9] = Stop;
   stateTransitionOnAmmo[9]        = "Reload2";
   stateSequence[9]                = "NoAmmo";
};

datablock ShapeBaseImageData(GatLaserBarrelPackImage)
{
   mass = 15;

   shapeFile  = "pack_barrel_aa.dts";
   item       = GatLaserBarrelPack;
   mountPoint = 1;
   offset     = "0 0 0";
	turretBarrel = "GatLaserBarrelLarge";

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";

	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateTransitionOnTriggerUp[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeOut[2] = "Idle";

	isLarge = true;
};

datablock ItemData(GatLaserBarrelPack)
{
   className    = Pack;
   catagory     = "Packs";
   shapeFile    = "pack_barrel_mortar.dts";
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
   rotate       = true;
   image        = "GatLaserBarrelPackImage";
	pickUpName = "a Gattling Laser barrel pack";
};

function GatLaserBarrelPack::onActivate(%data, %obj, %slot)
{
	checkTurretMount(%data, %obj, %slot);
}

//function GatLaserBarrelPack::onFire(%data,%obj,%slot)
//{
//   if(%obj.getEnergyLevel() > %data.fireEnergy)
//   {
//      %vector = calcSpreadVector(%obj.getMuzzleVector(%slot), 7);
//
//      %p = new (%data.projectileType)() {
//         dataBlock        = "BasicSniperShot";
//         initialDirection = %vector;
//         initialPosition  = %obj.getMuzzlePoint(%slot);
//         sourceObject     = %obj;
//         sourceSlot       = %slot;
//      };
//      %p.setEnergyPercentage(100);
//
//      MissionCleanup.add(%p);
//      %obj.useEnergy(%data.fireEnergy);
//   }
//}

function GatLaserBarrelLarge::onFire(%data,%obj,%slot)
{

   %vector = calcSpreadVector(%obj.getMuzzleVector(%slot), 6);
   //%vector = %obj.getMuzzleVector(%slot);
   %x = (getRandom() - 0.5) * 2 * 3.1415926 * %data.projectileSpread;
   %y = (getRandom() - 0.5) * 2 * 3.1415926 * %data.projectileSpread;
   %z = (getRandom() - 0.5) * 2 * 3.1415926 * %data.projectileSpread;
   %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
   //%vector = MatrixMulVector(%mat, %vector);

  %p = new (SniperProjectile)() {
   dataBlock    = GatBeam; //%projectile;
   initialDirection = %vector;
   initialPosition = %obj.getMuzzlePoint(%slot);
   sourceObject   = %obj;
   damageFactor   = %pct * %pct;
   sourceSlot    = %slot;
  };
  %pct = 0.75; //the higher the more damage and brighter it is
  %p.setEnergyPercentage(%pct);

  MissionCleanup.add(%p);

 %obj.useEnergy(%data.fireEnergy);
}

function GatLaserBarrelPackImage::onDeactivate(%data, %obj, %slot)
{
	%obj.setImageTrigger($BackpackSlot, false);
}

function GatLaserBarrelPack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}
